/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "core/cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "daemonize.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLOCKLIST
	#define IF_DST_BLOCKLIST(x) x
#else
	#define IF_DST_BLOCKLIST(x) warn("dst blocklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer then using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;
static struct rval_expr* rve_tmp = NULL;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 239 "core/cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_FORWARD = 3,                    /* FORWARD  */
  YYSYMBOL_FORWARD_TCP = 4,                /* FORWARD_TCP  */
  YYSYMBOL_FORWARD_TLS = 5,                /* FORWARD_TLS  */
  YYSYMBOL_FORWARD_SCTP = 6,               /* FORWARD_SCTP  */
  YYSYMBOL_FORWARD_UDP = 7,                /* FORWARD_UDP  */
  YYSYMBOL_EXIT = 8,                       /* EXIT  */
  YYSYMBOL_DROP = 9,                       /* DROP  */
  YYSYMBOL_RETURN = 10,                    /* RETURN  */
  YYSYMBOL_BREAK = 11,                     /* BREAK  */
  YYSYMBOL_LOG_TOK = 12,                   /* LOG_TOK  */
  YYSYMBOL_ERROR = 13,                     /* ERROR  */
  YYSYMBOL_ROUTE = 14,                     /* ROUTE  */
  YYSYMBOL_ROUTE_REQUEST = 15,             /* ROUTE_REQUEST  */
  YYSYMBOL_ROUTE_FAILURE = 16,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 17,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_REPLY = 18,               /* ROUTE_REPLY  */
  YYSYMBOL_ROUTE_BRANCH = 19,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_SEND = 20,                /* ROUTE_SEND  */
  YYSYMBOL_ROUTE_EVENT = 21,               /* ROUTE_EVENT  */
  YYSYMBOL_EXEC = 22,                      /* EXEC  */
  YYSYMBOL_SET_HOST = 23,                  /* SET_HOST  */
  YYSYMBOL_SET_HOSTPORT = 24,              /* SET_HOSTPORT  */
  YYSYMBOL_SET_HOSTPORTTRANS = 25,         /* SET_HOSTPORTTRANS  */
  YYSYMBOL_PREFIX = 26,                    /* PREFIX  */
  YYSYMBOL_STRIP = 27,                     /* STRIP  */
  YYSYMBOL_STRIP_TAIL = 28,                /* STRIP_TAIL  */
  YYSYMBOL_SET_USERPHONE = 29,             /* SET_USERPHONE  */
  YYSYMBOL_APPEND_BRANCH = 30,             /* APPEND_BRANCH  */
  YYSYMBOL_REMOVE_BRANCH = 31,             /* REMOVE_BRANCH  */
  YYSYMBOL_CLEAR_BRANCHES = 32,            /* CLEAR_BRANCHES  */
  YYSYMBOL_SET_USER = 33,                  /* SET_USER  */
  YYSYMBOL_SET_USERPASS = 34,              /* SET_USERPASS  */
  YYSYMBOL_SET_PORT = 35,                  /* SET_PORT  */
  YYSYMBOL_SET_URI = 36,                   /* SET_URI  */
  YYSYMBOL_REVERT_URI = 37,                /* REVERT_URI  */
  YYSYMBOL_FORCE_RPORT = 38,               /* FORCE_RPORT  */
  YYSYMBOL_ADD_LOCAL_RPORT = 39,           /* ADD_LOCAL_RPORT  */
  YYSYMBOL_LOCAL_RPORT = 40,               /* LOCAL_RPORT  */
  YYSYMBOL_FORCE_TCP_ALIAS = 41,           /* FORCE_TCP_ALIAS  */
  YYSYMBOL_UDP_MTU = 42,                   /* UDP_MTU  */
  YYSYMBOL_UDP_MTU_TRY_PROTO = 43,         /* UDP_MTU_TRY_PROTO  */
  YYSYMBOL_UDP4_RAW = 44,                  /* UDP4_RAW  */
  YYSYMBOL_UDP4_RAW_MTU = 45,              /* UDP4_RAW_MTU  */
  YYSYMBOL_UDP4_RAW_TTL = 46,              /* UDP4_RAW_TTL  */
  YYSYMBOL_IF = 47,                        /* IF  */
  YYSYMBOL_ELSE = 48,                      /* ELSE  */
  YYSYMBOL_SET_ADV_ADDRESS = 49,           /* SET_ADV_ADDRESS  */
  YYSYMBOL_SET_ADV_PORT = 50,              /* SET_ADV_PORT  */
  YYSYMBOL_FORCE_SEND_SOCKET = 51,         /* FORCE_SEND_SOCKET  */
  YYSYMBOL_SET_FWD_NO_CONNECT = 52,        /* SET_FWD_NO_CONNECT  */
  YYSYMBOL_SET_RPL_NO_CONNECT = 53,        /* SET_RPL_NO_CONNECT  */
  YYSYMBOL_SET_FWD_CLOSE = 54,             /* SET_FWD_CLOSE  */
  YYSYMBOL_SET_RPL_CLOSE = 55,             /* SET_RPL_CLOSE  */
  YYSYMBOL_SWITCH = 56,                    /* SWITCH  */
  YYSYMBOL_CASE = 57,                      /* CASE  */
  YYSYMBOL_DEFAULT = 58,                   /* DEFAULT  */
  YYSYMBOL_WHILE = 59,                     /* WHILE  */
  YYSYMBOL_CFG_SELECT = 60,                /* CFG_SELECT  */
  YYSYMBOL_CFG_RESET = 61,                 /* CFG_RESET  */
  YYSYMBOL_URIHOST = 62,                   /* URIHOST  */
  YYSYMBOL_URIPORT = 63,                   /* URIPORT  */
  YYSYMBOL_MAX_LEN = 64,                   /* MAX_LEN  */
  YYSYMBOL_SETFLAG = 65,                   /* SETFLAG  */
  YYSYMBOL_RESETFLAG = 66,                 /* RESETFLAG  */
  YYSYMBOL_ISFLAGSET = 67,                 /* ISFLAGSET  */
  YYSYMBOL_SETAVPFLAG = 68,                /* SETAVPFLAG  */
  YYSYMBOL_RESETAVPFLAG = 69,              /* RESETAVPFLAG  */
  YYSYMBOL_ISAVPFLAGSET = 70,              /* ISAVPFLAGSET  */
  YYSYMBOL_METHOD = 71,                    /* METHOD  */
  YYSYMBOL_URI = 72,                       /* URI  */
  YYSYMBOL_FROM_URI = 73,                  /* FROM_URI  */
  YYSYMBOL_TO_URI = 74,                    /* TO_URI  */
  YYSYMBOL_SRCIP = 75,                     /* SRCIP  */
  YYSYMBOL_SRCPORT = 76,                   /* SRCPORT  */
  YYSYMBOL_DSTIP = 77,                     /* DSTIP  */
  YYSYMBOL_DSTPORT = 78,                   /* DSTPORT  */
  YYSYMBOL_TOIP = 79,                      /* TOIP  */
  YYSYMBOL_TOPORT = 80,                    /* TOPORT  */
  YYSYMBOL_SNDIP = 81,                     /* SNDIP  */
  YYSYMBOL_SNDPORT = 82,                   /* SNDPORT  */
  YYSYMBOL_SNDPROTO = 83,                  /* SNDPROTO  */
  YYSYMBOL_SNDAF = 84,                     /* SNDAF  */
  YYSYMBOL_PROTO = 85,                     /* PROTO  */
  YYSYMBOL_AF = 86,                        /* AF  */
  YYSYMBOL_MYSELF = 87,                    /* MYSELF  */
  YYSYMBOL_MSGLEN = 88,                    /* MSGLEN  */
  YYSYMBOL_UDP = 89,                       /* UDP  */
  YYSYMBOL_TCP = 90,                       /* TCP  */
  YYSYMBOL_TLS = 91,                       /* TLS  */
  YYSYMBOL_SCTP = 92,                      /* SCTP  */
  YYSYMBOL_WS = 93,                        /* WS  */
  YYSYMBOL_WSS = 94,                       /* WSS  */
  YYSYMBOL_DEBUG_V = 95,                   /* DEBUG_V  */
  YYSYMBOL_FORK = 96,                      /* FORK  */
  YYSYMBOL_FORK_DELAY = 97,                /* FORK_DELAY  */
  YYSYMBOL_MODINIT_DELAY = 98,             /* MODINIT_DELAY  */
  YYSYMBOL_LOGSTDERROR = 99,               /* LOGSTDERROR  */
  YYSYMBOL_LOGFACILITY = 100,              /* LOGFACILITY  */
  YYSYMBOL_LOGNAME = 101,                  /* LOGNAME  */
  YYSYMBOL_LOGCOLOR = 102,                 /* LOGCOLOR  */
  YYSYMBOL_LOGPREFIX = 103,                /* LOGPREFIX  */
  YYSYMBOL_LOGPREFIXMODE = 104,            /* LOGPREFIXMODE  */
  YYSYMBOL_LOGENGINETYPE = 105,            /* LOGENGINETYPE  */
  YYSYMBOL_LOGENGINEDATA = 106,            /* LOGENGINEDATA  */
  YYSYMBOL_XAVPVIAPARAMS = 107,            /* XAVPVIAPARAMS  */
  YYSYMBOL_XAVPVIAFIELDS = 108,            /* XAVPVIAFIELDS  */
  YYSYMBOL_LISTEN = 109,                   /* LISTEN  */
  YYSYMBOL_ADVERTISE = 110,                /* ADVERTISE  */
  YYSYMBOL_VIRTUAL = 111,                  /* VIRTUAL  */
  YYSYMBOL_STRNAME = 112,                  /* STRNAME  */
  YYSYMBOL_ALIAS = 113,                    /* ALIAS  */
  YYSYMBOL_SR_AUTO_ALIASES = 114,          /* SR_AUTO_ALIASES  */
  YYSYMBOL_DNS = 115,                      /* DNS  */
  YYSYMBOL_REV_DNS = 116,                  /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 117,             /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 118,            /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_SRV_LB = 119,               /* DNS_SRV_LB  */
  YYSYMBOL_DNS_UDP_PREF = 120,             /* DNS_UDP_PREF  */
  YYSYMBOL_DNS_TCP_PREF = 121,             /* DNS_TCP_PREF  */
  YYSYMBOL_DNS_TLS_PREF = 122,             /* DNS_TLS_PREF  */
  YYSYMBOL_DNS_SCTP_PREF = 123,            /* DNS_SCTP_PREF  */
  YYSYMBOL_DNS_RETR_TIME = 124,            /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_SLOW_QUERY_MS = 125,        /* DNS_SLOW_QUERY_MS  */
  YYSYMBOL_DNS_RETR_NO = 126,              /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 127,           /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 128,           /* DNS_USE_SEARCH  */
  YYSYMBOL_DNS_SEARCH_FMATCH = 129,        /* DNS_SEARCH_FMATCH  */
  YYSYMBOL_DNS_NAPTR_IGNORE_RFC = 130,     /* DNS_NAPTR_IGNORE_RFC  */
  YYSYMBOL_DNS_CACHE_INIT = 131,           /* DNS_CACHE_INIT  */
  YYSYMBOL_DNS_USE_CACHE = 132,            /* DNS_USE_CACHE  */
  YYSYMBOL_DNS_USE_FAILOVER = 133,         /* DNS_USE_FAILOVER  */
  YYSYMBOL_DNS_CACHE_FLAGS = 134,          /* DNS_CACHE_FLAGS  */
  YYSYMBOL_DNS_CACHE_NEG_TTL = 135,        /* DNS_CACHE_NEG_TTL  */
  YYSYMBOL_DNS_CACHE_MIN_TTL = 136,        /* DNS_CACHE_MIN_TTL  */
  YYSYMBOL_DNS_CACHE_MAX_TTL = 137,        /* DNS_CACHE_MAX_TTL  */
  YYSYMBOL_DNS_CACHE_MEM = 138,            /* DNS_CACHE_MEM  */
  YYSYMBOL_DNS_CACHE_GC_INT = 139,         /* DNS_CACHE_GC_INT  */
  YYSYMBOL_DNS_CACHE_DEL_NONEXP = 140,     /* DNS_CACHE_DEL_NONEXP  */
  YYSYMBOL_DNS_CACHE_REC_PREF = 141,       /* DNS_CACHE_REC_PREF  */
  YYSYMBOL_AUTO_BIND_IPV6 = 142,           /* AUTO_BIND_IPV6  */
  YYSYMBOL_BIND_IPV6_LINK_LOCAL = 143,     /* BIND_IPV6_LINK_LOCAL  */
  YYSYMBOL_IPV6_HEX_STYLE = 144,           /* IPV6_HEX_STYLE  */
  YYSYMBOL_DST_BLST_INIT = 145,            /* DST_BLST_INIT  */
  YYSYMBOL_USE_DST_BLST = 146,             /* USE_DST_BLST  */
  YYSYMBOL_DST_BLST_MEM = 147,             /* DST_BLST_MEM  */
  YYSYMBOL_DST_BLST_TTL = 148,             /* DST_BLST_TTL  */
  YYSYMBOL_DST_BLST_GC_INT = 149,          /* DST_BLST_GC_INT  */
  YYSYMBOL_DST_BLST_UDP_IMASK = 150,       /* DST_BLST_UDP_IMASK  */
  YYSYMBOL_DST_BLST_TCP_IMASK = 151,       /* DST_BLST_TCP_IMASK  */
  YYSYMBOL_DST_BLST_TLS_IMASK = 152,       /* DST_BLST_TLS_IMASK  */
  YYSYMBOL_DST_BLST_SCTP_IMASK = 153,      /* DST_BLST_SCTP_IMASK  */
  YYSYMBOL_IP_FREE_BIND = 154,             /* IP_FREE_BIND  */
  YYSYMBOL_PORT = 155,                     /* PORT  */
  YYSYMBOL_STAT = 156,                     /* STAT  */
  YYSYMBOL_STATS_NAMESEP = 157,            /* STATS_NAMESEP  */
  YYSYMBOL_CHILDREN = 158,                 /* CHILDREN  */
  YYSYMBOL_SOCKET_WORKERS = 159,           /* SOCKET_WORKERS  */
  YYSYMBOL_ASYNC_WORKERS = 160,            /* ASYNC_WORKERS  */
  YYSYMBOL_ASYNC_USLEEP = 161,             /* ASYNC_USLEEP  */
  YYSYMBOL_ASYNC_NONBLOCK = 162,           /* ASYNC_NONBLOCK  */
  YYSYMBOL_ASYNC_WORKERS_GROUP = 163,      /* ASYNC_WORKERS_GROUP  */
  YYSYMBOL_CHECK_VIA = 164,                /* CHECK_VIA  */
  YYSYMBOL_PHONE2TEL = 165,                /* PHONE2TEL  */
  YYSYMBOL_MEMLOG = 166,                   /* MEMLOG  */
  YYSYMBOL_MEMDBG = 167,                   /* MEMDBG  */
  YYSYMBOL_MEMSUM = 168,                   /* MEMSUM  */
  YYSYMBOL_MEMSAFETY = 169,                /* MEMSAFETY  */
  YYSYMBOL_MEMJOIN = 170,                  /* MEMJOIN  */
  YYSYMBOL_MEMSTATUSMODE = 171,            /* MEMSTATUSMODE  */
  YYSYMBOL_SIP_PARSER_LOG_ONELINE = 172,   /* SIP_PARSER_LOG_ONELINE  */
  YYSYMBOL_SIP_PARSER_LOG = 173,           /* SIP_PARSER_LOG  */
  YYSYMBOL_SIP_PARSER_MODE = 174,          /* SIP_PARSER_MODE  */
  YYSYMBOL_CORELOG = 175,                  /* CORELOG  */
  YYSYMBOL_SIP_WARNING = 176,              /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 177,         /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 178,            /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 179,        /* USER_AGENT_HEADER  */
  YYSYMBOL_REPLY_TO_VIA = 180,             /* REPLY_TO_VIA  */
  YYSYMBOL_LOADMODULE = 181,               /* LOADMODULE  */
  YYSYMBOL_LOADMODULEX = 182,              /* LOADMODULEX  */
  YYSYMBOL_LOADPATH = 183,                 /* LOADPATH  */
  YYSYMBOL_MODPARAM = 184,                 /* MODPARAM  */
  YYSYMBOL_MODPARAMX = 185,                /* MODPARAMX  */
  YYSYMBOL_CFGENGINE = 186,                /* CFGENGINE  */
  YYSYMBOL_MAXBUFFER = 187,                /* MAXBUFFER  */
  YYSYMBOL_SQL_BUFFER_SIZE = 188,          /* SQL_BUFFER_SIZE  */
  YYSYMBOL_USER = 189,                     /* USER  */
  YYSYMBOL_GROUP = 190,                    /* GROUP  */
  YYSYMBOL_CHROOT = 191,                   /* CHROOT  */
  YYSYMBOL_WDIR = 192,                     /* WDIR  */
  YYSYMBOL_RUNDIR = 193,                   /* RUNDIR  */
  YYSYMBOL_MHOMED = 194,                   /* MHOMED  */
  YYSYMBOL_DISABLE_TCP = 195,              /* DISABLE_TCP  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 196,       /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_ACCEPT_UNIQUE = 197,        /* TCP_ACCEPT_UNIQUE  */
  YYSYMBOL_TCP_CONNECTION_MATCH = 198,     /* TCP_CONNECTION_MATCH  */
  YYSYMBOL_TCP_CHILDREN = 199,             /* TCP_CHILDREN  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 200,      /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_SEND_TIMEOUT = 201,         /* TCP_SEND_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 202,         /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_POLL_METHOD = 203,          /* TCP_POLL_METHOD  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 204,      /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TLS_MAX_CONNECTIONS = 205,      /* TLS_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_CONNECT = 206,           /* TCP_NO_CONNECT  */
  YYSYMBOL_TCP_SOURCE_IPV4 = 207,          /* TCP_SOURCE_IPV4  */
  YYSYMBOL_TCP_SOURCE_IPV6 = 208,          /* TCP_SOURCE_IPV6  */
  YYSYMBOL_TCP_OPT_FD_CACHE = 209,         /* TCP_OPT_FD_CACHE  */
  YYSYMBOL_TCP_OPT_BUF_WRITE = 210,        /* TCP_OPT_BUF_WRITE  */
  YYSYMBOL_TCP_OPT_CONN_WQ_MAX = 211,      /* TCP_OPT_CONN_WQ_MAX  */
  YYSYMBOL_TCP_OPT_WQ_MAX = 212,           /* TCP_OPT_WQ_MAX  */
  YYSYMBOL_TCP_OPT_RD_BUF = 213,           /* TCP_OPT_RD_BUF  */
  YYSYMBOL_TCP_OPT_WQ_BLK = 214,           /* TCP_OPT_WQ_BLK  */
  YYSYMBOL_TCP_OPT_DEFER_ACCEPT = 215,     /* TCP_OPT_DEFER_ACCEPT  */
  YYSYMBOL_TCP_OPT_DELAYED_ACK = 216,      /* TCP_OPT_DELAYED_ACK  */
  YYSYMBOL_TCP_OPT_SYNCNT = 217,           /* TCP_OPT_SYNCNT  */
  YYSYMBOL_TCP_OPT_LINGER2 = 218,          /* TCP_OPT_LINGER2  */
  YYSYMBOL_TCP_OPT_KEEPALIVE = 219,        /* TCP_OPT_KEEPALIVE  */
  YYSYMBOL_TCP_OPT_KEEPIDLE = 220,         /* TCP_OPT_KEEPIDLE  */
  YYSYMBOL_TCP_OPT_KEEPINTVL = 221,        /* TCP_OPT_KEEPINTVL  */
  YYSYMBOL_TCP_OPT_KEEPCNT = 222,          /* TCP_OPT_KEEPCNT  */
  YYSYMBOL_TCP_OPT_CRLF_PING = 223,        /* TCP_OPT_CRLF_PING  */
  YYSYMBOL_TCP_OPT_ACCEPT_NO_CL = 224,     /* TCP_OPT_ACCEPT_NO_CL  */
  YYSYMBOL_TCP_OPT_ACCEPT_HEP3 = 225,      /* TCP_OPT_ACCEPT_HEP3  */
  YYSYMBOL_TCP_OPT_ACCEPT_HAPROXY = 226,   /* TCP_OPT_ACCEPT_HAPROXY  */
  YYSYMBOL_TCP_CLONE_RCVBUF = 227,         /* TCP_CLONE_RCVBUF  */
  YYSYMBOL_TCP_REUSE_PORT = 228,           /* TCP_REUSE_PORT  */
  YYSYMBOL_TCP_WAIT_DATA = 229,            /* TCP_WAIT_DATA  */
  YYSYMBOL_TCP_SCRIPT_MODE = 230,          /* TCP_SCRIPT_MODE  */
  YYSYMBOL_DISABLE_TLS = 231,              /* DISABLE_TLS  */
  YYSYMBOL_ENABLE_TLS = 232,               /* ENABLE_TLS  */
  YYSYMBOL_TLSLOG = 233,                   /* TLSLOG  */
  YYSYMBOL_TLS_PORT_NO = 234,              /* TLS_PORT_NO  */
  YYSYMBOL_TLS_METHOD = 235,               /* TLS_METHOD  */
  YYSYMBOL_TLS_HANDSHAKE_TIMEOUT = 236,    /* TLS_HANDSHAKE_TIMEOUT  */
  YYSYMBOL_TLS_SEND_TIMEOUT = 237,         /* TLS_SEND_TIMEOUT  */
  YYSYMBOL_SSLv23 = 238,                   /* SSLv23  */
  YYSYMBOL_SSLv2 = 239,                    /* SSLv2  */
  YYSYMBOL_SSLv3 = 240,                    /* SSLv3  */
  YYSYMBOL_TLSv1 = 241,                    /* TLSv1  */
  YYSYMBOL_TLS_VERIFY = 242,               /* TLS_VERIFY  */
  YYSYMBOL_TLS_REQUIRE_CERTIFICATE = 243,  /* TLS_REQUIRE_CERTIFICATE  */
  YYSYMBOL_TLS_CERTIFICATE = 244,          /* TLS_CERTIFICATE  */
  YYSYMBOL_TLS_PRIVATE_KEY = 245,          /* TLS_PRIVATE_KEY  */
  YYSYMBOL_TLS_CA_LIST = 246,              /* TLS_CA_LIST  */
  YYSYMBOL_DISABLE_SCTP = 247,             /* DISABLE_SCTP  */
  YYSYMBOL_ENABLE_SCTP = 248,              /* ENABLE_SCTP  */
  YYSYMBOL_SCTP_CHILDREN = 249,            /* SCTP_CHILDREN  */
  YYSYMBOL_ADVERTISED_ADDRESS = 250,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 251,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 252,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 253,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_SHM_MEM_SZ = 254,               /* SHM_MEM_SZ  */
  YYSYMBOL_SHM_FORCE_ALLOC = 255,          /* SHM_FORCE_ALLOC  */
  YYSYMBOL_MLOCK_PAGES = 256,              /* MLOCK_PAGES  */
  YYSYMBOL_REAL_TIME = 257,                /* REAL_TIME  */
  YYSYMBOL_RT_PRIO = 258,                  /* RT_PRIO  */
  YYSYMBOL_RT_POLICY = 259,                /* RT_POLICY  */
  YYSYMBOL_RT_TIMER1_PRIO = 260,           /* RT_TIMER1_PRIO  */
  YYSYMBOL_RT_TIMER1_POLICY = 261,         /* RT_TIMER1_POLICY  */
  YYSYMBOL_RT_TIMER2_PRIO = 262,           /* RT_TIMER2_PRIO  */
  YYSYMBOL_RT_TIMER2_POLICY = 263,         /* RT_TIMER2_POLICY  */
  YYSYMBOL_MCAST_LOOPBACK = 264,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 265,                /* MCAST_TTL  */
  YYSYMBOL_MCAST = 266,                    /* MCAST  */
  YYSYMBOL_TOS = 267,                      /* TOS  */
  YYSYMBOL_PMTU_DISCOVERY = 268,           /* PMTU_DISCOVERY  */
  YYSYMBOL_KILL_TIMEOUT = 269,             /* KILL_TIMEOUT  */
  YYSYMBOL_MAX_WLOOPS = 270,               /* MAX_WLOOPS  */
  YYSYMBOL_PVBUFSIZE = 271,                /* PVBUFSIZE  */
  YYSYMBOL_PVBUFSLOTS = 272,               /* PVBUFSLOTS  */
  YYSYMBOL_PVCACHELIMIT = 273,             /* PVCACHELIMIT  */
  YYSYMBOL_PVCACHEACTION = 274,            /* PVCACHEACTION  */
  YYSYMBOL_HTTP_REPLY_PARSE = 275,         /* HTTP_REPLY_PARSE  */
  YYSYMBOL_VERSION_TABLE_CFG = 276,        /* VERSION_TABLE_CFG  */
  YYSYMBOL_VERBOSE_STARTUP = 277,          /* VERBOSE_STARTUP  */
  YYSYMBOL_ROUTE_LOCKS_SIZE = 278,         /* ROUTE_LOCKS_SIZE  */
  YYSYMBOL_WAIT_WORKER1_MODE = 279,        /* WAIT_WORKER1_MODE  */
  YYSYMBOL_WAIT_WORKER1_TIME = 280,        /* WAIT_WORKER1_TIME  */
  YYSYMBOL_WAIT_WORKER1_USLEEP = 281,      /* WAIT_WORKER1_USLEEP  */
  YYSYMBOL_CFG_DESCRIPTION = 282,          /* CFG_DESCRIPTION  */
  YYSYMBOL_SERVER_ID = 283,                /* SERVER_ID  */
  YYSYMBOL_KEMI = 284,                     /* KEMI  */
  YYSYMBOL_ONSEND_ROUTE_CALLBACK = 285,    /* ONSEND_ROUTE_CALLBACK  */
  YYSYMBOL_REPLY_ROUTE_CALLBACK = 286,     /* REPLY_ROUTE_CALLBACK  */
  YYSYMBOL_EVENT_ROUTE_CALLBACK = 287,     /* EVENT_ROUTE_CALLBACK  */
  YYSYMBOL_RECEIVED_ROUTE_CALLBACK = 288,  /* RECEIVED_ROUTE_CALLBACK  */
  YYSYMBOL_RECEIVED_ROUTE_MODE = 289,      /* RECEIVED_ROUTE_MODE  */
  YYSYMBOL_PRE_ROUTING_CALLBACK = 290,     /* PRE_ROUTING_CALLBACK  */
  YYSYMBOL_MAX_RECURSIVE_LEVEL = 291,      /* MAX_RECURSIVE_LEVEL  */
  YYSYMBOL_MAX_BRANCHES_PARAM = 292,       /* MAX_BRANCHES_PARAM  */
  YYSYMBOL_LATENCY_CFG_LOG = 293,          /* LATENCY_CFG_LOG  */
  YYSYMBOL_LATENCY_LOG = 294,              /* LATENCY_LOG  */
  YYSYMBOL_LATENCY_LIMIT_DB = 295,         /* LATENCY_LIMIT_DB  */
  YYSYMBOL_LATENCY_LIMIT_ACTION = 296,     /* LATENCY_LIMIT_ACTION  */
  YYSYMBOL_LATENCY_LIMIT_CFG = 297,        /* LATENCY_LIMIT_CFG  */
  YYSYMBOL_MSG_TIME = 298,                 /* MSG_TIME  */
  YYSYMBOL_ONSEND_RT_REPLY = 299,          /* ONSEND_RT_REPLY  */
  YYSYMBOL_URI_HOST_EXTRA_CHARS = 300,     /* URI_HOST_EXTRA_CHARS  */
  YYSYMBOL_HDR_NAME_EXTRA_CHARS = 301,     /* HDR_NAME_EXTRA_CHARS  */
  YYSYMBOL_FLAGS_DECL = 302,               /* FLAGS_DECL  */
  YYSYMBOL_AVPFLAGS_DECL = 303,            /* AVPFLAGS_DECL  */
  YYSYMBOL_ATTR_MARK = 304,                /* ATTR_MARK  */
  YYSYMBOL_SELECT_MARK = 305,              /* SELECT_MARK  */
  YYSYMBOL_ATTR_FROM = 306,                /* ATTR_FROM  */
  YYSYMBOL_ATTR_TO = 307,                  /* ATTR_TO  */
  YYSYMBOL_ATTR_FROMURI = 308,             /* ATTR_FROMURI  */
  YYSYMBOL_ATTR_TOURI = 309,               /* ATTR_TOURI  */
  YYSYMBOL_ATTR_FROMUSER = 310,            /* ATTR_FROMUSER  */
  YYSYMBOL_ATTR_TOUSER = 311,              /* ATTR_TOUSER  */
  YYSYMBOL_ATTR_FROMDOMAIN = 312,          /* ATTR_FROMDOMAIN  */
  YYSYMBOL_ATTR_TODOMAIN = 313,            /* ATTR_TODOMAIN  */
  YYSYMBOL_ATTR_GLOBAL = 314,              /* ATTR_GLOBAL  */
  YYSYMBOL_ADDEQ = 315,                    /* ADDEQ  */
  YYSYMBOL_SUBST = 316,                    /* SUBST  */
  YYSYMBOL_SUBSTDEF = 317,                 /* SUBSTDEF  */
  YYSYMBOL_SUBSTDEFS = 318,                /* SUBSTDEFS  */
  YYSYMBOL_EQUAL = 319,                    /* EQUAL  */
  YYSYMBOL_LOG_OR = 320,                   /* LOG_OR  */
  YYSYMBOL_LOG_AND = 321,                  /* LOG_AND  */
  YYSYMBOL_BIN_OR = 322,                   /* BIN_OR  */
  YYSYMBOL_BIN_AND = 323,                  /* BIN_AND  */
  YYSYMBOL_BIN_XOR = 324,                  /* BIN_XOR  */
  YYSYMBOL_BIN_LSHIFT = 325,               /* BIN_LSHIFT  */
  YYSYMBOL_BIN_RSHIFT = 326,               /* BIN_RSHIFT  */
  YYSYMBOL_EQUAL_T = 327,                  /* EQUAL_T  */
  YYSYMBOL_DIFF = 328,                     /* DIFF  */
  YYSYMBOL_MATCH = 329,                    /* MATCH  */
  YYSYMBOL_INTEQ = 330,                    /* INTEQ  */
  YYSYMBOL_INTDIFF = 331,                  /* INTDIFF  */
  YYSYMBOL_STREQ = 332,                    /* STREQ  */
  YYSYMBOL_STRDIFF = 333,                  /* STRDIFF  */
  YYSYMBOL_GT = 334,                       /* GT  */
  YYSYMBOL_LT = 335,                       /* LT  */
  YYSYMBOL_GTE = 336,                      /* GTE  */
  YYSYMBOL_LTE = 337,                      /* LTE  */
  YYSYMBOL_PLUS = 338,                     /* PLUS  */
  YYSYMBOL_MINUS = 339,                    /* MINUS  */
  YYSYMBOL_STAR = 340,                     /* STAR  */
  YYSYMBOL_SLASH = 341,                    /* SLASH  */
  YYSYMBOL_MODULO = 342,                   /* MODULO  */
  YYSYMBOL_NOT = 343,                      /* NOT  */
  YYSYMBOL_UNARY = 344,                    /* UNARY  */
  YYSYMBOL_BIN_NOT = 345,                  /* BIN_NOT  */
  YYSYMBOL_DEFINED = 346,                  /* DEFINED  */
  YYSYMBOL_INTCAST = 347,                  /* INTCAST  */
  YYSYMBOL_STRCAST = 348,                  /* STRCAST  */
  YYSYMBOL_DOT = 349,                      /* DOT  */
  YYSYMBOL_STRLEN = 350,                   /* STRLEN  */
  YYSYMBOL_STREMPTY = 351,                 /* STREMPTY  */
  YYSYMBOL_SELVAL = 352,                   /* SELVAL  */
  YYSYMBOL_NUMBER = 353,                   /* NUMBER  */
  YYSYMBOL_ID = 354,                       /* ID  */
  YYSYMBOL_NUM_ID = 355,                   /* NUM_ID  */
  YYSYMBOL_STRING = 356,                   /* STRING  */
  YYSYMBOL_IPV6ADDR = 357,                 /* IPV6ADDR  */
  YYSYMBOL_PVAR = 358,                     /* PVAR  */
  YYSYMBOL_AVP_OR_PVAR = 359,              /* AVP_OR_PVAR  */
  YYSYMBOL_EVENT_RT_NAME = 360,            /* EVENT_RT_NAME  */
  YYSYMBOL_COMMA = 361,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 362,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 363,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 364,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 365,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 366,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 367,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 368,                   /* RBRACK  */
  YYSYMBOL_CR = 369,                       /* CR  */
  YYSYMBOL_COLON = 370,                    /* COLON  */
  YYSYMBOL_YYACCEPT = 371,                 /* $accept  */
  YYSYMBOL_cfg = 372,                      /* cfg  */
  YYSYMBOL_statements = 373,               /* statements  */
  YYSYMBOL_statement = 374,                /* statement  */
  YYSYMBOL_375_1 = 375,                    /* $@1  */
  YYSYMBOL_376_2 = 376,                    /* $@2  */
  YYSYMBOL_377_3 = 377,                    /* $@3  */
  YYSYMBOL_378_4 = 378,                    /* $@4  */
  YYSYMBOL_379_5 = 379,                    /* $@5  */
  YYSYMBOL_listen_id = 380,                /* listen_id  */
  YYSYMBOL_listen_id_lst = 381,            /* listen_id_lst  */
  YYSYMBOL_listen_id2 = 382,               /* listen_id2  */
  YYSYMBOL_proto = 383,                    /* proto  */
  YYSYMBOL_eqproto = 384,                  /* eqproto  */
  YYSYMBOL_port = 385,                     /* port  */
  YYSYMBOL_phostport = 386,                /* phostport  */
  YYSYMBOL_listen_phostport = 387,         /* listen_phostport  */
  YYSYMBOL_id_lst = 388,                   /* id_lst  */
  YYSYMBOL_intno = 389,                    /* intno  */
  YYSYMBOL_flags_decl = 390,               /* flags_decl  */
  YYSYMBOL_flag_list = 391,                /* flag_list  */
  YYSYMBOL_flag_spec = 392,                /* flag_spec  */
  YYSYMBOL_flag_name = 393,                /* flag_name  */
  YYSYMBOL_avpflags_decl = 394,            /* avpflags_decl  */
  YYSYMBOL_avpflag_list = 395,             /* avpflag_list  */
  YYSYMBOL_avpflag_spec = 396,             /* avpflag_spec  */
  YYSYMBOL_assign_stm = 397,               /* assign_stm  */
  YYSYMBOL_cfg_var_id = 398,               /* cfg_var_id  */
  YYSYMBOL_cfg_var_idn = 399,              /* cfg_var_idn  */
  YYSYMBOL_cfg_var = 400,                  /* cfg_var  */
  YYSYMBOL_module_stm = 401,               /* module_stm  */
  YYSYMBOL_ip = 402,                       /* ip  */
  YYSYMBOL_ipv4 = 403,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 404,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 405,                     /* ipv6  */
  YYSYMBOL_route_name = 406,               /* route_name  */
  YYSYMBOL_route_main = 407,               /* route_main  */
  YYSYMBOL_route_stm = 408,                /* route_stm  */
  YYSYMBOL_failure_route_main = 409,       /* failure_route_main  */
  YYSYMBOL_failure_route_stm = 410,        /* failure_route_stm  */
  YYSYMBOL_route_reply_main = 411,         /* route_reply_main  */
  YYSYMBOL_onreply_route_stm = 412,        /* onreply_route_stm  */
  YYSYMBOL_413_6 = 413,                    /* $@6  */
  YYSYMBOL_414_7 = 414,                    /* $@7  */
  YYSYMBOL_branch_route_main = 415,        /* branch_route_main  */
  YYSYMBOL_branch_route_stm = 416,         /* branch_route_stm  */
  YYSYMBOL_send_route_main = 417,          /* send_route_main  */
  YYSYMBOL_send_route_stm = 418,           /* send_route_stm  */
  YYSYMBOL_event_route_main = 419,         /* event_route_main  */
  YYSYMBOL_event_route_stm = 420,          /* event_route_stm  */
  YYSYMBOL_preprocess_stm = 421,           /* preprocess_stm  */
  YYSYMBOL_equalop = 422,                  /* equalop  */
  YYSYMBOL_cmpop = 423,                    /* cmpop  */
  YYSYMBOL_strop = 424,                    /* strop  */
  YYSYMBOL_rve_equalop = 425,              /* rve_equalop  */
  YYSYMBOL_rve_cmpop = 426,                /* rve_cmpop  */
  YYSYMBOL_uri_type = 427,                 /* uri_type  */
  YYSYMBOL_eint_op_onsend = 428,           /* eint_op_onsend  */
  YYSYMBOL_eint_op = 429,                  /* eint_op  */
  YYSYMBOL_eip_op_onsend = 430,            /* eip_op_onsend  */
  YYSYMBOL_eip_op = 431,                   /* eip_op  */
  YYSYMBOL_exp_elem = 432,                 /* exp_elem  */
  YYSYMBOL_ipnet = 433,                    /* ipnet  */
  YYSYMBOL_host = 434,                     /* host  */
  YYSYMBOL_host_if_id = 435,               /* host_if_id  */
  YYSYMBOL_host_or_if = 436,               /* host_or_if  */
  YYSYMBOL_fcmd = 437,                     /* fcmd  */
  YYSYMBOL_stm = 438,                      /* stm  */
  YYSYMBOL_actions = 439,                  /* actions  */
  YYSYMBOL_action = 440,                   /* action  */
  YYSYMBOL_if_cmd = 441,                   /* if_cmd  */
  YYSYMBOL_ct_rval = 442,                  /* ct_rval  */
  YYSYMBOL_single_case = 443,              /* single_case  */
  YYSYMBOL_case_stms = 444,                /* case_stms  */
  YYSYMBOL_switch_cmd = 445,               /* switch_cmd  */
  YYSYMBOL_while_cmd = 446,                /* while_cmd  */
  YYSYMBOL_select_param = 447,             /* select_param  */
  YYSYMBOL_select_params = 448,            /* select_params  */
  YYSYMBOL_select_id = 449,                /* select_id  */
  YYSYMBOL_450_8 = 450,                    /* $@8  */
  YYSYMBOL_attr_class_spec = 451,          /* attr_class_spec  */
  YYSYMBOL_attr_name_spec = 452,           /* attr_name_spec  */
  YYSYMBOL_attr_spec = 453,                /* attr_spec  */
  YYSYMBOL_attr_mark = 454,                /* attr_mark  */
  YYSYMBOL_attr_id = 455,                  /* attr_id  */
  YYSYMBOL_attr_id_num_idx = 456,          /* attr_id_num_idx  */
  YYSYMBOL_attr_id_no_idx = 457,           /* attr_id_no_idx  */
  YYSYMBOL_attr_id_ass = 458,              /* attr_id_ass  */
  YYSYMBOL_attr_id_any = 459,              /* attr_id_any  */
  YYSYMBOL_attr_id_any_str = 460,          /* attr_id_any_str  */
  YYSYMBOL_pvar = 461,                     /* pvar  */
  YYSYMBOL_avp_pvar = 462,                 /* avp_pvar  */
  YYSYMBOL_assign_op = 463,                /* assign_op  */
  YYSYMBOL_lval = 464,                     /* lval  */
  YYSYMBOL_rval = 465,                     /* rval  */
  YYSYMBOL_rve_un_op = 466,                /* rve_un_op  */
  YYSYMBOL_rval_expr = 467,                /* rval_expr  */
  YYSYMBOL_assign_action = 468,            /* assign_action  */
  YYSYMBOL_avpflag_oper = 469,             /* avpflag_oper  */
  YYSYMBOL_cmd = 470,                      /* cmd  */
  YYSYMBOL_471_9 = 471,                    /* $@9  */
  YYSYMBOL_func_params = 472,              /* func_params  */
  YYSYMBOL_func_param = 473,               /* func_param  */
  YYSYMBOL_ret_cmd = 474                   /* ret_cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  500
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12569

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  371
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  104
/* YYNRULES -- Number of rules.  */
#define YYNRULES  952
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1787

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   625


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   648,   648,   651,   652,   653,   656,   657,   658,   659,
     660,   661,   661,   662,   662,   663,   664,   664,   665,   665,
     666,   666,   667,   668,   671,   687,   695,   709,   710,   716,
     717,   721,   722,   723,   724,   725,   728,   729,   730,   731,
     732,   733,   734,   737,   738,   741,   742,   743,   744,   745,
     749,   750,   751,   752,   753,   757,   758,   761,   762,   765,
     766,   768,   769,   772,   775,   781,   782,   786,   787,   790,
     791,   794,   800,   801,   802,   803,   804,   805,   806,   807,
     808,   811,   812,   818,   819,   820,   821,   822,   823,   824,
     825,   826,   827,   828,   829,   830,   831,   834,   835,   838,
     839,   840,   841,   842,   843,   844,   845,   846,   847,   848,
     849,   850,   851,   852,   853,   854,   855,   857,   858,   859,
     860,   861,   862,   863,   864,   865,   866,   867,   868,   869,
     870,   871,   872,   873,   874,   875,   876,   877,   878,   879,
     880,   881,   882,   883,   884,   885,   886,   887,   888,   889,
     890,   891,   892,   893,   894,   895,   896,   904,   905,   906,
     907,   908,   909,   912,   913,   916,   917,   920,   921,   922,
     923,   926,   927,   930,   931,   934,   935,   938,   939,   940,
     941,   942,   943,   944,   945,   946,   947,   948,   949,   950,
     951,   952,   953,   954,   955,   956,   957,   958,   959,   960,
     961,   962,   963,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,   976,   977,   978,   979,   980,
     981,   982,   983,   984,   985,   986,   987,   990,   991,   998,
    1005,  1006,  1007,  1008,  1009,  1010,  1011,  1012,  1013,  1014,
    1015,  1016,  1017,  1018,  1019,  1020,  1027,  1028,  1035,  1036,
    1043,  1044,  1051,  1052,  1059,  1060,  1067,  1068,  1075,  1076,
    1086,  1087,  1101,  1115,  1116,  1123,  1124,  1131,  1132,  1139,
    1140,  1149,  1150,  1159,  1160,  1167,  1168,  1175,  1176,  1183,
    1184,  1191,  1192,  1199,  1200,  1207,  1208,  1215,  1216,  1223,
    1224,  1231,  1232,  1239,  1240,  1247,  1248,  1255,  1256,  1263,
    1264,  1271,  1272,  1279,  1280,  1287,  1288,  1295,  1296,  1303,
    1305,  1312,  1313,  1324,  1325,  1332,  1333,  1340,  1341,  1348,
    1349,  1356,  1357,  1364,  1365,  1372,  1373,  1380,  1387,  1394,
    1401,  1408,  1415,  1416,  1423,  1424,  1431,  1432,  1439,  1440,
    1447,  1448,  1455,  1456,  1463,  1464,  1471,  1472,  1479,  1480,
    1487,  1488,  1489,  1490,  1493,  1494,  1497,  1498,  1499,  1500,
    1501,  1502,  1503,  1504,  1516,  1529,  1541,  1554,  1567,  1581,
    1594,  1608,  1621,  1635,  1648,  1662,  1664,  1675,  1676,  1677,
    1678,  1684,  1685,  1695,  1696,  1697,  1698,  1699,  1700,  1707,
    1708,  1715,  1716,  1717,  1718,  1719,  1720,  1721,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1739,
    1740,  1747,  1748,  1755,  1762,  1763,  1764,  1791,  1792,  1793,
    1794,  1795,  1796,  1797,  1798,  1799,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1808,  1809,  1810,  1811,  1812,  1813,
    1814,  1815,  1816,  1817,  1818,  1819,  1820,  1829,  1830,  1839,
    1840,  1849,  1850,  1859,  1860,  1869,  1870,  1871,  1872,  1873,
    1874,  1875,  1876,  1877,  1878,  1879,  1880,  1881,  1882,  1883,
    1884,  1885,  1886,  1887,  1888,  1889,  1890,  1892,  1893,  1894,
    1895,  1897,  1899,  1900,  1901,  1904,  1905,  1908,  1909,  1910,
    1913,  1914,  1917,  1918,  1919,  1927,  1932,  1937,  1942,  1947,
    1950,  1955,  1963,  1969,  1970,  1976,  1977,  1987,  1988,  1998,
    1999,  2008,  2017,  2018,  2027,  2036,  2045,  2046,  2052,  2053,
    2059,  2063,  2064,  2067,  2096,  2111,  2112,  2116,  2127,  2128,
    2132,  2133,  2137,  2144,  2160,  2161,  2164,  2167,  2174,  2190,
    2194,  2195,  2200,  2200,  2207,  2208,  2210,  2209,  2232,  2237,
    2240,  2247,  2263,  2266,  2269,  2276,  2292,  2295,  2298,  2315,
    2318,  2319,  2320,  2321,  2322,  2323,  2345,  2346,  2347,  2348,
    2351,  2352,  2353,  2354,  2357,  2358,  2364,  2365,  2366,  2367,
    2368,  2369,  2370,  2373,  2374,  2375,  2376,  2383,  2384,  2385,
    2392,  2393,  2394,  2398,  2399,  2400,  2401,  2402,  2407,  2408,
    2411,  2412,  2413,  2419,  2421,  2423,  2424,  2426,  2428,  2430,
    2432,  2434,  2435,  2437,  2438,  2439,  2440,  2442,  2444,  2446,
    2448,  2450,  2452,  2453,  2489,  2491,  2493,  2495,  2498,  2500,
    2502,  2504,  2508,  2509,  2520,  2521,  2525,  2526,  2541,  2556,
    2557,  2560,  2561,  2562,  2574,  2575,  2590,  2605,  2607,  2614,
    2656,  2657,  2660,  2661,  2662,  2665,  2666,  2667,  2668,  2669,
    2670,  2671,  2672,  2675,  2683,  2693,  2710,  2717,  2724,  2731,
    2738,  2743,  2748,  2749,  2750,  2751,  2752,  2755,  2764,  2771,
    2796,  2812,  2813,  2818,  2837,  2846,  2858,  2873,  2874,  2877,
    2877,  2887,  2888,  2889,  2890,  2891,  2892,  2893,  2894,  2895,
    2898,  2901,  2902,  2905,  2912,  2915,  2922,  2928,  2929,  2938,
    2939,  2940,  2943,  2944,  2956,  2980,  2991,  3022,  3026,  3036,
    3050,  3062,  3063,  3065,  3066,  3067,  3081,  3082,  3083,  3084,
    3085,  3086,  3087,  3091,  3092,  3093,  3106,  3112,  3113,  3114,
    3115,  3116,  3117,  3118,  3119,  3120,  3121,  3122,  3123,  3124,
    3125,  3126,  3144,  3145,  3146,  3147,  3148,  3149,  3150,  3158,
    3159,  3160,  3161,  3162,  3163,  3164,  3165,  3166,  3167,  3168,
    3170,  3172,  3173,  3174,  3175,  3176,  3177,  3180,  3198,  3199,
    3200,  3203,  3204,  3205,  3206,  3207,  3208,  3209,  3210,  3211,
    3212,  3213,  3214,  3215,  3216,  3217,  3218,  3219,  3220,  3221,
    3222,  3223,  3224,  3225,  3226,  3227,  3228,  3229,  3230,  3231,
    3232,  3233,  3234,  3235,  3236,  3237,  3245,  3253,  3261,  3269,
    3277,  3285,  3293,  3301,  3309,  3310,  3312,  3320,  3328,  3336,
    3345,  3354,  3363,  3371,  3380,  3388,  3389,  3391,  3394,  3395,
    3396,  3397,  3404,  3411,  3412,  3418,  3425,  3426,  3432,  3439,
    3440,  3446,  3449,  3452,  3453,  3454,  3457,  3458,  3459,  3468,
    3477,  3478,  3479,  3480,  3481,  3482,  3483,  3484,  3485,  3486,
    3487,  3488,  3489,  3490,  3491,  3492,  3493,  3494,  3498,  3502,
    3503,  3504,  3505,  3506,  3507,  3508,  3509,  3510,  3511,  3512,
    3513,  3514,  3515,  3516,  3517,  3518,  3519,  3520,  3521,  3522,
    3523,  3524,  3525,  3526,  3527,  3528,  3529,  3537,  3545,  3553,
    3554,  3556,  3558,  3569,  3570,  3571,  3587,  3588,  3589,  3593,
    3596,  3597,  3600,  3603,  3606,  3609,  3612,  3615,  3618,  3621,
    3624,  3627,  3628,  3629,  3632,  3633,  3634,  3634,  3667,  3669,
    3671,  3672,  3675,  3692,  3696,  3700,  3704,  3709,  3713,  3718,
    3722,  3726,  3730
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "FORWARD",
  "FORWARD_TCP", "FORWARD_TLS", "FORWARD_SCTP", "FORWARD_UDP", "EXIT",
  "DROP", "RETURN", "BREAK", "LOG_TOK", "ERROR", "ROUTE", "ROUTE_REQUEST",
  "ROUTE_FAILURE", "ROUTE_ONREPLY", "ROUTE_REPLY", "ROUTE_BRANCH",
  "ROUTE_SEND", "ROUTE_EVENT", "EXEC", "SET_HOST", "SET_HOSTPORT",
  "SET_HOSTPORTTRANS", "PREFIX", "STRIP", "STRIP_TAIL", "SET_USERPHONE",
  "APPEND_BRANCH", "REMOVE_BRANCH", "CLEAR_BRANCHES", "SET_USER",
  "SET_USERPASS", "SET_PORT", "SET_URI", "REVERT_URI", "FORCE_RPORT",
  "ADD_LOCAL_RPORT", "LOCAL_RPORT", "FORCE_TCP_ALIAS", "UDP_MTU",
  "UDP_MTU_TRY_PROTO", "UDP4_RAW", "UDP4_RAW_MTU", "UDP4_RAW_TTL", "IF",
  "ELSE", "SET_ADV_ADDRESS", "SET_ADV_PORT", "FORCE_SEND_SOCKET",
  "SET_FWD_NO_CONNECT", "SET_RPL_NO_CONNECT", "SET_FWD_CLOSE",
  "SET_RPL_CLOSE", "SWITCH", "CASE", "DEFAULT", "WHILE", "CFG_SELECT",
  "CFG_RESET", "URIHOST", "URIPORT", "MAX_LEN", "SETFLAG", "RESETFLAG",
  "ISFLAGSET", "SETAVPFLAG", "RESETAVPFLAG", "ISAVPFLAGSET", "METHOD",
  "URI", "FROM_URI", "TO_URI", "SRCIP", "SRCPORT", "DSTIP", "DSTPORT",
  "TOIP", "TOPORT", "SNDIP", "SNDPORT", "SNDPROTO", "SNDAF", "PROTO", "AF",
  "MYSELF", "MSGLEN", "UDP", "TCP", "TLS", "SCTP", "WS", "WSS", "DEBUG_V",
  "FORK", "FORK_DELAY", "MODINIT_DELAY", "LOGSTDERROR", "LOGFACILITY",
  "LOGNAME", "LOGCOLOR", "LOGPREFIX", "LOGPREFIXMODE", "LOGENGINETYPE",
  "LOGENGINEDATA", "XAVPVIAPARAMS", "XAVPVIAFIELDS", "LISTEN", "ADVERTISE",
  "VIRTUAL", "STRNAME", "ALIAS", "SR_AUTO_ALIASES", "DNS", "REV_DNS",
  "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF",
  "DNS_TCP_PREF", "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME",
  "DNS_SLOW_QUERY_MS", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "DNS_SEARCH_FMATCH", "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT",
  "DNS_USE_CACHE", "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS",
  "DNS_CACHE_NEG_TTL", "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL",
  "DNS_CACHE_MEM", "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP",
  "DNS_CACHE_REC_PREF", "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL",
  "IPV6_HEX_STYLE", "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM",
  "DST_BLST_TTL", "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK",
  "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK",
  "IP_FREE_BIND", "PORT", "STAT", "STATS_NAMESEP", "CHILDREN",
  "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP", "ASYNC_NONBLOCK",
  "ASYNC_WORKERS_GROUP", "CHECK_VIA", "PHONE2TEL", "MEMLOG", "MEMDBG",
  "MEMSUM", "MEMSAFETY", "MEMJOIN", "MEMSTATUSMODE",
  "SIP_PARSER_LOG_ONELINE", "SIP_PARSER_LOG", "SIP_PARSER_MODE", "CORELOG",
  "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER",
  "REPLY_TO_VIA", "LOADMODULE", "LOADMODULEX", "LOADPATH", "MODPARAM",
  "MODPARAMX", "CFGENGINE", "MAXBUFFER", "SQL_BUFFER_SIZE", "USER",
  "GROUP", "CHROOT", "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP",
  "TCP_ACCEPT_ALIASES", "TCP_ACCEPT_UNIQUE", "TCP_CONNECTION_MATCH",
  "TCP_CHILDREN", "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT",
  "TCP_CON_LIFETIME", "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS",
  "TLS_MAX_CONNECTIONS", "TCP_NO_CONNECT", "TCP_SOURCE_IPV4",
  "TCP_SOURCE_IPV6", "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE",
  "TCP_OPT_CONN_WQ_MAX", "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF",
  "TCP_OPT_WQ_BLK", "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK",
  "TCP_OPT_SYNCNT", "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE",
  "TCP_OPT_KEEPIDLE", "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT",
  "TCP_OPT_CRLF_PING", "TCP_OPT_ACCEPT_NO_CL", "TCP_OPT_ACCEPT_HEP3",
  "TCP_OPT_ACCEPT_HAPROXY", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "TCP_WAIT_DATA", "TCP_SCRIPT_MODE", "DISABLE_TLS", "ENABLE_TLS",
  "TLSLOG", "TLS_PORT_NO", "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT",
  "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY",
  "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE", "TLS_PRIVATE_KEY",
  "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP", "SCTP_CHILDREN",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES", "REAL_TIME", "RT_PRIO",
  "RT_POLICY", "RT_TIMER1_PRIO", "RT_TIMER1_POLICY", "RT_TIMER2_PRIO",
  "RT_TIMER2_POLICY", "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS",
  "PMTU_DISCOVERY", "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE",
  "PVBUFSLOTS", "PVCACHELIMIT", "PVCACHEACTION", "HTTP_REPLY_PARSE",
  "VERSION_TABLE_CFG", "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE",
  "WAIT_WORKER1_MODE", "WAIT_WORKER1_TIME", "WAIT_WORKER1_USLEEP",
  "CFG_DESCRIPTION", "SERVER_ID", "KEMI", "ONSEND_ROUTE_CALLBACK",
  "REPLY_ROUTE_CALLBACK", "EVENT_ROUTE_CALLBACK",
  "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE", "PRE_ROUTING_CALLBACK",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "MSG_TIME", "ONSEND_RT_REPLY",
  "URI_HOST_EXTRA_CHARS", "HDR_NAME_EXTRA_CHARS", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "SELVAL", "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR",
  "AVP_OR_PVAR", "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN",
  "LBRACE", "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "port",
  "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "assign_stm", "cfg_var_id", "cfg_var_idn", "cfg_var",
  "module_stm", "ip", "ipv4", "ipv6addr", "ipv6", "route_name",
  "route_main", "route_stm", "failure_route_main", "failure_route_stm",
  "route_reply_main", "onreply_route_stm", "$@6", "$@7",
  "branch_route_main", "branch_route_stm", "send_route_main",
  "send_route_stm", "event_route_main", "event_route_stm",
  "preprocess_stm", "equalop", "cmpop", "strop", "rve_equalop",
  "rve_cmpop", "uri_type", "eint_op_onsend", "eint_op", "eip_op_onsend",
  "eip_op", "exp_elem", "ipnet", "host", "host_if_id", "host_or_if",
  "fcmd", "stm", "actions", "action", "if_cmd", "ct_rval", "single_case",
  "case_stms", "switch_cmd", "while_cmd", "select_param", "select_params",
  "select_id", "$@8", "attr_class_spec", "attr_name_spec", "attr_spec",
  "attr_mark", "attr_id", "attr_id_num_idx", "attr_id_no_idx",
  "attr_id_ass", "attr_id_any", "attr_id_any_str", "pvar", "avp_pvar",
  "assign_op", "lval", "rval", "rve_un_op", "rval_expr", "assign_action",
  "avpflag_oper", "cmd", "$@9", "func_params", "func_param", "ret_cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625
};
#endif

#define YYPACT_NINF (-1237)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-937)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2590,  -235,     5,    40,  -192,  -185,  -166,  -157,  -117,  -104,
    -101, -1237,  -100,   -86,   -79,   -75,   -72,   -61,   -14,    -5,
       0,    17,   379,   466,   477,   486,   489,   538,   542,   553,
     556,    22,    26,   671,   715,   763,   808,   820,   821,   824,
     834,   846,   872,   878,   883,   889,   898,   905,   908,   910,
     911,   917,   918,   919,   930,   946,   947,   948,   951,   968,
     971,   973,   987,   988,  1001,  1013,  1016,  1017,   568,   583,
     596,   597,   603,   606,   622,   631,   643,   654,   660,   679,
     682,   696,   744,   753,   754,   757,   812,   823,   837,   879,
     882,   903,   909,   927,   131,   156,    93,    55,    98,   211,
     928,   931,   934,   950,   952,   967,   991,  1011,  1015,  1046,
    1049,  1076,  1092,  1094,  1095,  1112,  1127,  1128,  1176,  1177,
    1202,  1203,  1205,  1206,  1019,  1050,  1051,  1056,  1207,  1208,
    1214,  1215,  1216,  1224,  1225,  1226,  1227,  1229,  1232,  1233,
    1234,  1235,  1237,  1238,  1239,  1240,  1241,  1242,  1243,  1269,
    1270,  1271,  1272,  1273,  1274,  1276,  1277,  1278,  1283,  1285,
    1286,  1287,  1288,  1318,  1319,  1321,  1322,  1323,  1324,  1326,
    1327,  1331,  1332,  1334,  1338,  1339,  1340,  1060,  1341,  1342,
    1343,  1344,  1345,  1346,  1347,  1374,  1376,  1382,  1383,  1384,
    1385,  1386,   585,  1387,  1388,  1389,  1390,  1392,  1394,  1395,
    1396,  1397,  1398,  1399,  1400,    61,    79,   167,   180,   195,
   -1237, -1237, -1237,   344,  1654, -1237,   183,   943,   964,  1025,
    1041, -1237, -1237, -1237,  -286, -1237, -1237,     8, -1237, -1237,
   -1237, -1237,   -56, -1237,    44,   266,   314,   864,    24,   317,
     320,   310,   322,   349,   352,   353,   124,   213,   356,   220,
     499,   228,   241,   252,   256,   116,   135,   586,   592,   608,
   -1237,   724, -1237,   725, -1237,   739, -1237,  -252, -1237,  -252,
   -1237,  -252, -1237,  -252, -1237,   748, -1237,   751, -1237,   788,
   -1237,   796, -1237,   818, -1237,   819, -1237,   861, -1237,  1000,
   -1237,  1024, -1237,  1052, -1237,  1144, -1237,  1250, -1237,  1367,
   -1237,  1369, -1237,  1370, -1237,  1373, -1237,  1375, -1237,  1377,
   -1237,  1378, -1237,  1379, -1237,  1022, -1237,  1380, -1237,  1381,
   -1237,  1393, -1237,  1411, -1237,  1412, -1237,  1413, -1237,  1457,
   -1237,  1539, -1237,  1540,   326,   610,   258,   615,   624,   638,
     640,   663,   259,   673,   675,   327,   329,   330,   332,   339,
     342,   347,   348,   354,   357,   676,   683,   264,   265,   693,
   -1237, -1237, -1237, -1237, -1237,   267, -1237, -1237,  1371, -1237,
    1391, -1237,   268, -1237,   703,   707,   120,   216,   234,   235,
     240,   713,   714,   718,   721,   727,   728,   358,   360,   391,
     244,   731,   733,   734,   735,    47,   736,   738, -1237,  1541,
   -1237,  1542, -1237,  1583, -1237,  1586,   740,   741,   742,   745,
     747,   749,   750,   758,   759,   760,   761,   762,   764,   765,
     394,   401,   766,   767,   768,   769,   869,   770,   771,   772,
     773,   270,   271,   272,   775,   776,   777,    27,   779,   780,
     781,   782,   783,   785,   792,   793,   798,   799,   801,   802,
     805,   806,   810,   247,   105, -1237,  1587,   815,   816,   822,
     825,   826,   827,   829,   273,   830,   831,   832,   836,   841,
     842,  1086,   465,  1588,  1589,   554,   582,   843,   847,   850,
     852,   853,   275,   277, -1237, -1237, -1237, -1237,  1368,  1365,
   -1237, -1237, -1237,  1597, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237,  -235, -1237,    69,    51,   811, -1237,    78,  1579, -1237,
      88,  1594, -1237,    96,  1595, -1237,     9,  1596, -1237,   752,
    1608, -1237, -1237, -1237, -1237,  1372, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
    1609, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,  1615, -1237, -1237, -1237,
   -1237,  1175,  1610, -1237,  1366,  1598,  1183,    68, -1237, -1237,
   -1237, -1237, -1237,  -126, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237,  1604,  1605, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,  1615, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,  1423,  1426,
    1429,  1650,  1679, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  -289,  1620,  -289, -1237,   -56,
   -1237, 12207, -1237,   -56, 12207, -1237,   -56, 12207, -1237,   -56,
   12207, -1237,  1614, -1237, -1237, -1237,  1680,  1632, 12207,    65,
   -1237,  1648,  1641,  1640,  1636,   350,  1045, -1237,  1175, -1237,
    1649,   184,   307,  1651,  1653,   279,   280,   281,   282,   284,
   -1237, -1237, -1237,  1638,   103,   104,   122,   129,   130, 11016,
   11102, 11465, -1237,   132,   137,   139,  1646,   140,   142,   143,
     144,   146,   147,   158,   162,  1647,   163,   164,   165,   168,
    1656,  1657,  1672,  1673,  1674, 11551,   169,   170,   171,  1675,
    1676,  1677,  1678,  6237, 11551,   176,   186,   188,   192,   193,
   -1237, -1237, -1237, -1237,   194, -1237, -1237, -1237,    23,  3677,
   -1237, -1237, -1237, -1237,  1074, -1237, -1237, -1237, -1237, -1237,
    1693,  1652,   202, -1237,  1689,  1645,  3747,  1695,  3817,  1697,
    3898,  1698,   249,  1666,  4181, -1237,  1696,  1668,  1175, -1237,
   -1237, -1237, -1237, -1237, -1237,  1699,   -53,  1908, -1237, -1237,
   -1237, -1237, -1237,  1706,  1717, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  1714, -1237,    11, -1237,    33,
   -1237,    75, -1237,   128, -1237,   208,   726, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,   648, -1237,
     648, -1237,   737, -1237, -1237,  1609, -1237, -1237,  6602,  6690,
    6778,  1719,  1720,  1721, -1237,  5608, 12139, -1237,   956, -1237,
     907, -1237,  1034, -1237, -1237, -1237,  1074, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,  7143,  1982,  5696,  1982,  6061,  1982,
   -1237,   254, -1237,   286, -1237,  7231,  1737, -1237,   287, -1237,
     288, -1237,   289, -1237,   290, -1237,   857, -1237,   858, -1237,
    1743, -1237,   229,  1744, -1237,   291, -1237,   294, -1237,   295,
   -1237,   300,  1745,  1746,  1747,    43,   875,  7319, 11637, -1237,
      54, -1237,   859, -1237,    84,  1748,  1749,  1758,  1768, -1237,
    1129, 11637, -1237,   301, -1237,   303, -1237,   684, -1237,   743,
   -1237,   955, -1237,  1769, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,  1786,
   -1237,  1770, -1237, 11551, -1237, -1237,   215, -1237,  1771, -1237,
    1774, -1237,  1783, -1237,  1784, -1237,  1871,  1872,   752, -1237,
   12207,  1802, -1237,  -198, -1237,  1807,  1823, -1237,   -40,  -265,
   12207,  1814,  -271, -1237,   -84, -1237,   473,   621,  1815,   664,
     669,   678,   670,  1816,   722,   855,   862,  1054,  1817,  1047,
    1059,  1062,  1055,  1818,  1063,  1066,  1071,  1058, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  7684,  5149,  5514, -1237,  1363,
    1828, -1237, -1237, -1237, -1237, -1237, -1237,  7772,  7860,  8225,
    1838, -1237,  1884,  1886,  1887,  1888,  1178,  1846,  1825,  4262,
   -1237,  8313, -1237, -1237, -1237, -1237, -1237,  8401,  8766, -1237,
    2942,  1851, -1237, -1237,  8854,  8942,  9307,  9395, 11551, 11551,
   11551, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237,  9483,  9848,  9936, 10024, 10389, 10477, 10565, -1237,
   -1237,  1856,  1862,  1861,  1870,  1864,  1883,   101,  1245,  1885,
    1889,  1898,  1910,  1912,  1913,  1914,  1916,  1925,  1926,  1930,
    1931,  1932, -1237,  1963, -1237,  1964, -1237,  1965,  1966,  1967,
    1968,  1969,  1970,  1971,  1972, -1237, -1237, -1237,  1973,  1974,
   -1237,  1975,  1976, 12207,  2199, -1237,  1977,  2001,  2002,  2003,
    2004,  1879,  1880,  2005, -1237, -1237, -1237, -1237,    25, -1237,
    2006,  1890,  2008,  2009,  2010,  2011,  2013,  2014,  2015,  2018,
   11551,  1917,  2019,  1982,  1078, -1237,  1074, -1237,  2027, -1237,
   12207, 12207, 12207, 12207,  2033,  2034,  2073,  4332,  2044, -1237,
    2283,     7,  2035,  2036,  2037,  2038,  2039,  4402, -1237,   514,
   -1237,  2043, -1237,  2050, -1237,   125,   200,  2051, -1237, -1237,
     854, -1237,  2052, -1237,  2053, -1237,  2054, -1237, -1237,   860,
   -1237,  2055, -1237,  2056, -1237,  2057, -1237, -1237,   873, -1237,
    2081, -1237,  2082, -1237,  2083, -1237, -1237,   895, -1237,  2084,
   -1237,  2085, -1237,  2086, -1237, -1237,  2091,  1294, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237,  1294, -1237, -1237,
    1294, -1237, -1237, -1237,  2030, -1237,  2092,  2077,  1655,  2079,
    2337,  2080,  3085, -1237, -1237, -1237, -1237, -1237, -1237,  2161,
    1294, -1237,  1294, -1237,   666, -1237,  2231,  1615,  2021,  2103,
   -1237,    -2,  1294,   632, -1237,  1151, -1237,  3296, -1237,  3316,
   -1237,  3658,  1284,  3102,  1349, -1237,   915, -1237,   915, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237,  1294, -1237,   666, -1237,
    2090, -1237, -1237,  2095, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237,  4545, 12069, -1237, -1237, -1237, -1237,
   -1237,   378,  1175, -1237,  2093,  6149,  2078, -1237, -1237,     3,
   -1237, 11706, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
    1982,  1082, -1237, -1237, -1237,  -289, -1237, -1237,   250,  4766,
    4909,  4979,  5049, -1237, -1237,  -195, -1237,  2094, -1237, -1237,
    2101, -1237, -1237, -1237, -1237, -1237, -1237,  2097,  2099,  2100,
    2104, -1237, -1237, -1237, -1237,  2105,  2106,  2107,  2108,  2109,
    2110,  2111,  2112,  2113,  2114,  2115,  2116,  2117,  2141,  2142,
    2143,  2144,  2145,  2146,  2147,  2148,   532,  1828, -1237, -1237,
   -1237, -1237, -1237, 11551,    46,  2096,  2149,  2150, -1237, -1237,
   -1237, -1237,  2088, -1237,  2151, 10930,  2155,  1982, 12207, -1237,
   -1237,  2153,  2594, 11551, -1237,  2154,  2164,  2165, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237,  2355, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237,  2162,  2166, -1237,  3155, -1237,  1615, -1237, -1237, -1237,
   -1237,  -198, 12207,  2159,  2163,  1290,  3030, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, 11551, -1237,  3100, 12207,
   12207, -1237,  3170,  2928,  3313,  3534, -1237
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   491,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     490,    22,    23,     0,     0,     4,     0,     0,     0,     0,
       0,     8,     9,     6,     0,   488,    10,     0,    15,     7,
     489,   544,     0,   545,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     105,     0,   107,     0,   109,     0,   111,     0,   113,     0,
     115,     0,   117,     0,   119,     0,   121,     0,   123,     0,
     125,     0,   127,     0,   129,     0,   131,     0,   133,     0,
     135,     0,   137,     0,   139,     0,   141,     0,   145,     0,
     143,     0,   147,     0,   149,     0,   151,     0,   153,     0,
     155,     0,   159,     0,   157,     0,   161,     0,   163,     0,
     165,     0,   167,     0,   169,     0,   171,     0,   173,     0,
     175,     0,   177,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     503,   502,   505,   504,   507,     0,   506,   512,     0,   516,
       0,   518,     0,   517,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   279,     0,
     281,     0,   283,     0,   285,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   419,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    60,    66,    65,    59,    61,    63,
      68,    71,    67,    69,   561,   560,   563,   562,   565,   564,
       1,     5,     3,     0,     0,     0,    12,     0,     0,    14,
       0,     0,    17,     0,     0,    19,     0,     0,    21,     0,
       0,   542,   527,   528,   529,     0,   477,   476,   479,   478,
     475,   474,   481,    31,    32,    33,    34,    35,   480,   483,
       0,    57,   482,   485,   484,   487,   486,    73,    72,    75,
      74,    77,    76,    79,    78,    81,    80,    83,    82,    85,
      84,    87,    86,    89,    88,    91,    90,    93,    92,    95,
      94,    97,    96,    99,    98,   375,   643,   641,   642,    25,
     524,     0,     0,    30,    50,     0,    55,   363,    24,   521,
     525,   522,   644,    26,   377,   376,   379,   378,   101,   100,
     103,   102,   104,   106,   108,   110,   112,   114,   116,   118,
     120,   122,   124,   126,   128,   130,   132,   134,   136,   138,
     140,   144,   142,   146,   148,   150,   152,   154,   158,   156,
     160,   162,   164,   166,   168,   170,   172,   174,   176,   179,
     178,   185,   180,   189,   188,   187,   186,   191,   190,   193,
     192,   195,   194,   197,   196,   199,   198,   201,   200,   203,
     202,   205,   204,   207,   206,   209,   208,   211,   210,   213,
     212,   215,   214,   217,   216,   219,   218,   221,   220,   223,
     222,   225,   224,   352,   351,   354,   353,   356,   355,   362,
     361,   509,   508,     0,     0,   520,   519,   182,   181,   184,
     183,   230,   229,   228,   233,   232,   231,   236,   235,   234,
     239,   238,   237,   242,   241,   240,   244,   243,   246,   245,
     248,   247,   250,   249,   252,   251,   254,   253,   256,   255,
     258,   257,   260,   259,   263,   261,   262,   265,   264,   267,
     266,   269,   268,   271,     0,   270,   273,   272,   275,   274,
     277,   276,   278,   280,   282,   284,   287,   286,   289,   288,
     291,   290,   293,   292,   295,   294,   297,   296,   299,   298,
     301,   300,   303,   302,   305,   304,   307,   306,   309,   308,
     311,   310,   313,   312,   315,   314,   317,   316,   319,   318,
     321,   320,   323,   322,   325,   324,   330,   326,   327,   328,
     329,   342,   341,   344,   343,   332,   331,   334,   333,   336,
     335,   338,   337,   340,   339,   346,   345,   348,   347,   350,
     349,   381,   380,   383,   382,   385,   384,   387,   386,   389,
     388,   391,   390,   393,   392,   395,   394,   397,   396,   399,
     398,   401,   400,   403,   402,   405,   404,   407,   406,   409,
     408,   411,   410,   414,   412,   413,   417,   415,   416,   418,
     421,   420,   423,   422,   425,   424,   427,   426,   429,   428,
     431,   430,   433,   432,   227,   226,   435,   434,   437,   436,
     439,   438,   441,   440,   443,   442,   445,   444,     0,     0,
       0,     0,     0,   457,   456,   458,   459,   463,   462,   461,
     460,   465,   464,   467,   466,   469,   468,   471,   470,   473,
     472,   358,   357,   360,   359,     0,     0,     0,   534,     0,
     535,     0,   539,     0,     0,   552,     0,     0,   556,     0,
       0,   559,     0,   493,   494,   492,     0,     0,     0,     0,
      58,     0,    27,     0,     0,     0,     0,    56,     0,   364,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      62,    64,    70,     0,     0,     0,     0,     0,     0,   948,
     945,   949,   952,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     901,   903,   905,   908,     0,     0,     0,     0,     0,   922,
     924,   926,   928,     0,     0,     0,     0,     0,     0,     0,
     778,   779,   780,   703,     0,   715,   716,   661,     0,     0,
     653,   656,   657,   658,     0,   707,   708,   718,   719,   720,
       0,     0,     0,   649,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   548,     0,     0,     0,    29,
     526,    54,    44,    43,    51,    52,   371,   365,   648,   643,
     646,   647,   645,     0,     0,   447,   446,   449,   448,   451,
     450,   453,   452,   455,   454,     0,   791,     0,   813,     0,
     824,     0,   835,     0,   802,     0,     0,   587,   588,   589,
     600,   593,   601,   594,   599,   591,   598,   590,     0,   592,
       0,   595,     0,   596,   689,   735,   733,   734,     0,     0,
       0,     0,     0,     0,   722,     0,     0,   721,     0,   597,
       0,   602,     0,   728,   727,   726,     0,   709,   711,   710,
     723,   724,   725,   736,     0,   947,     0,   944,     0,   951,
     839,     0,   856,     0,   860,     0,     0,   864,     0,   883,
       0,   886,     0,   867,     0,   873,     0,   870,     0,   876,
       0,   879,     0,     0,   892,     0,   895,     0,   889,     0,
     898,     0,     0,     0,     0,     0,     0,     0,     0,   914,
       0,   917,     0,   920,     0,     0,     0,     0,     0,   681,
       0,     0,   931,     0,   934,     0,   843,     0,   846,     0,
     849,     0,   938,     0,   662,   655,   654,   532,   652,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,     0,
     701,   704,   717,     0,   660,   854,     0,   659,     0,   537,
       0,   550,     0,   554,     0,   499,   495,   496,     0,   543,
       0,     0,    28,     0,   372,     0,     0,   366,     0,     0,
       0,     0,     0,   636,     0,   781,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   606,   566,
     567,   575,   568,   569,   574,     0,     0,     0,   631,     0,
       0,   776,   757,   760,   738,   761,   739,     0,     0,     0,
       0,   946,   709,   710,   724,   725,     0,     0,     0,     0,
     610,     0,   615,   570,   571,   572,   573,     0,     0,   627,
       0,   704,   759,   737,     0,     0,     0,     0,     0,     0,
       0,   576,   577,   582,   578,   579,   580,   581,   583,   584,
     585,   586,     0,     0,     0,     0,     0,     0,     0,   943,
     950,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   875,     0,   878,     0,   881,     0,     0,     0,
       0,     0,     0,     0,     0,   900,   902,   904,     0,     0,
     907,     0,     0,     0,   663,   650,     0,     0,     0,     0,
       0,    45,     0,     0,   921,   923,   925,   927,     0,   683,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     939,     0,     0,   777,     0,   714,     0,   712,     0,   713,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    53,
     373,   367,     0,     0,     0,     0,     0,     0,   792,     0,
     790,     0,   783,     0,   784,     0,     0,     0,   782,   814,
       0,   812,     0,   805,     0,   806,     0,   804,   825,     0,
     823,     0,   816,     0,   817,     0,   815,   836,     0,   834,
       0,   827,     0,   828,     0,   826,   803,     0,   801,     0,
     794,     0,   795,     0,   793,   605,     0,   603,   621,    36,
      37,    38,    39,    40,    41,    42,   619,   620,   618,   616,
     617,   630,   628,   629,   684,   688,   690,     0,     0,     0,
       0,     0,     0,   732,   754,   731,   730,   729,   609,     0,
     607,   614,   612,   613,   611,   626,     0,    57,     0,   634,
     622,   624,   623,     0,   772,   753,   771,   752,   767,   745,
     768,   746,   747,   748,   749,   762,   740,   763,   741,   764,
     742,   765,   743,   766,   744,   770,   751,   769,   750,   840,
       0,   837,   857,     0,   861,   859,   858,   862,   865,   863,
     884,   882,   887,   885,   868,   866,   874,   872,   871,   869,
     880,   877,   893,   891,   896,   894,   890,   888,   899,   897,
     909,   906,   911,   910,     0,     0,   913,   912,   916,   915,
     919,     0,     0,   918,     0,     0,     0,   680,   678,     0,
     932,     0,   935,   933,   841,   842,   844,   845,   847,   848,
     942,     0,   941,   702,   706,     0,   853,   704,     0,     0,
       0,     0,     0,   497,   498,     0,   547,     0,   374,   368,
       0,   510,   511,   513,   515,   514,   533,     0,     0,     0,
       0,   640,   638,   639,   637,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   773,   755,
     774,   756,   775,     0,     0,     0,     0,     0,   651,   664,
      49,    46,    47,   682,     0,     0,     0,   665,   671,   679,
     677,    57,     0,     0,   937,     0,     0,     0,   538,   551,
     555,   558,   500,   501,   523,   369,   788,   789,   786,   787,
     785,   810,   811,   808,   809,   807,   821,   822,   819,   820,
     818,   832,   833,   830,   831,   829,   799,   800,   797,   798,
     796,     0,     0,   687,     0,   635,   633,   632,   705,   838,
     855,     0,   674,     0,     0,     0,     0,   929,   930,   940,
     852,   851,   850,   370,   686,   685,     0,    48,     0,   675,
     669,   676,     0,     0,     0,     0,   758
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1237, -1237, -1237,  2300, -1237, -1237, -1237, -1237, -1237,  -435,
    1470,  1590,  -233,  1251, -1236, -1237, -1237,  -226,  -238, -1237,
    1617, -1237,  -205, -1237,  1622, -1237, -1237, -1237,  1299, -1237,
   -1237, -1064,  2152,  1958,  2179,  -680, -1237, -1237, -1237, -1237,
   -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237, -1237,
   -1237, -1082, -1237, -1054, -1237, -1237,  1252, -1237, -1237, -1237,
    1253, -1237, -1237,  -139,  -741, -1237,   -41, -1182,  -888,  -987,
   -1237,   838,   925, -1237, -1237, -1237,   863, -1237, -1237, -1237,
   -1237,  1124, -1055,  -592,  -916, -1237,  -852, -1237, -1237, -1237,
    -618,  -884, -1237, -1237, -1237, -1237,   -66, -1038, -1237, -1237,
   -1237, -1237,   835, -1237
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   213,   214,   215,   216,   217,   218,   219,   220,   583,
     943,   584,   585,  1506,  1054,  1403,   586,   587,  1117,   221,
     487,   488,   489,   222,   492,   493,   223,   224,   936,   225,
     226,   588,   589,   590,   591,   525,   505,   506,   508,   509,
     227,   228,   938,  1046,   511,   512,   514,   515,   517,   518,
     229,  1284,  1318,  1285,  1347,  1348,  1118,  1119,  1120,  1121,
    1122,  1123,  1540,  1257,   592,   593,  1124,  1394,  1019,  1020,
    1021,  1706,  1618,  1619,  1022,  1023,  1515,  1516,  1125,  1290,
    1219,  1220,  1221,  1126,  1127,  1128,  1129,  1027,  1130,  1428,
    1131,  1132,  1223,  1030,  1133,  1134,  1306,  1031,  1032,  1033,
    1203,  1631,  1632,  1034
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     542,   491,   822,   548,   538,  1025,   231,  1439,  1025,  1409,
     931,  1025,  1251,  1256,  1025,  1261,  1286,  1266,  1287,  1271,
    1289,  1276,  1025,   260,  1204,   539,  1614,   262,   821,   605,
     595,   606,  1208,   607,  1258,   608,  1036,  1029,  1317,  1038,
    1029,   233,  1040,  1029,  1388,   526,  1029,  1755,   746,  1208,
    1044,  1208,   920,  1208,  1029,  1396,   367,  1208,  1244,  1245,
    1615,  1616,   484,   519,  1311,   485,  1045,   486,  1320,  1026,
     918,  1321,  1026,  1252,   540,  1026,  1263,  1307,  1026,   922,
     490,   520,  1615,  1616,   230,  1400,  1026,   540,   541,   925,
    1449,  1444,  1450,  1445,   364,  1259,   640,   928,  1307,   369,
    1307,   541,  1202,  1025,  1076,  1078,   856,   662,   664,   666,
     668,   670,   672,   674,   676,   678,   680,   575,  1649,  1650,
    1025,   701,  1025,  1080,  1025,   557,  1661,   234,  1025,  1268,
    1082,  1084,   360,  1140,   235,  1029,   594,  1264,  1142,  1307,
    1144,  1147,  1052,  1149,  1151,  1153,   942,  1155,  1157,   729,
     731,   733,  1029,   236,  1029,  1053,  1029,   362,  1722,  1159,
    1029,  1723,   237,  1161,  1164,  1166,  1168,  1026,   494,  1170,
    1179,  1181,  1183,   533,   534,   535,   536,  1192,   948,   949,
     950,   496,   785,   787,  1026,  1058,  1026,  1194,  1026,  1196,
    1269,  1395,  1026,  1198,  1200,  1202,   498,   503,   504,  1302,
    1025,  1663,   238,  1225,  1395,   533,   534,   535,   536,  1273,
    1060,  1062,   371,   951,   559,   239,  1424,   704,   240,   241,
    1302,   563,  1302,   952,   533,   534,   535,   536,  1309,   567,
    1373,  1305,  1029,   242,   894,   707,   710,   898,   900,   963,
     243,   713,   569,  1035,   244,   734,  1037,   245,   853,  1039,
    1235,  1716,  1305,   571,  1305,  1351,  1539,   573,   246,   643,
     655,  1302,  1025,  1303,  1026,   685,   687,   528,   691,   695,
    1274,   809,   811,   813,   874,  1025,   911,  1451,   913,  1452,
    1065,  1067,  1069,  1071,  1303,  1073,  1303,  1354,  1360,  1362,
    1364,  1366,  1377,  1305,  1029,  1379,  1381,   522,   523,   540,
     524,  1383,  1410,  1028,  1412,   247,  1028,  1029,  1061,  1028,
    1427,   547,  1028,   541,   248,   530,  1442,  1246,   543,   249,
    1028,   545,  1208,   549,  1025,  1303,  1026,   639,   661,  1024,
     663,   665,  1024,   667,  1025,  1024,   250,  1455,  1024,  1026,
     669,   261,  1429,   671,   500,   263,  1024,  1456,   673,   675,
     551,  1051,  1437,   553,   555,   677,  1029,   561,   679,   728,
     947,   730,  1447,   540,   744,  1253,  1029,  1254,   580,  1709,
    -540,  1637,   232,   521,  1255,  1701,  -557,   541,   582,  1700,
     576,   577,   578,   579,   580,  1205,   744,  1253,  1026,  1260,
     580,  1617,   732,  1025,   582,   784,  1389,   527,  1026,  1756,
     582,  1028,   786,   580,   580,  -541,  1390,   576,   577,   578,
     579,   580,   365,   582,   582,   485,  -531,   486,  1028,   368,
    1028,   582,  1028,  1699,   537,  1029,  1028,  1024,   744,  1253,
    -546,  1265,   580,   485,  -530,   486,   919,   576,   577,   578,
     579,   580,   582,  -536,  1024,   923,  1024,  1289,  1024,   366,
    1208,   582,  1024,  -549,  1289,   926,   537,  1026,   857,   858,
    1208,  -553,   370,   929,  1575,  -936,   893,  1077,  1079,   576,
     577,   578,   579,   580,   702,   537,   703,  1025,   558,  1662,
     581,   744,  1253,   582,  1270,   580,  1081,   361,   576,   577,
     578,   579,   580,  1083,  1085,   582,  1141,  1304,  1028,   581,
     565,  1143,   582,  1145,  1148,  1604,  1150,  1152,  1154,  1029,
    1156,  1158,   363,  1056,  1025,  1025,  1025,  1025,  1304,  1013,
    1304,  1025,  1160,   495,  1024,  1777,  1162,  1165,  1167,  1169,
     372,  1025,  1171,  1180,  1182,  1184,   497,  1059,   577,   578,
    1193,  1026,  1639,  1640,  1641,  1642,  1029,  1029,  1029,  1029,
    1195,   499,  1197,  1029,  1664,   897,  1199,  1201,  -936,  1304,
    1028,   744,  1253,  1029,  1275,   580,  1226,   373,   540,   560,
     705,  1425,   706,  1028,  1016,   582,   564,  1657,  1026,  1026,
    1026,  1026,   541,   899,   568,  1026,  1024,   596,   708,   711,
     709,   712,  1374,   598,   714,  1026,   715,   570,   735,  1024,
     736,   854,  1236,   855,   485,  1237,   486,  1352,   572,   600,
    1353,   641,   574,   942,   644,   656,   645,  1208,  1395,   529,
     686,   688,  1028,   692,   696,   647,   810,   812,   814,   875,
    1757,   912,  1028,   914,  1426,  1066,  1068,  1070,  1072,   649,
    1074,   651,  1355,  1361,  1363,  1365,  1367,  1378,  1024,   540,
    1380,  1382,  1208,  1208,  1208,  1208,  1384,  1411,  1024,  1413,
    1059,   577,   578,   541,   653,   540,   540,   531,   540,   540,
     544,   540,   264,   546,   657,   550,   659,   681,   540,   541,
     541,   540,   541,   541,   683,   541,   540,   540,  1025,  1025,
    1052,  1028,   541,   540,   689,   541,   540,   540,   251,   540,
     541,   541,   552,  1053,   697,   554,   556,   541,   699,   562,
     541,   541,   491,   541,   716,   718,   266,  1024,  1052,   720,
    1029,  1029,   722,  1025,  1025,  1025,  1025,  1278,   724,   726,
     540,  1053,   737,   540,   739,   741,   743,   748,  1288,   750,
     540,   756,   758,   760,   541,  1397,   762,   541,   764,  1401,
     766,   768,  1026,  1026,   541,  1029,  1029,  1029,  1029,   770,
     772,   774,   776,   778,   268,   780,   782,   788,   790,   792,
     794,   801,   803,   805,   807,  1028,   815,   817,   819,  1208,
     823,   825,   827,   829,   831,   252,   833,  1026,  1026,  1026,
    1026,  1208,  1025,   835,   837,  1208,   253,  1208,  1208,   839,
     841,  1024,   843,   845,   540,   254,   847,   849,   255,   270,
     933,   851,  1028,  1028,  1028,  1028,   860,   862,   541,  1028,
    1766,   272,   274,   864,  1029,   276,   866,   868,   870,  1028,
     872,   876,   878,   880,  1453,   278,  1454,   882,  1024,  1024,
    1024,  1024,   884,   886,   901,  1024,  1025,   280,   903,  1025,
    1025,   905,   566,   907,   909,  1024,  1026,   256,  1368,  1370,
    1398,   257,  1025,  1025,  1025,   532,  1025,  1658,  1025,  1025,
     796,   540,   258,   282,  1778,   259,  1391,  1782,  1029,   284,
    1018,  1029,  1029,  1018,   286,   541,  1018,   334,  1751,  1018,
     288,  1784,  1785,   540,  1029,  1029,  1029,  1018,  1029,   290,
    1029,  1029,   335,  1135,  1137,  1139,   292,   541,  1312,   294,
    1026,   296,   298,  1026,  1026,   336,   337,  1666,   300,   302,
     304,   540,   338,  1671,  1375,   339,  1026,  1026,  1026,  1178,
    1026,   306,  1026,  1026,   471,   541,  1676,  1190,  1191,   597,
    1262,   340,  1267,  1392,  1272,   599,  1277,   308,   310,   312,
     341,  1402,   314,   533,   534,   535,   536,  1310,  1681,   507,
    1455,   601,   342,   642,   533,   534,   535,   536,   646,   316,
    1456,   540,   318,   343,   320,  1279,  1280,   648,  1018,   344,
    1282,  1283,  1457,   510,  1458,   541,  1028,  1028,   322,   324,
     265,   650,  1415,   652,  1417,  1018,  1419,  1018,   345,  1018,
    1634,   346,   326,  1018,  1342,  1343,  1344,  1345,  1346,  1455,
    1443,  1446,  1024,  1024,   328,   347,   654,   330,   332,  1456,
     398,  1028,  1028,  1028,  1028,  1460,   658,  1461,   660,   682,
    1462,  1466,  1463,  1467,   267,  1319,   684,  1414,   485,  1464,
     486,  1465,  1292,  1294,  1296,   513,   690,  1024,  1024,  1024,
    1024,   400,   402,  1279,  1280,  1281,   698,   404,  1282,  1283,
     700,   455,   516,   348,  1279,  1280,   717,   719,  1323,  1282,
    1283,   721,   349,   350,   723,  1018,   351,   602,   603,  1358,
     725,   727,   269,  1469,   738,  1470,   740,   742,   744,   749,
    1028,   751,   604,   757,   759,   761,  1416,   485,   763,   486,
     765,   609,   767,   769,   610,   934,   935,   797,   798,   799,
     800,   771,   773,   775,   777,   779,  1024,   781,   783,   789,
     791,   793,   795,   802,   804,   806,   808,   271,   816,   818,
     820,   352,   824,   826,   828,   830,   832,  1018,   834,   273,
     275,   611,   353,   277,  1028,   836,   838,  1028,  1028,   612,
    1018,   840,   842,   279,   844,   846,   354,  1423,   848,   850,
    1028,  1028,  1028,   852,  1028,   281,  1028,  1028,   861,   863,
    1024,   613,   614,  1024,  1024,   865,   921,  1702,   867,   869,
     871,  1541,   873,   877,   879,   881,  1024,  1024,  1024,   883,
    1024,   283,  1024,  1024,   885,   887,   902,   285,   355,  1018,
     904,   356,   287,   906,   537,   908,   910,  1667,   289,  1018,
    1369,  1371,  1399,  1672,   615,   537,  1471,   291,  1472,  1497,
    1507,  1510,   357,  1473,   293,  1474,  1677,   295,   358,   297,
     299,  1518,  1520,  1522,  1279,  1280,   301,   303,   305,  1282,
    1283,  1313,  1314,  1315,  1316,  1530,   359,   374,  1682,   307,
     375,  1532,  1534,   376,  1542,  1344,  1345,  1346,  1545,  1547,
    1549,  1551,  1552,  1553,  1554,   309,   311,   313,  1018,   377,
     315,   378,   533,   534,   535,   536,  1556,  1558,  1560,  1562,
    1564,  1566,  1568,  1279,  1280,  1281,   379,   317,  1282,  1283,
     319,  1781,   321,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,  1695,   323,   325,  1418,   485,
     380,   486,   976,   977,   978,   979,   980,   981,   982,   983,
     327,   984,   985,   986,   987,   988,   989,   990,   991,   992,
     381,   993,   329,   994,   382,   331,   333,   995,   399,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -668,  -668,  1004,
    1005,  1006,  1018,   616,  1630,  1007,  1008,  1009,  1010,  1011,
    1012,  1279,  1280,  1281,  1511,   383,  1282,  1283,   384,   401,
     403,   888,   889,   890,   891,   405,   892,   617,   629,   456,
    1209,  1210,  1211,  1212,  1213,  1214,  1215,  1216,  1217,  1018,
    1018,  1018,  1018,  1455,  1455,   385,  1018,  1455,   576,   577,
     578,   579,   580,  1456,  1456,   618,  1018,  1456,  1478,   581,
    1479,   386,   582,   387,   388,  1475,  1484,  1476,  1485,  1493,
    1480,  1494,  1481,  1482,  1487,  1483,  1488,  1489,  1218,  1490,
    1715,   389,  1491,  1717,  1492,  1087,  1088,  1089,  1090,  1635,
    1092,  1636,  1094,  1713,  1096,  1714,   390,   391,  1752,  1324,
    1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,
    1345,  1346,  1325,  1326,  1327,  1328,  1329,  1330,  1331,  1332,
    1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,
    1343,  1344,  1345,  1346,  1408,   392,   393,   619,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,
    1346,   394,   395,   537,   396,   397,   406,   407,   576,   577,
     578,   579,   580,   408,   409,   410,   576,   577,   578,   579,
     580,  1524,   582,   411,   412,   413,   414,   581,   415,  1707,
     582,   416,   417,   418,   419,  1712,   420,   421,   422,   423,
     424,   425,   426,  1018,  1018,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,   427,   428,
     429,   430,   431,   432,  1013,   433,   434,   435,  1018,  1018,
    1018,  1018,   436,   620,   437,   438,   439,   440,  1576,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,  1754,  1338,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,   441,   442,  1707,
     443,   444,   445,   446,  1014,   447,   448,  1630,  1015,  1016,
     449,   450,  1017,   451,    -2,   501,  -668,   452,   453,   454,
     457,   458,   459,   460,   461,   462,   463,  1018,   -11,   -11,
     -13,     2,     3,   -16,   -18,   -20,  1331,  1332,  1333,  1334,
    1335,  1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,
    1345,  1346,     4,   464,     5,   465,     6,     7,     8,     9,
      10,   466,   467,   468,   469,   470,   472,   473,   474,   475,
    1783,   476,    11,   477,   478,   479,   480,   481,   482,   483,
     621,  1018,   622,   623,  1018,  1018,   624,   693,   625,   915,
     626,   627,   628,   630,   631,   916,   945,  1018,  1018,  1018,
     939,  1018,   955,  1018,  1018,   956,   632,   694,   957,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,   633,   634,   635,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
     636,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   637,   638,   752,   753,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   754,   191,   192,   755,
     859,   895,   896,   193,   924,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   917,   927,
     930,   937,   940,   932,   941,   953,   954,   580,   946,   958,
     207,   208,   209,   961,  1041,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,   959,  1042,
    1043,  1047,  1048,  1049,  1050,  1057,  1075,  1063,   210,  1064,
    1146,  1163,  1222,  1228,  1224,  1238,   211,  1241,  1689,  1247,
    1172,  1173,  1202,   212,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  -636,  -636,  -636,  -636,  -636,  1174,  1175,  1176,  1185,
    1186,  1187,  1188,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  1227,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  1240,  -636,  1230,  -636,  1232,  1234,  1248,  -636,  1243,
    -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  1249,  1250,
    -636,  -636,  -636,  1297,  1298,  1299,  -636,  -636,  -636,  -636,
    -636,  -636,  1202,  1359,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  1372,  1376,  1385,  1386,
    1387,  1404,  1405,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  1406,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  1407,  -604,  1420,  -604,  1421,  1430,  1422,  -604,  1431,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  1432,  1433,
    -604,  -604,  -604,  1434,  1435,  1438,  -604,  -604,  -604,  -604,
    -604,  -604,  1288,  1440,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  1441,  1448,  1459,  1468,
    1477,  1486,  1514,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  1526,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  1523,  -608,  -707,  -608,  -708,  -719,  -720,  -608,  1525,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  1543,  1569,
    -608,  -608,  -608,  1570,  1571,  1573,  -608,  -608,  -608,  -608,
    -608,  -608,  1288,  1572,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  -625,  -625,  -625,  -625,  -625,  1574,  1605,  1577,  1611,
    1612,  1621,  1578,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  1579,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  1218,  -625,  1580,  -625,  1581,  1582,  1583,  -625,  1584,
    -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  1585,  1586,
    -625,  -625,  -625,  1587,  1588,  1589,  -625,  -625,  -625,  -625,
    -625,  -625,  1324,  1325,  1326,  1327,  1328,  1329,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,
    1342,  1343,  1344,  1345,  1346,  -636,  1590,  1591,  1592,  1593,
    1594,  1595,  1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,
    1606,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,  -636,
    -636,  -636,  -636,  -636,  1607,  1608,  1609,  1610,  1613,  1620,
    -636,  1622,  1623,  1624,  1625,  -636,  1626,  1627,  1628,  -636,
    -636,  1629,  -636,  -636,  -636,  -936,  -636,  1634,  1638,  1643,
    1644,  -636,  1645,  1647,  1648,  -604,  1659,  1686,  1651,  1652,
    1653,  1654,  1655,  1660,  1665,  1668,  1669,  1670,  1673,  1674,
    1675,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,  -604,
    -604,  -604,  -604,  -604,  1678,  1679,  1680,  1683,  1684,  1685,
    1688,  1687,  1690,  1692,  1694,  -604,  1696,  1724,  1708,  -604,
    -604,  1697,  -604,  -604,  -604,  -936,  -604,  1725,  1761,  1703,
    1726,  -604,  1727,  1728,  1758,  -608,  1773,  1729,  1730,  1731,
    1732,  1733,  1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,
    1742,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,  -608,
    -608,  -608,  -608,  -608,  1743,  1744,  1745,  1746,  1747,  1748,
    1749,  1750,  1759,  1760,   502,  -608,  1767,  1770,  1242,  -608,
    -608,  1762,  -608,  -608,  -608,  1765,  -608,  1771,  1772,  1779,
    1774,  -608,   960,  1780,  1775,  -625,  1055,  1436,  1509,   962,
     944,  1512,  1513,  1764,  1710,  1633,   745,     0,  1769,     0,
    1753,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,  -625,
    -625,  -625,  -625,  -625,   747,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  -625,     0,     0,     0,  -625,
    -625,     1,  -625,  -625,  -625,     0,  -625,     0,     0,     0,
       0,  -625,     0,     0,   -11,   -11,   -13,     2,     3,   -16,
     -18,   -20,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     4,     0,
       5,     0,     6,     7,     8,     9,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    11,     0,
       0,     0,     0,     0,     0,     0,     0,  1324,  1325,  1326,
    1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,
       0,     0,     0,     0,     0,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    1691,     0,     0,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,     0,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,     0,     0,
       0,     0,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,     0,   191,   192,     0,     0,     0,     0,   193,
       0,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,   208,   209,     0,
       0,     0,     0,     0,  1324,  1325,  1326,  1327,  1328,  1329,
    1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,
    1340,  1341,  1342,  1343,  1344,  1345,  1346,     0,     0,     0,
       0,     0,     0,  1535,   210,   964,   965,   966,   967,   968,
       0,     0,   211,     0,   973,   974,   975,  1768,     0,   212,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1536,
    1103,  1206,     0,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,   995,     0,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -670,  -670,  1004,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1206,     0,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,   995,     0,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -672,  -672,  1004,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1206,     0,   964,   965,   966,   967,   968,   969,   970,
     971,   972,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,   995,     0,   996,
     997,   998,   999,  1000,  1001,  1002,  1003,  -666,  -666,  1004,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,     0,     0,     0,     0,     0,  1013,  1104,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,
    1346,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,  1786,  1111,  1112,  1113,  1537,  1538,     0,  1114,   580,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,   582,
       0,     0,     0,     0,  1206,     0,   964,   965,   966,   967,
     968,   969,   970,   971,   972,   973,   974,   975,     0,     0,
       0,     0,     0,     0,  1013,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
     995,     0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,
    -673,  -673,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1014,     0,     0,     0,  1015,  1016,
       0,     0,  1017,     0,     0,     0,  -670,     0,     0,     0,
       0,     0,     0,     0,  1013,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,  1330,  1331,
    1332,  1333,  1334,  1335,  1336,  1337,  1338,  1339,  1340,  1341,
    1342,  1343,  1344,  1345,  1346,     0,  1693,     0,     0,     0,
       0,     0,     0,     0,  1014,     0,     0,     0,  1015,  1016,
       0,     0,  1017,     0,     0,     0,  -672,     0,     0,     0,
       0,     0,     0,     0,  1013,  1324,  1325,  1326,  1327,  1328,
    1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,  1338,
    1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1776,     0,     0,     0,
       0,     0,     0,     0,  1014,     0,     0,     0,  1015,  1016,
       0,     0,  1017,     0,     0,  1206,  -666,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,   995,     0,   996,   997,   998,   999,  1000,  1001,  1002,
    1003,  -667,  -667,  1004,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1326,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,  1327,
    1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,  1337,
    1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,     0,
       0,     0,     0,     0,     0,     0,     0,  1014,     0,     0,
       0,  1015,  1016,     0,     0,  1017,     0,     0,  1206,  -673,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1206,     0,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1206,     0,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,  1013,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1014,     0,
       0,     0,  1015,  1016,     0,     0,  1017,     0,     0,  1206,
    -667,   964,   965,   966,   967,   968,   969,   970,   971,   972,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,   995,     0,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,
    1336,  1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,
    1346,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,     0,  1207,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,     0,  1229,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,  1206,  1231,   964,   965,   966,   967,   968,   969,
     970,   971,   972,   973,   974,   975,     0,     0,     0,     0,
       0,     0,  1013,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,   995,     0,
     996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,     0,
    1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1014,     0,     0,     0,  1015,  1016,     0,     0,
    1017,     0,     0,  1206,  1233,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,   995,
       0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,
       0,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1206,     0,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,   995,
       0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,
       0,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1206,     0,   964,   965,   966,   967,   968,
     969,   970,   971,   972,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,   995,
       0,   996,   997,   998,   999,  1000,  1001,  1002,  1003,     0,
       0,  1004,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1014,     0,     0,     0,  1015,
    1016,     0,     0,  1017,     0,     0,  1206,  1239,   964,   965,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
       0,     0,     0,     0,     0,     0,  1013,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,   995,     0,   996,   997,   998,   999,  1000,  1001,
    1002,  1003,     0,     0,  1004,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1014,     0,     0,     0,
    1015,  1016,     0,     0,  1017,     0,     0,     0,  1527,     0,
       0,     0,     0,     0,     0,     0,  1013,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1014,     0,     0,     0,
    1015,  1016,     0,     0,  1017,     0,     0,     0,  1646,     0,
       0,     0,     0,     0,     0,     0,  1013,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1014,     0,     0,     0,
    1015,  1016,     0,     0,  1017,     0,     0,  1206,  1656,   964,
     965,   966,   967,   968,   969,   970,   971,   972,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,   995,     0,   996,   997,   998,   999,  1000,
    1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1014,
       0,     0,     0,  1015,  1016,     0,     0,  1017,     0,     0,
    1206,  1698,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1206,     0,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1206,     0,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
    1013,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,     0,
       0,     0,  1718,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1498,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,  1013,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1499,  1500,
    1501,  1502,  1503,  1504,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,  1719,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,  1720,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,  1721,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,  1505,
       0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,  1508,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1499,  1500,  1501,  1502,  1503,  1504,  1300,
       0,   964,   965,   966,   967,   968,     0,     0,     0,     0,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,     0,     0,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1300,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,  1505,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1013,  1104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,
    1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,
       0,  1301,  1177,  1116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,  1349,
    1177,  1116,  1300,     0,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1704,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1189,     0,
     964,   965,   966,   967,   968,     0,     0,     0,     0,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,     0,     0,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,
    1016,     0,     0,     0,  1350,  1177,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
    1705,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,     0,     0,
    1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,
     541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,
       0,  1177,  1116,  1291,     0,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1293,     0,   964,   965,   966,   967,   968,     0,     0,
       0,     0,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,     0,     0,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1295,
       0,   964,   965,   966,   967,   968,     0,     0,     0,     0,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,     0,     0,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1013,  1104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,
    1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,
       0,     0,     0,     0,  1177,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1013,  1104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,
    1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,
       0,     0,  1177,  1116,  1322,     0,   964,   965,   966,   967,
     968,     0,     0,     0,     0,   973,   974,   975,     0,     0,
       0,     0,     0,     0,     0,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
       0,     0,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,  1356,     0,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
    1300,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,
    1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,
       0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1357,     0,  1114,     0,  1015,
    1016,     0,     0,     0,     0,  1177,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
       0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,  1495,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1517,     0,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,  1519,     0,   964,   965,   966,   967,   968,     0,     0,
       0,     0,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,     0,     0,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1496,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1013,  1104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,
    1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,
       0,     0,     0,     0,  1177,  1116,  1521,     0,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,  1528,     0,   964,   965,   966,   967,
     968,     0,     0,     0,     0,   973,   974,   975,     0,     0,
       0,     0,     0,     0,     0,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
       0,     0,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1529,  1103,  1531,     0,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
    1104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,
    1116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,
    1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,
       0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,
    1016,     0,     0,     0,     0,  1177,  1116,  1533,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1544,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1546,     0,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1177,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1177,  1116,  1548,     0,
     964,   965,   966,   967,   968,     0,     0,     0,     0,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,     0,     0,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1550,     0,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,  1555,     0,   964,   965,   966,   967,
     968,     0,     0,     0,     0,   973,   974,   975,     0,     0,
       0,     0,     0,     0,     0,   976,   977,   978,   979,   980,
     981,   982,   983,     0,   984,   985,   986,   987,   988,   989,
     990,   991,   992,     0,   993,     0,   994,     0,     0,     0,
       0,     0,   996,   997,   998,   999,  1000,  1001,  1002,     0,
       0,     0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,
    1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,
    1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,
    1102,  1103,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,     0,     0,
    1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,
     541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,
       0,  1177,  1116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
    1104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,
    1116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1013,  1104,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,
    1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,
       0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,  1557,
       0,   964,   965,   966,   967,   968,     0,     0,     0,     0,
     973,   974,   975,     0,     0,     0,     0,     0,     0,     0,
     976,   977,   978,   979,   980,   981,   982,   983,     0,   984,
     985,   986,   987,   988,   989,   990,   991,   992,     0,   993,
       0,   994,     0,     0,     0,     0,     0,   996,   997,   998,
     999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,
       0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,
    1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,
    1097,  1098,  1099,  1100,  1101,  1102,  1103,  1559,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,  1561,     0,   964,   965,   966,
     967,   968,     0,     0,     0,     0,   973,   974,   975,     0,
       0,     0,     0,     0,     0,     0,   976,   977,   978,   979,
     980,   981,   982,   983,     0,   984,   985,   986,   987,   988,
     989,   990,   991,   992,     0,   993,     0,   994,     0,     0,
       0,     0,     0,   996,   997,   998,   999,  1000,  1001,  1002,
       0,     0,     0,     0,  1005,  1006,     0,     0,     0,  1007,
    1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,
    1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1013,  1104,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1105,     0,     0,
       0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,
    1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,
       0,     0,  1177,  1116,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1177,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1013,  1104,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1105,     0,     0,     0,  1106,     0,  1107,
    1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,     0,
    1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,  1116,
    1563,     0,   964,   965,   966,   967,   968,     0,     0,     0,
       0,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,     0,     0,   996,   997,
     998,   999,  1000,  1001,  1002,     0,     0,     0,     0,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,
    1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,  1565,     0,
     964,   965,   966,   967,   968,     0,     0,     0,     0,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,     0,     0,   996,   997,   998,   999,
    1000,  1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,
    1088,  1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,
    1098,  1099,  1100,  1101,  1102,  1103,  1567,     0,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,  1104,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1105,     0,
       0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,  1111,
    1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,     0,
       0,     0,     0,  1177,  1116,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,  1104,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1105,     0,     0,     0,
    1106,     0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,
     541,  1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,
       0,  1177,  1116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1013,
    1104,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1177,
    1116,  1763,     0,   964,   965,   966,   967,   968,     0,     0,
       0,     0,   973,   974,   975,     0,     0,     0,     0,     0,
       0,     0,   976,   977,   978,   979,   980,   981,   982,   983,
       0,   984,   985,   986,   987,   988,   989,   990,   991,   992,
       0,   993,     0,   994,     0,     0,     0,     0,     0,   996,
     997,   998,   999,  1000,  1001,  1002,     0,     0,     0,     0,
    1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,
    1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,  1094,
    1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,     0,
       0,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,   964,   965,   966,   967,   968,
       0,     0,     0,     0,   973,   974,   975,     0,     0,     0,
       0,     0,     0,     0,   976,   977,   978,   979,   980,   981,
     982,   983,     0,   984,   985,   986,   987,   988,   989,   990,
     991,   992,     0,   993,     0,   994,     0,     0,     0,     0,
       0,   996,   997,   998,   999,  1000,  1001,  1002,     0,     0,
       0,     0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,
    1010,  1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,
    1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,
    1103,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1013,  1104,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1105,
       0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,     0,
    1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,  1016,
       0,     0,     0,     0,  1177,  1116,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1115,  1116,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1013,  1104,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,
    1110,     0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,
    1015,  1016,     0,     0,     0,     0,  1136,  1116,   964,   965,
     966,   967,   968,     0,     0,     0,     0,   973,   974,   975,
       0,     0,     0,     0,     0,     0,     0,   976,   977,   978,
     979,   980,   981,   982,   983,     0,   984,   985,   986,   987,
     988,   989,   990,   991,   992,     0,   993,     0,   994,     0,
       0,     0,     0,     0,   996,   997,   998,   999,  1000,  1001,
    1002,     0,     0,     0,     0,  1005,  1006,     0,     0,     0,
    1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,  1099,
    1100,  1101,  1102,  1103,   964,   965,   966,   967,   968,     0,
       0,     0,     0,   973,   974,   975,     0,     0,     0,     0,
       0,     0,     0,   976,   977,   978,   979,   980,   981,   982,
     983,     0,   984,   985,   986,   987,   988,   989,   990,   991,
     992,     0,   993,     0,   994,     0,     0,     0,     0,     0,
     996,   997,   998,   999,  1000,  1001,  1002,     0,     0,     0,
       0,  1005,  1006,     0,     0,     0,  1007,  1008,  1009,  1010,
    1011,  1012,  1086,  1087,  1088,  1089,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1099,  1100,  1101,  1102,  1103,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,     0,   964,
     965,   966,   967,   968,     0,     0,     0,     0,   973,   974,
     975,     0,     0,     0,     0,     0,     0,     0,   976,   977,
     978,   979,   980,   981,   982,   983,     0,   984,   985,   986,
     987,   988,   989,   990,   991,   992,     0,   993,     0,   994,
       0,     0,     0,     0,     0,   996,   997,   998,   999,  1000,
    1001,  1002,     0,     0,     0,     0,  1005,  1006,     0,  1013,
    1104,  1007,  1008,  1009,  1010,  1011,  1012,  1086,  1087,  1088,
    1089,  1090,  1091,  1092,  1093,  1094,  1095,  1096,  1097,  1098,
    1099,  1100,  1101,  1102,  1103,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1105,     0,     0,     0,  1106,     0,
    1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,   541,  1014,
       0,  1114,     0,  1015,  1016,     0,     0,     0,     0,  1138,
    1116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1013,  1104,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1105,     0,     0,     0,  1106,     0,  1107,  1108,  1109,  1110,
       0,  1111,  1112,  1113,   541,  1014,     0,  1114,     0,  1015,
    1016,     0,     0,     0,     0,  1177,  1116,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1324,  1325,  1326,
    1327,  1328,  1329,  1330,  1331,  1332,  1333,  1334,  1335,  1336,
    1337,  1338,  1339,  1340,  1341,  1342,  1343,  1344,  1345,  1346,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017,
       0,     0,  1393,     0,     0,     0,     0,     0,     0,     0,
    1013,  1104,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1105,     0,     0,     0,  1106,
       0,  1107,  1108,  1109,  1110,     0,  1111,  1112,  1113,  1711,
    1014,     0,  1114,     0,  1015,  1016,     0,     0,     0,     0,
    1177,  1116,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
    1308,     0,   964,   965,   966,   967,   968,   969,   970,   971,
     972,   973,   974,   975,     0,     0,     0,     0,     0,     0,
       0,   976,   977,   978,   979,   980,   981,   982,   983,     0,
     984,   985,   986,   987,   988,   989,   990,   991,   992,     0,
     993,     0,   994,     0,     0,     0,   995,     0,   996,   997,
     998,   999,  1000,  1001,  1002,  1003,     0,     0,  1004,  1005,
    1006,     0,     0,     0,  1007,  1008,  1009,  1010,  1011,  1012,
     964,   965,   966,   967,   968,   969,   970,   971,   972,   973,
     974,   975,     0,     0,     0,     0,     0,     0,     0,   976,
     977,   978,   979,   980,   981,   982,   983,     0,   984,   985,
     986,   987,   988,   989,   990,   991,   992,     0,   993,     0,
     994,     0,     0,     0,   995,     0,   996,   997,   998,   999,
    1000,  1001,  1002,  1003,     0,     0,  1004,  1005,  1006,     0,
       0,     0,  1007,  1008,  1009,  1010,  1011,  1012,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,  1393,     0,     0,     0,     0,     0,
       0,     0,     0,  1013,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1014,     0,     0,     0,  1015,  1016,     0,
       0,  1017,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1013,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1014,     0,     0,     0,  1015,  1016,     0,     0,  1017
};

static const yytype_int16 yycheck[] =
{
     238,   206,   437,   241,   237,   921,     1,  1243,   924,  1191,
       1,   927,     1,  1077,   930,  1079,  1098,  1081,  1100,  1083,
    1102,  1085,   938,     1,     1,     1,     1,     1,     1,   267,
     256,   269,  1019,   271,     1,   273,   924,   921,  1120,   927,
     924,     1,   930,   927,     1,     1,   930,     1,     1,  1036,
     938,  1038,     1,  1040,   938,     1,     1,  1044,   111,   112,
      57,    58,     1,   349,  1118,   354,     1,   356,  1122,   921,
       1,  1126,   924,    62,   339,   927,     1,  1115,   930,     1,
       1,   367,    57,    58,   319,     1,   938,   339,   353,     1,
     361,   356,   363,   358,     1,    62,   334,     1,  1136,     1,
    1138,   353,     1,  1019,     1,     1,     1,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,     1,   111,   112,
    1036,     1,  1038,     1,  1040,     1,     1,   319,  1044,     1,
       1,     1,     1,     1,   319,  1019,     1,    62,     1,  1177,
       1,     1,   340,     1,     1,     1,   581,     1,     1,   387,
     388,   389,  1036,   319,  1038,   353,  1040,     1,   353,     1,
    1044,   356,   319,     1,     1,     1,     1,  1019,     1,     1,
       1,     1,     1,    89,    90,    91,    92,     1,   110,   111,
     112,     1,   420,   421,  1036,     1,  1038,     1,  1040,     1,
      62,  1178,  1044,     1,     1,     1,     1,    14,    15,  1115,
    1116,     1,   319,     1,  1191,    89,    90,    91,    92,     1,
     951,   952,     1,   339,     1,   319,     1,     1,   319,   319,
    1136,     1,  1138,   349,    89,    90,    91,    92,  1116,     1,
       1,  1115,  1116,   319,   472,     1,     1,   475,   476,   919,
     319,     1,     1,   923,   319,     1,   926,   319,     1,   929,
       1,     1,  1136,     1,  1138,     1,  1320,     1,   319,     1,
       1,  1177,  1178,  1115,  1116,     1,     1,     1,     1,     1,
      62,     1,     1,     1,     1,  1191,     1,   361,     1,   363,
       1,     1,     1,     1,  1136,     1,  1138,     1,     1,     1,
       1,     1,     1,  1177,  1178,     1,     1,   353,   354,   339,
     356,     1,     1,   921,     1,   319,   924,  1191,     1,   927,
    1226,     1,   930,   353,   319,     1,   356,   370,     1,   319,
     938,     1,  1309,     1,  1240,  1177,  1178,     1,     1,   921,
       1,     1,   924,     1,  1250,   927,   319,   339,   930,  1191,
       1,   319,  1226,     1,     0,   319,   938,   349,     1,     1,
       1,     1,  1240,     1,     1,     1,  1240,     1,     1,     1,
     586,     1,  1250,   339,   353,   354,  1250,   356,   357,   366,
     365,  1426,   367,   365,   363,  1611,   367,   353,   367,     1,
     353,   354,   355,   356,   357,   362,   353,   354,  1240,   356,
     357,   366,     1,  1309,   367,     1,   353,   353,  1250,   353,
     367,  1019,     1,   357,   357,   365,   363,   353,   354,   355,
     356,   357,   319,   367,   367,   354,   365,   356,  1036,   364,
    1038,   367,  1040,  1605,   340,  1309,  1044,  1019,   353,   354,
     365,   356,   357,   354,   365,   356,   367,   353,   354,   355,
     356,   357,   367,   365,  1036,   367,  1038,  1529,  1040,   356,
    1437,   367,  1044,   365,  1536,   367,   340,  1309,   353,   354,
    1447,   365,   364,   367,   363,   364,     1,   364,   364,   353,
     354,   355,   356,   357,   354,   340,   356,  1393,   354,   354,
     364,   353,   354,   367,   356,   357,   364,   356,   353,   354,
     355,   356,   357,   364,   364,   367,   364,  1115,  1116,   364,
       1,   364,   367,   364,   364,  1393,   364,   364,   364,  1393,
     364,   364,   356,   948,  1430,  1431,  1432,  1433,  1136,   304,
    1138,  1437,   364,   356,  1116,  1761,   364,   364,   364,   364,
     319,  1447,   364,   364,   364,   364,   356,   353,   354,   355,
     364,  1393,  1430,  1431,  1432,  1433,  1430,  1431,  1432,  1433,
     364,   356,   364,  1437,   354,     1,   364,   364,   364,  1177,
    1178,   353,   354,  1447,   356,   357,   364,   356,   339,   356,
     354,   356,   356,  1191,   359,   367,   356,    63,  1430,  1431,
    1432,  1433,   353,     1,   356,  1437,  1178,     1,   354,   354,
     356,   356,   363,     1,   354,  1447,   356,   356,   354,  1191,
     356,   354,   353,   356,   354,   356,   356,   353,   356,     1,
     356,     1,   356,  1048,   356,   356,     1,  1604,  1605,   353,
     356,   356,  1240,   356,   356,     1,   356,   356,   356,   356,
    1694,   356,  1250,   356,  1226,   356,   356,   356,   356,     1,
     356,     1,   356,   356,   356,   356,   356,   356,  1240,   339,
     356,   356,  1639,  1640,  1641,  1642,   356,   356,  1250,   356,
     353,   354,   355,   353,     1,   339,   339,   353,   339,   339,
     353,   339,     1,   353,     1,   353,     1,     1,   339,   353,
     353,   339,   353,   353,     1,   353,   339,   339,  1604,  1605,
     340,  1309,   353,   339,     1,   353,   339,   339,   319,   339,
     353,   353,   353,   353,     1,   353,   353,   353,     1,   353,
     353,   353,   917,   353,     1,     1,     1,  1309,   340,     1,
    1604,  1605,     1,  1639,  1640,  1641,  1642,     1,     1,     1,
     339,   353,     1,   339,     1,     1,     1,     1,     1,     1,
     339,     1,     1,     1,   353,  1180,     1,   353,     1,  1184,
       1,     1,  1604,  1605,   353,  1639,  1640,  1641,  1642,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,  1393,     1,     1,     1,  1766,
       1,     1,     1,     1,     1,   319,     1,  1639,  1640,  1641,
    1642,  1778,  1708,     1,     1,  1782,   319,  1784,  1785,     1,
       1,  1393,     1,     1,   339,   319,     1,     1,   319,     1,
      58,     1,  1430,  1431,  1432,  1433,     1,     1,   353,  1437,
    1708,     1,     1,     1,  1708,     1,     1,     1,     1,  1447,
       1,     1,     1,     1,   361,     1,   363,     1,  1430,  1431,
    1432,  1433,     1,     1,     1,  1437,  1762,     1,     1,  1765,
    1766,     1,   353,     1,     1,  1447,  1708,   319,     1,     1,
       1,   319,  1778,  1779,  1780,     1,  1782,   353,  1784,  1785,
       1,   339,   319,     1,  1762,   319,     1,  1765,  1762,     1,
     921,  1765,  1766,   924,     1,   353,   927,   319,   356,   930,
       1,  1779,  1780,   339,  1778,  1779,  1780,   938,  1782,     1,
    1784,  1785,   319,   969,   970,   971,     1,   353,     1,     1,
    1762,     1,     1,  1765,  1766,   319,   319,    63,     1,     1,
       1,   339,   319,    63,  1162,   319,  1778,  1779,  1780,   995,
    1782,     1,  1784,  1785,   349,   353,    63,  1003,  1004,   353,
    1079,   319,  1081,  1176,  1083,   353,  1085,     1,     1,     1,
     319,  1184,     1,    89,    90,    91,    92,     1,    63,    16,
     339,   353,   319,   353,    89,    90,    91,    92,   353,     1,
     349,   339,     1,   319,     1,   327,   328,   353,  1019,   319,
     332,   333,   361,    19,   363,   353,  1604,  1605,     1,     1,
     319,   353,  1197,   353,  1199,  1036,  1201,  1038,   319,  1040,
     368,   319,     1,  1044,   338,   339,   340,   341,   342,   339,
    1248,  1249,  1604,  1605,     1,   319,   353,     1,     1,   349,
       1,  1639,  1640,  1641,  1642,   361,   353,   363,   353,   353,
     361,   361,   363,   363,   319,     1,   353,   353,   354,   361,
     356,   363,  1108,  1109,  1110,    20,   353,  1639,  1640,  1641,
    1642,     1,     1,   327,   328,   329,   353,     1,   332,   333,
     353,     1,    21,   319,   327,   328,   353,   353,  1134,   332,
     333,   353,   319,   319,   353,  1116,   319,   353,   353,  1145,
     353,   353,   319,   361,   353,   363,   353,   353,   353,   353,
    1708,   353,   353,   353,   353,   353,   353,   354,   353,   356,
     353,   353,   353,   353,   353,   353,   354,   238,   239,   240,
     241,   353,   353,   353,   353,   353,  1708,   353,   353,   353,
     353,   353,   353,   353,   353,   353,   353,   319,   353,   353,
     353,   319,   353,   353,   353,   353,   353,  1178,   353,   319,
     319,   353,   319,   319,  1762,   353,   353,  1765,  1766,   353,
    1191,   353,   353,   319,   353,   353,   319,  1223,   353,   353,
    1778,  1779,  1780,   353,  1782,   319,  1784,  1785,   353,   353,
    1762,   353,   353,  1765,  1766,   353,   365,  1612,   353,   353,
     353,  1320,   353,   353,   353,   353,  1778,  1779,  1780,   353,
    1782,   319,  1784,  1785,   353,   353,   353,   319,   319,  1240,
     353,   319,   319,   353,   340,   353,   353,   353,   319,  1250,
     353,   353,   353,   353,   353,   340,   361,   319,   363,  1285,
    1286,  1287,   319,   361,   319,   363,   353,   319,   319,   319,
     319,  1297,  1298,  1299,   327,   328,   319,   319,   319,   332,
     333,   334,   335,   336,   337,  1311,   319,   319,   353,   319,
     319,  1317,  1318,   319,  1320,   340,   341,   342,  1324,  1325,
    1326,  1327,  1328,  1329,  1330,   319,   319,   319,  1309,   319,
     319,   319,    89,    90,    91,    92,  1342,  1343,  1344,  1345,
    1346,  1347,  1348,   327,   328,   329,   319,   319,   332,   333,
     319,     1,   319,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,  1543,   319,   319,   353,   354,
     319,   356,    22,    23,    24,    25,    26,    27,    28,    29,
     319,    31,    32,    33,    34,    35,    36,    37,    38,    39,
     319,    41,   319,    43,   319,   319,   319,    47,   319,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,  1393,   353,  1420,    65,    66,    67,    68,    69,
      70,   327,   328,   329,     1,   319,   332,   333,   319,   319,
     319,   285,   286,   287,   288,   319,   290,   353,   356,   319,
     306,   307,   308,   309,   310,   311,   312,   313,   314,  1430,
    1431,  1432,  1433,   339,   339,   319,  1437,   339,   353,   354,
     355,   356,   357,   349,   349,   353,  1447,   349,   361,   364,
     363,   319,   367,   319,   319,   361,   361,   363,   363,   361,
     361,   363,   363,   361,   361,   363,   363,   361,   354,   363,
    1635,   319,   361,  1638,   363,    72,    73,    74,    75,   361,
      77,   363,    79,   361,    81,   363,   319,   319,  1686,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   365,   319,   319,   353,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   319,   319,   340,   319,   319,   319,   319,   353,   354,
     355,   356,   357,   319,   319,   319,   353,   354,   355,   356,
     357,   363,   367,   319,   319,   319,   319,   364,   319,  1615,
     367,   319,   319,   319,   319,  1621,   319,   319,   319,   319,
     319,   319,   319,  1604,  1605,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   319,   319,
     319,   319,   319,   319,   304,   319,   319,   319,  1639,  1640,
    1641,  1642,   319,   353,   319,   319,   319,   319,   363,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,  1693,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   319,   319,  1705,
     319,   319,   319,   319,   354,   319,   319,  1713,   358,   359,
     319,   319,   362,   319,     0,     1,   366,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,  1708,    14,    15,
      16,    17,    18,    19,    20,    21,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,    38,   319,    40,   319,    42,    43,    44,    45,
      46,   319,   319,   319,   319,   319,   319,   319,   319,   319,
    1776,   319,    58,   319,   319,   319,   319,   319,   319,   319,
     353,  1762,   353,   353,  1765,  1766,   353,   356,   353,   361,
     353,   353,   353,   353,   353,   370,   370,  1778,  1779,  1780,
     368,  1782,   319,  1784,  1785,   319,   353,   356,   319,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   353,   353,   353,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     353,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   353,   353,   353,   353,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   353,   283,   284,   353,
     353,   353,   353,   289,   365,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   361,   365,
     365,   353,   353,   367,   349,   361,   361,   357,   370,   319,
     316,   317,   318,   353,   360,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   319,   319,
     368,   353,   361,   363,   368,   356,   368,   356,   354,   356,
     364,   364,   319,   368,   362,   349,   362,   349,   363,   111,
     364,   364,     1,   369,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   364,   364,   364,   364,
     364,   364,   364,    22,    23,    24,    25,    26,    27,    28,
      29,   362,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   365,    41,   368,    43,   368,   368,   361,    47,   370,
      49,    50,    51,    52,    53,    54,    55,    56,   361,   365,
      59,    60,    61,   364,   364,   364,    65,    66,    67,    68,
      69,    70,     1,   356,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   363,   363,   363,   363,
     363,   363,   363,    22,    23,    24,    25,    26,    27,    28,
      29,   363,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   363,    41,   364,    43,   349,   365,   367,    47,   365,
      49,    50,    51,    52,    53,    54,    55,    56,   365,   365,
      59,    60,    61,   282,   282,   353,    65,    66,    67,    68,
      69,    70,     1,   356,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   353,   363,   363,   363,
     363,   363,   354,    22,    23,    24,    25,    26,    27,    28,
      29,   366,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   363,    41,   319,    43,   319,   319,   319,    47,   363,
      49,    50,    51,    52,    53,    54,    55,    56,   367,   363,
      59,    60,    61,   361,   363,   361,    65,    66,    67,    68,
      69,    70,     1,   363,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,   363,    48,   363,   370,
     370,   361,   363,    22,    23,    24,    25,    26,    27,    28,
      29,   363,    31,    32,    33,    34,    35,    36,    37,    38,
      39,   354,    41,   363,    43,   363,   363,   363,    47,   363,
      49,    50,    51,    52,    53,    54,    55,    56,   363,   363,
      59,    60,    61,   363,   363,   363,    65,    66,    67,    68,
      69,    70,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   304,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   363,   363,   363,   363,   363,   363,
     349,   363,   363,   363,   363,   354,   363,   363,   363,   358,
     359,   363,   361,   362,   363,   364,   365,   368,   361,   356,
     356,   370,   319,   349,   111,   304,   353,   367,   363,   363,
     363,   363,   363,   353,   353,   353,   353,   353,   353,   353,
     353,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   353,   353,   353,   353,   353,   353,
     363,   349,   363,   363,   341,   354,   356,   353,   370,   358,
     359,   356,   361,   362,   363,   364,   365,   356,   370,   366,
     363,   370,   363,   363,   368,   304,   111,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   214,   354,   363,   363,  1048,   358,
     359,   370,   361,   362,   363,   370,   365,   363,   363,   370,
     368,   370,   915,   370,   368,   304,   946,  1238,  1287,   917,
     582,  1289,  1289,  1705,  1619,  1421,   394,    -1,  1713,    -1,
    1687,   320,   321,   322,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   395,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,
     359,     1,   361,   362,   363,    -1,   365,    -1,    -1,    -1,
      -1,   370,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    38,    -1,
      40,    -1,    42,    43,    44,    45,    46,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    58,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     363,    -1,    -1,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,    -1,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,    -1,    -1,
      -1,    -1,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,    -1,   283,   284,    -1,    -1,    -1,    -1,   289,
      -1,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   316,   317,   318,    -1,
      -1,    -1,    -1,    -1,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,    -1,    -1,    -1,
      -1,    -1,    -1,     1,   354,     3,     4,     5,     6,     7,
      -1,    -1,   362,    -1,    12,    13,    14,   363,    -1,   369,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    -1,    -1,    -1,    -1,    -1,   304,   305,   320,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,   363,   350,   351,   352,   353,   354,    -1,   356,   357,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,   367,
      -1,    -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,   304,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      47,    -1,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,   354,    -1,    -1,    -1,   358,   359,
      -1,    -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,    -1,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,
      -1,    -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   361,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,
      -1,    -1,   362,    -1,    -1,     1,   366,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    47,    -1,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,
      -1,   358,   359,    -1,    -1,   362,    -1,    -1,     1,   366,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,   304,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,   354,    -1,
      -1,    -1,   358,   359,    -1,    -1,   362,    -1,    -1,     1,
     366,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    59,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,     1,   366,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,   304,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,    -1,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      59,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,
     362,    -1,    -1,     1,   366,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    47,
      -1,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    59,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,   358,
     359,    -1,    -1,   362,    -1,    -1,     1,   366,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,   304,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    47,    -1,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    59,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,   354,    -1,    -1,    -1,
     358,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,
     358,   359,    -1,    -1,   362,    -1,    -1,    -1,   366,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   354,    -1,    -1,    -1,
     358,   359,    -1,    -1,   362,    -1,    -1,     1,   366,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    59,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   354,
      -1,    -1,    -1,   358,   359,    -1,    -1,   362,    -1,    -1,
       1,   366,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
     304,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
     354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,    -1,
      -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,   304,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,   366,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,   340,
      -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,   340,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,
      -1,   363,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,   363,
     364,   365,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,   363,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,
     341,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,
      -1,   364,   365,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,    -1,   356,    -1,   358,   359,
      -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,
      -1,    -1,   364,   365,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,    -1,   356,
      -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,
      -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,    -1,   356,    -1,   358,   359,
      -1,    -1,    -1,    -1,   364,   365,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
     305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,    -1,   356,
      -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,    -1,   364,   365,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,
      -1,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
     305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,
     347,   348,    -1,   350,   351,   352,   353,   354,    -1,   356,
      -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    -1,    41,
      -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,
      -1,    -1,    -1,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    -1,    41,    -1,    43,    -1,    -1,
      -1,    -1,    -1,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,   343,    -1,   345,   346,   347,   348,    -1,   350,   351,
     352,   353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,
      -1,    -1,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,   305,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,   345,
     346,   347,   348,    -1,   350,   351,   352,   353,   354,    -1,
     356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,   365,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,    50,
      51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,
      -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,   350,
     351,   352,   353,   354,    -1,   356,    -1,   358,   359,    -1,
      -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,
     343,    -1,   345,   346,   347,   348,    -1,   350,   351,   352,
     353,   354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,
      -1,   364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   304,
     305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      60,    61,    -1,    -1,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,
      -1,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,
      -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,    -1,
     350,   351,   352,   353,   354,    -1,   356,    -1,   358,   359,
      -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,
     348,    -1,   350,   351,   352,   353,   354,    -1,   356,    -1,
     358,   359,    -1,    -1,    -1,    -1,   364,   365,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    -1,    41,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    60,    61,    -1,    -1,    -1,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    12,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    -1,    41,    -1,    43,    -1,    -1,    -1,    -1,    -1,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    60,    61,    -1,    -1,    -1,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    12,    13,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    -1,    41,    -1,    43,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,    52,    53,
      54,    55,    -1,    -1,    -1,    -1,    60,    61,    -1,   304,
     305,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,    -1,
     345,   346,   347,   348,    -1,   350,   351,   352,   353,   354,
      -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,   364,
     365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   304,   305,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     339,    -1,    -1,    -1,   343,    -1,   345,   346,   347,   348,
      -1,   350,   351,   352,   353,   354,    -1,   356,    -1,   358,
     359,    -1,    -1,    -1,    -1,   364,   365,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,   322,
     323,   324,   325,   326,   327,   328,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362,
      -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     304,   305,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,    -1,   343,
      -1,   345,   346,   347,   348,    -1,   350,   351,   352,   353,
     354,    -1,   356,    -1,   358,   359,    -1,    -1,    -1,    -1,
     364,   365,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    -1,
      41,    -1,    43,    -1,    -1,    -1,    47,    -1,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    65,    66,    67,    68,    69,    70,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    -1,    41,    -1,
      43,    -1,    -1,    -1,    47,    -1,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    59,    60,    61,    -1,
      -1,    -1,    65,    66,    67,    68,    69,    70,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,   365,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,   358,   359,    -1,
      -1,   362,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   304,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   354,    -1,    -1,    -1,   358,   359,    -1,    -1,   362
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    17,    18,    38,    40,    42,    43,    44,    45,
      46,    58,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   283,   284,   289,   291,   292,   293,   294,   295,   296,
     297,   298,   299,   300,   301,   302,   303,   316,   317,   318,
     354,   362,   369,   372,   373,   374,   375,   376,   377,   378,
     379,   390,   394,   397,   398,   400,   401,   411,   412,   421,
     319,     1,   367,     1,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,     1,   319,     1,   319,     1,   319,
       1,   319,     1,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
       1,   356,     1,   356,     1,   319,   356,     1,   364,     1,
     364,     1,   319,   356,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,     1,   319,
       1,   319,     1,   319,     1,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,   319,     1,   319,   319,   319,   319,
     319,   319,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   349,   319,   319,   319,   319,   319,   319,   319,   319,
     319,   319,   319,   319,     1,   354,   356,   391,   392,   393,
       1,   393,   395,   396,     1,   356,     1,   356,     1,   356,
       0,     1,   374,    14,    15,   407,   408,    16,   409,   410,
      19,   415,   416,    20,   417,   418,    21,   419,   420,   349,
     367,   365,   353,   354,   356,   406,     1,   353,     1,   353,
       1,   353,     1,    89,    90,    91,    92,   340,   383,     1,
     339,   353,   389,     1,   353,     1,   353,     1,   389,     1,
     353,     1,   353,     1,   353,     1,   353,     1,   354,     1,
     356,     1,   353,     1,   356,     1,   353,     1,   356,     1,
     356,     1,   356,     1,   356,     1,   353,   354,   355,   356,
     357,   364,   367,   380,   382,   383,   387,   388,   402,   403,
     404,   405,   435,   436,     1,   388,     1,   353,     1,   353,
       1,   353,   353,   353,   353,   389,   389,   389,   389,   353,
     353,   353,   353,   353,   353,   353,   353,   353,   353,   353,
     353,   353,   353,   353,   353,   353,   353,   353,   353,   356,
     353,   353,   353,   353,   353,   353,   353,   353,   353,     1,
     389,     1,   353,     1,   356,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   353,     1,   356,     1,   353,     1,
     353,     1,   389,     1,   389,     1,   389,     1,   389,     1,
     389,     1,   389,     1,   389,     1,   389,     1,   389,     1,
     389,     1,   353,     1,   353,     1,   356,     1,   356,     1,
     353,     1,   356,   356,   356,     1,   356,     1,   353,     1,
     353,     1,   354,   356,     1,   354,   356,     1,   354,   356,
       1,   354,   356,     1,   354,   356,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   389,
       1,   389,     1,   389,     1,   354,   356,     1,   353,     1,
     353,     1,   353,     1,   353,   403,     1,   405,     1,   353,
       1,   353,   353,   353,   353,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   389,     1,   389,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   238,   239,   240,
     241,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     356,     1,   356,     1,   356,     1,   353,     1,   353,     1,
     353,     1,   380,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   353,     1,   354,   356,     1,   353,   354,   353,
       1,   353,     1,   353,     1,   353,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   356,     1,   353,     1,   353,
       1,   353,     1,   353,     1,   353,     1,   353,   285,   286,
     287,   288,   290,     1,   389,   353,   353,     1,   389,     1,
     389,     1,   353,     1,   353,     1,   353,     1,   353,     1,
     353,     1,   356,     1,   356,   361,   370,   361,     1,   367,
       1,   365,     1,   367,   365,     1,   367,   365,     1,   367,
     365,     1,   367,    58,   353,   354,   399,   353,   413,   368,
     353,   349,   380,   381,   404,   370,   370,   388,   110,   111,
     112,   339,   349,   361,   361,   319,   319,   319,   319,   319,
     391,   353,   395,   406,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    22,    23,    24,    25,
      26,    27,    28,    29,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    41,    43,    47,    49,    50,    51,    52,
      53,    54,    55,    56,    59,    60,    61,    65,    66,    67,
      68,    69,    70,   304,   354,   358,   359,   362,   437,   439,
     440,   441,   445,   446,   454,   455,   457,   458,   461,   462,
     464,   468,   469,   470,   474,   406,   439,   406,   439,   406,
     439,   360,   319,   368,   439,     1,   414,   353,   361,   363,
     368,     1,   340,   353,   385,   382,   380,   356,     1,   353,
     435,     1,   435,   356,   356,     1,   356,     1,   356,     1,
     356,     1,   356,     1,   356,   368,     1,   364,     1,   364,
       1,   364,     1,   364,     1,   364,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,   305,   339,   343,   345,   346,   347,
     348,   350,   351,   352,   356,   364,   365,   389,   427,   428,
     429,   430,   431,   432,   437,   449,   454,   455,   456,   457,
     459,   461,   462,   465,   466,   467,   364,   467,   364,   467,
       1,   364,     1,   364,     1,   364,   364,     1,   364,     1,
     364,     1,   364,     1,   364,     1,   364,     1,   364,     1,
     364,     1,   364,   364,     1,   364,     1,   364,     1,   364,
       1,   364,   364,   364,   364,   364,   364,   364,   467,     1,
     364,     1,   364,     1,   364,   364,   364,   364,   364,     1,
     467,   467,     1,   364,     1,   364,     1,   364,     1,   364,
       1,   364,     1,   471,     1,   362,     1,   366,   440,   306,
     307,   308,   309,   310,   311,   312,   313,   314,   354,   451,
     452,   453,   319,   463,   362,     1,   364,   362,   368,   366,
     368,   366,   368,   366,   368,     1,   353,   356,   349,   366,
     365,   349,   381,   370,   111,   112,   370,   111,   361,   361,
     365,     1,    62,   354,   356,   363,   402,   434,     1,    62,
     356,   402,   434,     1,    62,   356,   402,   434,     1,    62,
     356,   402,   434,     1,    62,   356,   402,   434,     1,   327,
     328,   329,   332,   333,   422,   424,   422,   422,     1,   422,
     450,     1,   467,     1,   467,     1,   467,   364,   364,   364,
       1,   363,   455,   457,   461,   462,   467,   468,     1,   439,
       1,   424,     1,   334,   335,   336,   337,   422,   423,     1,
     424,   453,     1,   467,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   425,   426,   363,
     363,     1,   353,   356,     1,   356,     1,   354,   467,   356,
       1,   356,     1,   356,     1,   356,     1,   356,     1,   353,
       1,   353,   363,     1,   363,   389,   363,     1,   356,     1,
     356,     1,   356,     1,   356,   363,   363,   363,     1,   353,
     363,     1,   383,   365,   438,   440,     1,   380,     1,   353,
       1,   380,   383,   386,   363,   363,   363,   363,   365,   438,
       1,   356,     1,   356,   353,   393,   353,   393,   353,   393,
     364,   349,   367,   467,     1,   356,   454,   455,   460,   462,
     365,   365,   365,   365,   282,   282,   399,   439,   353,   385,
     356,   353,   356,   389,   356,   358,   389,   439,   363,   361,
     363,   361,   363,   361,   363,   339,   349,   361,   363,   363,
     361,   363,   361,   363,   361,   363,   361,   363,   363,   361,
     363,   361,   363,   361,   363,   361,   363,   363,   361,   363,
     361,   363,   361,   363,   361,   363,   363,   361,   363,   361,
     363,   361,   363,   361,   363,     1,   354,   467,     1,    89,
      90,    91,    92,    93,    94,   340,   384,   467,     1,   384,
     467,     1,   427,   431,   354,   447,   448,     1,   467,     1,
     467,     1,   467,   363,   363,   363,   366,   366,     1,    87,
     467,     1,   467,     1,   467,     1,    87,   353,   354,   402,
     433,   434,   467,   367,     1,   467,     1,   467,     1,   467,
       1,   467,   467,   467,   467,     1,   467,     1,   467,     1,
     467,     1,   467,     1,   467,     1,   467,     1,   467,   363,
     361,   363,   363,   361,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   439,    48,   363,   363,   363,   363,
     363,   370,   370,   363,     1,    57,    58,   366,   443,   444,
     363,   361,   363,   363,   363,   363,   363,   363,   363,   363,
     467,   472,   473,   452,   368,   361,   363,   453,   361,   439,
     439,   439,   439,   356,   356,   319,   366,   349,   111,   111,
     112,   363,   363,   363,   363,   363,   366,    63,   353,   353,
     353,     1,   354,     1,   354,   353,    63,   353,   353,   353,
     353,    63,   353,   353,   353,   353,    63,   353,   353,   353,
     353,    63,   353,   353,   353,   353,   367,   349,   363,   363,
     363,   363,   363,   361,   341,   389,   356,   356,   366,   438,
       1,   385,   380,   366,     1,   341,   442,   467,   370,   366,
     443,   353,   467,   361,   363,   393,     1,   393,   366,   366,
     366,   366,   353,   356,   353,   356,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   363,   363,   363,   363,   363,   363,   363,   363,   363,
     363,   356,   389,   447,   467,     1,   353,   402,   368,   363,
     363,   370,   370,     1,   442,   370,   439,   363,   363,   473,
     363,   363,   363,   111,   368,   368,   361,   385,   439,   370,
     370,     1,   439,   467,   439,   439,   363
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   371,   372,   373,   373,   373,   374,   374,   374,   374,
     374,   375,   374,   376,   374,   374,   377,   374,   378,   374,
     379,   374,   374,   374,   380,   380,   380,   381,   381,   382,
     382,   383,   383,   383,   383,   383,   384,   384,   384,   384,
     384,   384,   384,   385,   385,   386,   386,   386,   386,   386,
     387,   387,   387,   387,   387,   388,   388,   389,   389,   390,
     390,   391,   391,   392,   392,   393,   393,   394,   394,   395,
     395,   396,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     397,   397,   397,   397,   397,   397,   397,   397,   397,   397,
     398,   398,   399,   399,   399,   400,   400,   400,   400,   400,
     400,   400,   401,   401,   401,   401,   401,   401,   401,   401,
     401,   401,   401,   401,   401,   401,   401,   401,   401,   401,
     401,   402,   402,   403,   404,   405,   405,   406,   406,   406,
     407,   407,   408,   408,   408,   408,   409,   410,   410,   410,
     411,   411,   413,   412,   412,   412,   414,   412,   412,   415,
     416,   416,   416,   417,   418,   418,   418,   419,   420,   420,
     421,   421,   421,   421,   421,   421,   422,   422,   422,   422,
     423,   423,   423,   423,   424,   424,   425,   425,   425,   425,
     425,   425,   425,   426,   426,   426,   426,   427,   427,   427,
     428,   428,   428,   429,   429,   429,   429,   429,   430,   430,
     431,   431,   431,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   432,   432,   432,   432,   432,   432,   432,   432,
     432,   432,   433,   433,   433,   433,   434,   434,   434,   434,
     434,   435,   435,   435,   436,   436,   436,   436,   436,   437,
     438,   438,   439,   439,   439,   440,   440,   440,   440,   440,
     440,   440,   440,   441,   441,   442,   443,   443,   443,   443,
     443,   443,   443,   443,   443,   443,   443,   444,   444,   445,
     445,   445,   445,   446,   447,   447,   447,   448,   448,   450,
     449,   451,   451,   451,   451,   451,   451,   451,   451,   451,
     452,   453,   453,   454,   455,   456,   457,   458,   458,   459,
     459,   459,   460,   460,   460,   461,   462,   463,   464,   464,
     464,   465,   465,   465,   465,   465,   465,   465,   465,   465,
     465,   465,   465,   466,   466,   466,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   467,   467,   467,
     467,   467,   467,   467,   467,   467,   467,   468,   469,   469,
     469,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   470,   470,   470,   470,
     470,   470,   470,   470,   470,   470,   471,   470,   470,   472,
     472,   472,   473,   474,   474,   474,   474,   474,   474,   474,
     474,   474,   474
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     5,     3,
       1,     3,     3,     5,     3,     1,     2,     1,     2,     2,
       2,     1,     3,     1,     3,     1,     1,     2,     2,     1,
       3,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     5,     6,     7,     8,     9,
      10,     5,     6,     7,     8,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     1,     2,
       1,     1,     1,     1,     1,     5,     5,     7,     7,     5,
       8,     8,     2,     2,     2,     2,     2,     2,     3,     3,
       8,     8,     2,     8,     8,     8,     2,     2,     2,     3,
       3,     1,     1,     7,     1,     1,     3,     1,     1,     1,
       1,     1,     4,     7,     2,     2,     1,     4,     7,     2,
       1,     1,     0,     5,     2,     2,     0,     8,     5,     1,
       4,     7,     2,     1,     4,     7,     2,     1,     7,     2,
       2,     2,     2,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     3,     3,     2,     3,     3,     3,
       2,     3,     3,     3,     3,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     3,
       3,     2,     3,     3,     1,     3,     1,     3,     3,     3,
       3,     1,     1,     1,     1,     3,     3,     3,     3,     1,
       1,     3,     2,     1,     2,     2,     1,     1,     1,     2,
       2,     1,     2,     3,     5,     1,     4,     5,     3,     4,
       3,     2,     4,     5,     3,     4,     4,     2,     1,     5,
       4,     2,     5,     3,     1,     4,     4,     3,     1,     0,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     2,     5,     4,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     3,     3,     1,     1,     1,     1,     2,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     4,     4,     2,     8,     2,
       2,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     4,     4,     2,     3,     1,     1,
       1,     3,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     4,     4,     6,     6,     6,
       6,     6,     4,     2,     4,     4,     4,     4,     6,     6,
       6,     6,     6,     4,     2,     4,     4,     4,     4,     6,
       6,     6,     6,     6,     4,     2,     4,     4,     6,     2,
       4,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       6,     6,     6,     4,     2,     6,     2,     4,     4,     4,
       2,     4,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     4,     2,     4,     3,     2,     4,     3,     2,
       4,     3,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     4,     2,     4,
       3,     1,     3,     1,     3,     1,     4,     3,     1,     4,
       4,     4,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     3,     1,     3,     1,     3,     1,     3,     1,     6,
       6,     2,     4,     4,     2,     4,     0,     5,     2,     0,
       3,     1,     1,     3,     2,     1,     3,     2,     1,     1,
       3,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 651 "core/cfg.y"
                             {}
#line 5208 "core/cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 652 "core/cfg.y"
                    {}
#line 5214 "core/cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 653 "core/cfg.y"
                           { yyerror(""); YYABORT;}
#line 5220 "core/cfg.tab.c"
    break;

  case 11: /* $@1: %empty  */
#line 661 "core/cfg.y"
          {rt=REQUEST_ROUTE;}
#line 5226 "core/cfg.tab.c"
    break;

  case 13: /* $@2: %empty  */
#line 662 "core/cfg.y"
          {rt=FAILURE_ROUTE;}
#line 5232 "core/cfg.tab.c"
    break;

  case 16: /* $@3: %empty  */
#line 664 "core/cfg.y"
          {rt=BRANCH_ROUTE;}
#line 5238 "core/cfg.tab.c"
    break;

  case 18: /* $@4: %empty  */
#line 665 "core/cfg.y"
          {rt=ONSEND_ROUTE;}
#line 5244 "core/cfg.tab.c"
    break;

  case 20: /* $@5: %empty  */
#line 666 "core/cfg.y"
          {rt=EVENT_ROUTE;}
#line 5250 "core/cfg.tab.c"
    break;

  case 24: /* listen_id: ip  */
#line 671 "core/cfg.y"
           {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				(yyval.strval)=pkg_malloc(strlen(tmp)+1);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, strlen(tmp)+1);
				}
			}
		}
	}
#line 5271 "core/cfg.tab.c"
    break;

  case 25: /* listen_id: STRING  */
#line 687 "core/cfg.y"
                 {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
		}
	}
#line 5284 "core/cfg.tab.c"
    break;

  case 26: /* listen_id: host_or_if  */
#line 695 "core/cfg.y"
                     {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					strncpy((yyval.strval), (yyvsp[0].strval), strlen((yyvsp[0].strval))+1);
			}
		}
	}
#line 5299 "core/cfg.tab.c"
    break;

  case 27: /* listen_id_lst: listen_id  */
#line 709 "core/cfg.y"
                        { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5305 "core/cfg.tab.c"
    break;

  case 28: /* listen_id_lst: listen_id COMMA listen_id_lst  */
#line 710 "core/cfg.y"
                                        { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5313 "core/cfg.tab.c"
    break;

  case 29: /* listen_id2: LPAREN listen_id_lst RPAREN  */
#line 716 "core/cfg.y"
                                    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5319 "core/cfg.tab.c"
    break;

  case 30: /* listen_id2: listen_id  */
#line 717 "core/cfg.y"
                        { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5325 "core/cfg.tab.c"
    break;

  case 31: /* proto: UDP  */
#line 721 "core/cfg.y"
                { (yyval.intval)=PROTO_UDP; }
#line 5331 "core/cfg.tab.c"
    break;

  case 32: /* proto: TCP  */
#line 722 "core/cfg.y"
                { (yyval.intval)=PROTO_TCP; }
#line 5337 "core/cfg.tab.c"
    break;

  case 33: /* proto: TLS  */
#line 723 "core/cfg.y"
                { (yyval.intval)=PROTO_TLS; }
#line 5343 "core/cfg.tab.c"
    break;

  case 34: /* proto: SCTP  */
#line 724 "core/cfg.y"
                { (yyval.intval)=PROTO_SCTP; }
#line 5349 "core/cfg.tab.c"
    break;

  case 35: /* proto: STAR  */
#line 725 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5355 "core/cfg.tab.c"
    break;

  case 36: /* eqproto: UDP  */
#line 728 "core/cfg.y"
                { (yyval.intval)=PROTO_UDP; }
#line 5361 "core/cfg.tab.c"
    break;

  case 37: /* eqproto: TCP  */
#line 729 "core/cfg.y"
                { (yyval.intval)=PROTO_TCP; }
#line 5367 "core/cfg.tab.c"
    break;

  case 38: /* eqproto: TLS  */
#line 730 "core/cfg.y"
                { (yyval.intval)=PROTO_TLS; }
#line 5373 "core/cfg.tab.c"
    break;

  case 39: /* eqproto: SCTP  */
#line 731 "core/cfg.y"
                { (yyval.intval)=PROTO_SCTP; }
#line 5379 "core/cfg.tab.c"
    break;

  case 40: /* eqproto: WS  */
#line 732 "core/cfg.y"
                { (yyval.intval)=PROTO_WS; }
#line 5385 "core/cfg.tab.c"
    break;

  case 41: /* eqproto: WSS  */
#line 733 "core/cfg.y"
                { (yyval.intval)=PROTO_WSS; }
#line 5391 "core/cfg.tab.c"
    break;

  case 42: /* eqproto: STAR  */
#line 734 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5397 "core/cfg.tab.c"
    break;

  case 43: /* port: NUMBER  */
#line 737 "core/cfg.y"
                { (yyval.intval)=(yyvsp[0].intval); }
#line 5403 "core/cfg.tab.c"
    break;

  case 44: /* port: STAR  */
#line 738 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5409 "core/cfg.tab.c"
    break;

  case 45: /* phostport: listen_id  */
#line 741 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5415 "core/cfg.tab.c"
    break;

  case 46: /* phostport: listen_id COLON port  */
#line 742 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5421 "core/cfg.tab.c"
    break;

  case 47: /* phostport: proto COLON listen_id  */
#line 743 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5427 "core/cfg.tab.c"
    break;

  case 48: /* phostport: proto COLON listen_id COLON port  */
#line 744 "core/cfg.y"
                                                { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5433 "core/cfg.tab.c"
    break;

  case 49: /* phostport: listen_id COLON error  */
#line 745 "core/cfg.y"
                                { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5439 "core/cfg.tab.c"
    break;

  case 50: /* listen_phostport: listen_id2  */
#line 749 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5445 "core/cfg.tab.c"
    break;

  case 51: /* listen_phostport: listen_id2 COLON port  */
#line 750 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5451 "core/cfg.tab.c"
    break;

  case 52: /* listen_phostport: proto COLON listen_id2  */
#line 751 "core/cfg.y"
                                        { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5457 "core/cfg.tab.c"
    break;

  case 53: /* listen_phostport: proto COLON listen_id2 COLON port  */
#line 752 "core/cfg.y"
                                                { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5463 "core/cfg.tab.c"
    break;

  case 54: /* listen_phostport: listen_id2 COLON error  */
#line 753 "core/cfg.y"
                                 { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5469 "core/cfg.tab.c"
    break;

  case 55: /* id_lst: listen_phostport  */
#line 757 "core/cfg.y"
                                        {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5475 "core/cfg.tab.c"
    break;

  case 56: /* id_lst: listen_phostport id_lst  */
#line 758 "core/cfg.y"
                                        { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5481 "core/cfg.tab.c"
    break;

  case 58: /* intno: MINUS NUMBER  */
#line 762 "core/cfg.y"
                                    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5487 "core/cfg.tab.c"
    break;

  case 60: /* flags_decl: FLAGS_DECL error  */
#line 766 "core/cfg.y"
                                                 { yyerror("flag list expected\n"); }
#line 5493 "core/cfg.tab.c"
    break;

  case 63: /* flag_spec: flag_name  */
#line 772 "core/cfg.y"
                                        { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5501 "core/cfg.tab.c"
    break;

  case 64: /* flag_spec: flag_name COLON NUMBER  */
#line 775 "core/cfg.y"
                                                       {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5510 "core/cfg.tab.c"
    break;

  case 65: /* flag_name: STRING  */
#line 781 "core/cfg.y"
                                { (yyval.strval)=(yyvsp[0].strval); }
#line 5516 "core/cfg.tab.c"
    break;

  case 66: /* flag_name: ID  */
#line 782 "core/cfg.y"
                                                { (yyval.strval)=(yyvsp[0].strval); }
#line 5522 "core/cfg.tab.c"
    break;

  case 68: /* avpflags_decl: AVPFLAGS_DECL error  */
#line 787 "core/cfg.y"
                              { yyerror("avpflag list expected\n"); }
#line 5528 "core/cfg.tab.c"
    break;

  case 71: /* avpflag_spec: flag_name  */
#line 794 "core/cfg.y"
                  {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5537 "core/cfg.tab.c"
    break;

  case 72: /* assign_stm: DEBUG_V EQUAL intno  */
#line 800 "core/cfg.y"
                            { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5543 "core/cfg.tab.c"
    break;

  case 73: /* assign_stm: DEBUG_V EQUAL error  */
#line 801 "core/cfg.y"
                               { yyerror("number  expected"); }
#line 5549 "core/cfg.tab.c"
    break;

  case 74: /* assign_stm: FORK EQUAL NUMBER  */
#line 802 "core/cfg.y"
                             { dont_fork= ! (yyvsp[0].intval); }
#line 5555 "core/cfg.tab.c"
    break;

  case 75: /* assign_stm: FORK EQUAL error  */
#line 803 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 5561 "core/cfg.tab.c"
    break;

  case 76: /* assign_stm: FORK_DELAY EQUAL NUMBER  */
#line 804 "core/cfg.y"
                                   { set_fork_delay((yyvsp[0].intval)); }
#line 5567 "core/cfg.tab.c"
    break;

  case 77: /* assign_stm: FORK_DELAY EQUAL error  */
#line 805 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 5573 "core/cfg.tab.c"
    break;

  case 78: /* assign_stm: MODINIT_DELAY EQUAL NUMBER  */
#line 806 "core/cfg.y"
                                      { set_modinit_delay((yyvsp[0].intval)); }
#line 5579 "core/cfg.tab.c"
    break;

  case 79: /* assign_stm: MODINIT_DELAY EQUAL error  */
#line 807 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 5585 "core/cfg.tab.c"
    break;

  case 80: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 808 "core/cfg.y"
                                   { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5593 "core/cfg.tab.c"
    break;

  case 81: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 811 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 5599 "core/cfg.tab.c"
    break;

  case 82: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 812 "core/cfg.y"
                               {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5610 "core/cfg.tab.c"
    break;

  case 83: /* assign_stm: LOGFACILITY EQUAL error  */
#line 818 "core/cfg.y"
                                  { yyerror("ID expected"); }
#line 5616 "core/cfg.tab.c"
    break;

  case 84: /* assign_stm: LOGNAME EQUAL STRING  */
#line 819 "core/cfg.y"
                               { log_name=(yyvsp[0].strval); }
#line 5622 "core/cfg.tab.c"
    break;

  case 85: /* assign_stm: LOGNAME EQUAL error  */
#line 820 "core/cfg.y"
                              { yyerror("string value expected"); }
#line 5628 "core/cfg.tab.c"
    break;

  case 86: /* assign_stm: LOGCOLOR EQUAL NUMBER  */
#line 821 "core/cfg.y"
                                { log_color=(yyvsp[0].intval); }
#line 5634 "core/cfg.tab.c"
    break;

  case 87: /* assign_stm: LOGCOLOR EQUAL error  */
#line 822 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 5640 "core/cfg.tab.c"
    break;

  case 88: /* assign_stm: LOGPREFIX EQUAL STRING  */
#line 823 "core/cfg.y"
                                 { log_prefix_fmt=(yyvsp[0].strval); }
#line 5646 "core/cfg.tab.c"
    break;

  case 89: /* assign_stm: LOGPREFIX EQUAL error  */
#line 824 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 5652 "core/cfg.tab.c"
    break;

  case 90: /* assign_stm: LOGPREFIXMODE EQUAL NUMBER  */
#line 825 "core/cfg.y"
                                     { log_prefix_mode=(yyvsp[0].intval); }
#line 5658 "core/cfg.tab.c"
    break;

  case 91: /* assign_stm: LOGPREFIXMODE EQUAL error  */
#line 826 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 5664 "core/cfg.tab.c"
    break;

  case 92: /* assign_stm: LOGENGINETYPE EQUAL STRING  */
#line 827 "core/cfg.y"
                                     { _km_log_engine_type=(yyvsp[0].strval); }
#line 5670 "core/cfg.tab.c"
    break;

  case 93: /* assign_stm: LOGENGINETYPE EQUAL error  */
#line 828 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5676 "core/cfg.tab.c"
    break;

  case 94: /* assign_stm: LOGENGINEDATA EQUAL STRING  */
#line 829 "core/cfg.y"
                                     { _km_log_engine_data=(yyvsp[0].strval); }
#line 5682 "core/cfg.tab.c"
    break;

  case 95: /* assign_stm: LOGENGINEDATA EQUAL error  */
#line 830 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5688 "core/cfg.tab.c"
    break;

  case 96: /* assign_stm: XAVPVIAPARAMS EQUAL STRING  */
#line 831 "core/cfg.y"
                                     { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5696 "core/cfg.tab.c"
    break;

  case 97: /* assign_stm: XAVPVIAPARAMS EQUAL error  */
#line 834 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5702 "core/cfg.tab.c"
    break;

  case 98: /* assign_stm: XAVPVIAFIELDS EQUAL STRING  */
#line 835 "core/cfg.y"
                                     { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5710 "core/cfg.tab.c"
    break;

  case 99: /* assign_stm: XAVPVIAFIELDS EQUAL error  */
#line 838 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5716 "core/cfg.tab.c"
    break;

  case 100: /* assign_stm: DNS EQUAL NUMBER  */
#line 839 "core/cfg.y"
                             { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 5722 "core/cfg.tab.c"
    break;

  case 101: /* assign_stm: DNS EQUAL error  */
#line 840 "core/cfg.y"
                          { yyerror("boolean value expected"); }
#line 5728 "core/cfg.tab.c"
    break;

  case 102: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 841 "core/cfg.y"
                               { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 5734 "core/cfg.tab.c"
    break;

  case 103: /* assign_stm: REV_DNS EQUAL error  */
#line 842 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 5740 "core/cfg.tab.c"
    break;

  case 104: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 843 "core/cfg.y"
                                      { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 5746 "core/cfg.tab.c"
    break;

  case 105: /* assign_stm: DNS_TRY_IPV6 error  */
#line 844 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 5752 "core/cfg.tab.c"
    break;

  case 106: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 845 "core/cfg.y"
                                       { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 5758 "core/cfg.tab.c"
    break;

  case 107: /* assign_stm: DNS_TRY_NAPTR error  */
#line 846 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 5764 "core/cfg.tab.c"
    break;

  case 108: /* assign_stm: DNS_SRV_LB EQUAL NUMBER  */
#line 847 "core/cfg.y"
                                    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 5770 "core/cfg.tab.c"
    break;

  case 109: /* assign_stm: DNS_SRV_LB error  */
#line 848 "core/cfg.y"
                           { yyerror("boolean value expected"); }
#line 5776 "core/cfg.tab.c"
    break;

  case 110: /* assign_stm: DNS_UDP_PREF EQUAL intno  */
#line 849 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 5782 "core/cfg.tab.c"
    break;

  case 111: /* assign_stm: DNS_UDP_PREF error  */
#line 850 "core/cfg.y"
                             { yyerror("number expected"); }
#line 5788 "core/cfg.tab.c"
    break;

  case 112: /* assign_stm: DNS_TCP_PREF EQUAL intno  */
#line 851 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 5794 "core/cfg.tab.c"
    break;

  case 113: /* assign_stm: DNS_TCP_PREF error  */
#line 852 "core/cfg.y"
                             { yyerror("number expected"); }
#line 5800 "core/cfg.tab.c"
    break;

  case 114: /* assign_stm: DNS_TLS_PREF EQUAL intno  */
#line 853 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 5806 "core/cfg.tab.c"
    break;

  case 115: /* assign_stm: DNS_TLS_PREF error  */
#line 854 "core/cfg.y"
                             { yyerror("number expected"); }
#line 5812 "core/cfg.tab.c"
    break;

  case 116: /* assign_stm: DNS_SCTP_PREF EQUAL intno  */
#line 855 "core/cfg.y"
                                    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 5819 "core/cfg.tab.c"
    break;

  case 117: /* assign_stm: DNS_SCTP_PREF error  */
#line 857 "core/cfg.y"
                              { yyerror("number expected"); }
#line 5825 "core/cfg.tab.c"
    break;

  case 118: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 858 "core/cfg.y"
                                       { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 5831 "core/cfg.tab.c"
    break;

  case 119: /* assign_stm: DNS_RETR_TIME error  */
#line 859 "core/cfg.y"
                              { yyerror("number expected"); }
#line 5837 "core/cfg.tab.c"
    break;

  case 120: /* assign_stm: DNS_SLOW_QUERY_MS EQUAL NUMBER  */
#line 860 "core/cfg.y"
                                           { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 5843 "core/cfg.tab.c"
    break;

  case 121: /* assign_stm: DNS_SLOW_QUERY_MS error  */
#line 861 "core/cfg.y"
                                  { yyerror("number expected"); }
#line 5849 "core/cfg.tab.c"
    break;

  case 122: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 862 "core/cfg.y"
                                     { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 5855 "core/cfg.tab.c"
    break;

  case 123: /* assign_stm: DNS_RETR_NO error  */
#line 863 "core/cfg.y"
                            { yyerror("number expected"); }
#line 5861 "core/cfg.tab.c"
    break;

  case 124: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 864 "core/cfg.y"
                                        { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 5867 "core/cfg.tab.c"
    break;

  case 125: /* assign_stm: DNS_SERVERS_NO error  */
#line 865 "core/cfg.y"
                               { yyerror("number expected"); }
#line 5873 "core/cfg.tab.c"
    break;

  case 126: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 866 "core/cfg.y"
                                        { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 5879 "core/cfg.tab.c"
    break;

  case 127: /* assign_stm: DNS_USE_SEARCH error  */
#line 867 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 5885 "core/cfg.tab.c"
    break;

  case 128: /* assign_stm: DNS_SEARCH_FMATCH EQUAL NUMBER  */
#line 868 "core/cfg.y"
                                           { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 5891 "core/cfg.tab.c"
    break;

  case 129: /* assign_stm: DNS_SEARCH_FMATCH error  */
#line 869 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 5897 "core/cfg.tab.c"
    break;

  case 130: /* assign_stm: DNS_NAPTR_IGNORE_RFC EQUAL NUMBER  */
#line 870 "core/cfg.y"
                                              { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 5903 "core/cfg.tab.c"
    break;

  case 131: /* assign_stm: DNS_NAPTR_IGNORE_RFC error  */
#line 871 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 5909 "core/cfg.tab.c"
    break;

  case 132: /* assign_stm: DNS_CACHE_INIT EQUAL NUMBER  */
#line 872 "core/cfg.y"
                                        { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 5915 "core/cfg.tab.c"
    break;

  case 133: /* assign_stm: DNS_CACHE_INIT error  */
#line 873 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 5921 "core/cfg.tab.c"
    break;

  case 134: /* assign_stm: DNS_USE_CACHE EQUAL NUMBER  */
#line 874 "core/cfg.y"
                                       { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 5927 "core/cfg.tab.c"
    break;

  case 135: /* assign_stm: DNS_USE_CACHE error  */
#line 875 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 5933 "core/cfg.tab.c"
    break;

  case 136: /* assign_stm: DNS_USE_FAILOVER EQUAL NUMBER  */
#line 876 "core/cfg.y"
                                          { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 5939 "core/cfg.tab.c"
    break;

  case 137: /* assign_stm: DNS_USE_FAILOVER error  */
#line 877 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 5945 "core/cfg.tab.c"
    break;

  case 138: /* assign_stm: DNS_CACHE_FLAGS EQUAL NUMBER  */
#line 878 "core/cfg.y"
                                         { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 5951 "core/cfg.tab.c"
    break;

  case 139: /* assign_stm: DNS_CACHE_FLAGS error  */
#line 879 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 5957 "core/cfg.tab.c"
    break;

  case 140: /* assign_stm: DNS_CACHE_NEG_TTL EQUAL NUMBER  */
#line 880 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 5963 "core/cfg.tab.c"
    break;

  case 141: /* assign_stm: DNS_CACHE_NEG_TTL error  */
#line 881 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 5969 "core/cfg.tab.c"
    break;

  case 142: /* assign_stm: DNS_CACHE_MAX_TTL EQUAL NUMBER  */
#line 882 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 5975 "core/cfg.tab.c"
    break;

  case 143: /* assign_stm: DNS_CACHE_MAX_TTL error  */
#line 883 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 5981 "core/cfg.tab.c"
    break;

  case 144: /* assign_stm: DNS_CACHE_MIN_TTL EQUAL NUMBER  */
#line 884 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 5987 "core/cfg.tab.c"
    break;

  case 145: /* assign_stm: DNS_CACHE_MIN_TTL error  */
#line 885 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 5993 "core/cfg.tab.c"
    break;

  case 146: /* assign_stm: DNS_CACHE_MEM EQUAL NUMBER  */
#line 886 "core/cfg.y"
                                       { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 5999 "core/cfg.tab.c"
    break;

  case 147: /* assign_stm: DNS_CACHE_MEM error  */
#line 887 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6005 "core/cfg.tab.c"
    break;

  case 148: /* assign_stm: DNS_CACHE_GC_INT EQUAL NUMBER  */
#line 888 "core/cfg.y"
                                          { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 6011 "core/cfg.tab.c"
    break;

  case 149: /* assign_stm: DNS_CACHE_GC_INT error  */
#line 889 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 6017 "core/cfg.tab.c"
    break;

  case 150: /* assign_stm: DNS_CACHE_DEL_NONEXP EQUAL NUMBER  */
#line 890 "core/cfg.y"
                                              { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 6023 "core/cfg.tab.c"
    break;

  case 151: /* assign_stm: DNS_CACHE_DEL_NONEXP error  */
#line 891 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6029 "core/cfg.tab.c"
    break;

  case 152: /* assign_stm: DNS_CACHE_REC_PREF EQUAL NUMBER  */
#line 892 "core/cfg.y"
                                            { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 6035 "core/cfg.tab.c"
    break;

  case 153: /* assign_stm: DNS_CACHE_REC_PREF error  */
#line 893 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 6041 "core/cfg.tab.c"
    break;

  case 154: /* assign_stm: AUTO_BIND_IPV6 EQUAL NUMBER  */
#line 894 "core/cfg.y"
                                      {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 6047 "core/cfg.tab.c"
    break;

  case 155: /* assign_stm: AUTO_BIND_IPV6 error  */
#line 895 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 6053 "core/cfg.tab.c"
    break;

  case 156: /* assign_stm: IPV6_HEX_STYLE EQUAL STRING  */
#line 896 "core/cfg.y"
                                      {
		ksr_ipv6_hex_style.s = (yyvsp[0].strval);
		if(ksr_ipv6_hex_style.s[0]!='a' && ksr_ipv6_hex_style.s[0]!='A'
				&& ksr_ipv6_hex_style.s[0]!='c') {
			yyerror("expected \"a\", \"A\" or \"c\" value");
		}
		ksr_ipv6_hex_style.len = strlen(ksr_ipv6_hex_style.s);
	}
#line 6066 "core/cfg.tab.c"
    break;

  case 157: /* assign_stm: IPV6_HEX_STYLE error  */
#line 904 "core/cfg.y"
                               { yyerror("string value expected"); }
#line 6072 "core/cfg.tab.c"
    break;

  case 158: /* assign_stm: BIND_IPV6_LINK_LOCAL EQUAL NUMBER  */
#line 905 "core/cfg.y"
                                            {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 6078 "core/cfg.tab.c"
    break;

  case 159: /* assign_stm: BIND_IPV6_LINK_LOCAL error  */
#line 906 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6084 "core/cfg.tab.c"
    break;

  case 160: /* assign_stm: DST_BLST_INIT EQUAL NUMBER  */
#line 907 "core/cfg.y"
                                       { IF_DST_BLOCKLIST(dst_blocklist_init=(yyvsp[0].intval)); }
#line 6090 "core/cfg.tab.c"
    break;

  case 161: /* assign_stm: DST_BLST_INIT error  */
#line 908 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6096 "core/cfg.tab.c"
    break;

  case 162: /* assign_stm: USE_DST_BLST EQUAL NUMBER  */
#line 909 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.use_dst_blocklist=(yyvsp[0].intval));
	}
#line 6104 "core/cfg.tab.c"
    break;

  case 163: /* assign_stm: USE_DST_BLST error  */
#line 912 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6110 "core/cfg.tab.c"
    break;

  case 164: /* assign_stm: DST_BLST_MEM EQUAL NUMBER  */
#line 913 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 6118 "core/cfg.tab.c"
    break;

  case 165: /* assign_stm: DST_BLST_MEM error  */
#line 916 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6124 "core/cfg.tab.c"
    break;

  case 166: /* assign_stm: DST_BLST_TTL EQUAL NUMBER  */
#line 917 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 6132 "core/cfg.tab.c"
    break;

  case 167: /* assign_stm: DST_BLST_TTL error  */
#line 920 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6138 "core/cfg.tab.c"
    break;

  case 168: /* assign_stm: DST_BLST_GC_INT EQUAL NUMBER  */
#line 921 "core/cfg.y"
                                       { IF_DST_BLOCKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6144 "core/cfg.tab.c"
    break;

  case 169: /* assign_stm: DST_BLST_GC_INT error  */
#line 922 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6150 "core/cfg.tab.c"
    break;

  case 170: /* assign_stm: DST_BLST_UDP_IMASK EQUAL NUMBER  */
#line 923 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6158 "core/cfg.tab.c"
    break;

  case 171: /* assign_stm: DST_BLST_UDP_IMASK error  */
#line 926 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6164 "core/cfg.tab.c"
    break;

  case 172: /* assign_stm: DST_BLST_TCP_IMASK EQUAL NUMBER  */
#line 927 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6172 "core/cfg.tab.c"
    break;

  case 173: /* assign_stm: DST_BLST_TCP_IMASK error  */
#line 930 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6178 "core/cfg.tab.c"
    break;

  case 174: /* assign_stm: DST_BLST_TLS_IMASK EQUAL NUMBER  */
#line 931 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6186 "core/cfg.tab.c"
    break;

  case 175: /* assign_stm: DST_BLST_TLS_IMASK error  */
#line 934 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6192 "core/cfg.tab.c"
    break;

  case 176: /* assign_stm: DST_BLST_SCTP_IMASK EQUAL NUMBER  */
#line 935 "core/cfg.y"
                                           {
		IF_DST_BLOCKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6200 "core/cfg.tab.c"
    break;

  case 177: /* assign_stm: DST_BLST_SCTP_IMASK error  */
#line 938 "core/cfg.y"
                                    { yyerror("number(flags) expected"); }
#line 6206 "core/cfg.tab.c"
    break;

  case 178: /* assign_stm: IP_FREE_BIND EQUAL intno  */
#line 939 "core/cfg.y"
                                   { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6212 "core/cfg.tab.c"
    break;

  case 179: /* assign_stm: IP_FREE_BIND EQUAL error  */
#line 940 "core/cfg.y"
                                   { yyerror("int value expected"); }
#line 6218 "core/cfg.tab.c"
    break;

  case 180: /* assign_stm: PORT EQUAL NUMBER  */
#line 941 "core/cfg.y"
                              { port_no=(yyvsp[0].intval); }
#line 6224 "core/cfg.tab.c"
    break;

  case 181: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 942 "core/cfg.y"
                                 { maxbuffer=(yyvsp[0].intval); }
#line 6230 "core/cfg.tab.c"
    break;

  case 182: /* assign_stm: MAXBUFFER EQUAL error  */
#line 943 "core/cfg.y"
                                { yyerror("number expected"); }
#line 6236 "core/cfg.tab.c"
    break;

  case 183: /* assign_stm: SQL_BUFFER_SIZE EQUAL NUMBER  */
#line 944 "core/cfg.y"
                                   { sql_buffer_size=(yyvsp[0].intval); }
#line 6242 "core/cfg.tab.c"
    break;

  case 184: /* assign_stm: SQL_BUFFER_SIZE EQUAL error  */
#line 945 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 6248 "core/cfg.tab.c"
    break;

  case 185: /* assign_stm: PORT EQUAL error  */
#line 946 "core/cfg.y"
                              { yyerror("number expected"); }
#line 6254 "core/cfg.tab.c"
    break;

  case 186: /* assign_stm: CHILDREN EQUAL NUMBER  */
#line 947 "core/cfg.y"
                                { children_no=(yyvsp[0].intval); }
#line 6260 "core/cfg.tab.c"
    break;

  case 187: /* assign_stm: CHILDREN EQUAL error  */
#line 948 "core/cfg.y"
                               { yyerror("number expected"); }
#line 6266 "core/cfg.tab.c"
    break;

  case 188: /* assign_stm: STATS_NAMESEP EQUAL STRING  */
#line 949 "core/cfg.y"
                                     { ksr_stats_namesep=(yyvsp[0].strval); }
#line 6272 "core/cfg.tab.c"
    break;

  case 189: /* assign_stm: STATS_NAMESEP EQUAL error  */
#line 950 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 6278 "core/cfg.tab.c"
    break;

  case 190: /* assign_stm: SOCKET_WORKERS EQUAL NUMBER  */
#line 951 "core/cfg.y"
                                      { socket_workers=(yyvsp[0].intval); }
#line 6284 "core/cfg.tab.c"
    break;

  case 191: /* assign_stm: SOCKET_WORKERS EQUAL error  */
#line 952 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 6290 "core/cfg.tab.c"
    break;

  case 192: /* assign_stm: ASYNC_WORKERS EQUAL NUMBER  */
#line 953 "core/cfg.y"
                                     { async_task_set_workers((yyvsp[0].intval)); }
#line 6296 "core/cfg.tab.c"
    break;

  case 193: /* assign_stm: ASYNC_WORKERS EQUAL error  */
#line 954 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 6302 "core/cfg.tab.c"
    break;

  case 194: /* assign_stm: ASYNC_USLEEP EQUAL NUMBER  */
#line 955 "core/cfg.y"
                                    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6308 "core/cfg.tab.c"
    break;

  case 195: /* assign_stm: ASYNC_USLEEP EQUAL error  */
#line 956 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 6314 "core/cfg.tab.c"
    break;

  case 196: /* assign_stm: ASYNC_NONBLOCK EQUAL NUMBER  */
#line 957 "core/cfg.y"
                                      { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6320 "core/cfg.tab.c"
    break;

  case 197: /* assign_stm: ASYNC_NONBLOCK EQUAL error  */
#line 958 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 6326 "core/cfg.tab.c"
    break;

  case 198: /* assign_stm: ASYNC_WORKERS_GROUP EQUAL STRING  */
#line 959 "core/cfg.y"
                                           { async_task_set_workers_group((yyvsp[0].strval)); }
#line 6332 "core/cfg.tab.c"
    break;

  case 199: /* assign_stm: ASYNC_WORKERS_GROUP EQUAL error  */
#line 960 "core/cfg.y"
                                          { yyerror("string expected"); }
#line 6338 "core/cfg.tab.c"
    break;

  case 200: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 961 "core/cfg.y"
                                 { check_via=(yyvsp[0].intval); }
#line 6344 "core/cfg.tab.c"
    break;

  case 201: /* assign_stm: CHECK_VIA EQUAL error  */
#line 962 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6350 "core/cfg.tab.c"
    break;

  case 202: /* assign_stm: PHONE2TEL EQUAL NUMBER  */
#line 963 "core/cfg.y"
                                 { phone2tel=(yyvsp[0].intval); }
#line 6356 "core/cfg.tab.c"
    break;

  case 203: /* assign_stm: PHONE2TEL EQUAL error  */
#line 964 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6362 "core/cfg.tab.c"
    break;

  case 204: /* assign_stm: MEMLOG EQUAL intno  */
#line 965 "core/cfg.y"
                             { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6368 "core/cfg.tab.c"
    break;

  case 205: /* assign_stm: MEMLOG EQUAL error  */
#line 966 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6374 "core/cfg.tab.c"
    break;

  case 206: /* assign_stm: MEMDBG EQUAL intno  */
#line 967 "core/cfg.y"
                             { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6380 "core/cfg.tab.c"
    break;

  case 207: /* assign_stm: MEMDBG EQUAL error  */
#line 968 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6386 "core/cfg.tab.c"
    break;

  case 208: /* assign_stm: MEMSUM EQUAL intno  */
#line 969 "core/cfg.y"
                             { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6392 "core/cfg.tab.c"
    break;

  case 209: /* assign_stm: MEMSUM EQUAL error  */
#line 970 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6398 "core/cfg.tab.c"
    break;

  case 210: /* assign_stm: MEMSAFETY EQUAL intno  */
#line 971 "core/cfg.y"
                                { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6404 "core/cfg.tab.c"
    break;

  case 211: /* assign_stm: MEMSAFETY EQUAL error  */
#line 972 "core/cfg.y"
                                { yyerror("int value expected"); }
#line 6410 "core/cfg.tab.c"
    break;

  case 212: /* assign_stm: MEMJOIN EQUAL intno  */
#line 973 "core/cfg.y"
                              { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6416 "core/cfg.tab.c"
    break;

  case 213: /* assign_stm: MEMJOIN EQUAL error  */
#line 974 "core/cfg.y"
                              { yyerror("int value expected"); }
#line 6422 "core/cfg.tab.c"
    break;

  case 214: /* assign_stm: MEMSTATUSMODE EQUAL intno  */
#line 975 "core/cfg.y"
                                    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6428 "core/cfg.tab.c"
    break;

  case 215: /* assign_stm: MEMSTATUSMODE EQUAL error  */
#line 976 "core/cfg.y"
                                    { yyerror("int value expected"); }
#line 6434 "core/cfg.tab.c"
    break;

  case 216: /* assign_stm: SIP_PARSER_LOG_ONELINE EQUAL intno  */
#line 977 "core/cfg.y"
                                             { default_core_cfg.sip_parser_log_oneline=(yyvsp[0].intval); }
#line 6440 "core/cfg.tab.c"
    break;

  case 217: /* assign_stm: SIP_PARSER_LOG_ONELINE EQUAL error  */
#line 978 "core/cfg.y"
                                             { yyerror("int value expected"); }
#line 6446 "core/cfg.tab.c"
    break;

  case 218: /* assign_stm: SIP_PARSER_LOG EQUAL intno  */
#line 979 "core/cfg.y"
                                     { default_core_cfg.sip_parser_log=(yyvsp[0].intval); }
#line 6452 "core/cfg.tab.c"
    break;

  case 219: /* assign_stm: SIP_PARSER_LOG EQUAL error  */
#line 980 "core/cfg.y"
                                     { yyerror("int value expected"); }
#line 6458 "core/cfg.tab.c"
    break;

  case 220: /* assign_stm: SIP_PARSER_MODE EQUAL intno  */
#line 981 "core/cfg.y"
                                      { ksr_sip_parser_mode=(yyvsp[0].intval); }
#line 6464 "core/cfg.tab.c"
    break;

  case 221: /* assign_stm: SIP_PARSER_MODE EQUAL error  */
#line 982 "core/cfg.y"
                                      { yyerror("int value expected"); }
#line 6470 "core/cfg.tab.c"
    break;

  case 222: /* assign_stm: CORELOG EQUAL intno  */
#line 983 "core/cfg.y"
                              { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6476 "core/cfg.tab.c"
    break;

  case 223: /* assign_stm: CORELOG EQUAL error  */
#line 984 "core/cfg.y"
                              { yyerror("int value expected"); }
#line 6482 "core/cfg.tab.c"
    break;

  case 224: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 985 "core/cfg.y"
                                   { sip_warning=(yyvsp[0].intval); }
#line 6488 "core/cfg.tab.c"
    break;

  case 225: /* assign_stm: SIP_WARNING EQUAL error  */
#line 986 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6494 "core/cfg.tab.c"
    break;

  case 226: /* assign_stm: VERSION_TABLE_CFG EQUAL STRING  */
#line 987 "core/cfg.y"
                                         { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6502 "core/cfg.tab.c"
    break;

  case 227: /* assign_stm: VERSION_TABLE_CFG EQUAL error  */
#line 990 "core/cfg.y"
                                        { yyerror("string value expected"); }
#line 6508 "core/cfg.tab.c"
    break;

  case 228: /* assign_stm: USER EQUAL STRING  */
#line 991 "core/cfg.y"
                                {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6520 "core/cfg.tab.c"
    break;

  case 229: /* assign_stm: USER EQUAL ID  */
#line 998 "core/cfg.y"
                                {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6532 "core/cfg.tab.c"
    break;

  case 230: /* assign_stm: USER EQUAL error  */
#line 1005 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 6538 "core/cfg.tab.c"
    break;

  case 231: /* assign_stm: GROUP EQUAL STRING  */
#line 1006 "core/cfg.y"
                                 { group=(yyvsp[0].strval); }
#line 6544 "core/cfg.tab.c"
    break;

  case 232: /* assign_stm: GROUP EQUAL ID  */
#line 1007 "core/cfg.y"
                                 { group=(yyvsp[0].strval); }
#line 6550 "core/cfg.tab.c"
    break;

  case 233: /* assign_stm: GROUP EQUAL error  */
#line 1008 "core/cfg.y"
                                 { yyerror("string value expected"); }
#line 6556 "core/cfg.tab.c"
    break;

  case 234: /* assign_stm: CHROOT EQUAL STRING  */
#line 1009 "core/cfg.y"
                                  { chroot_dir=(yyvsp[0].strval); }
#line 6562 "core/cfg.tab.c"
    break;

  case 235: /* assign_stm: CHROOT EQUAL ID  */
#line 1010 "core/cfg.y"
                                  { chroot_dir=(yyvsp[0].strval); }
#line 6568 "core/cfg.tab.c"
    break;

  case 236: /* assign_stm: CHROOT EQUAL error  */
#line 1011 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 6574 "core/cfg.tab.c"
    break;

  case 237: /* assign_stm: WDIR EQUAL STRING  */
#line 1012 "core/cfg.y"
                                { working_dir=(yyvsp[0].strval); }
#line 6580 "core/cfg.tab.c"
    break;

  case 238: /* assign_stm: WDIR EQUAL ID  */
#line 1013 "core/cfg.y"
                                { working_dir=(yyvsp[0].strval); }
#line 6586 "core/cfg.tab.c"
    break;

  case 239: /* assign_stm: WDIR EQUAL error  */
#line 1014 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 6592 "core/cfg.tab.c"
    break;

  case 240: /* assign_stm: RUNDIR EQUAL STRING  */
#line 1015 "core/cfg.y"
                                  { runtime_dir=(yyvsp[0].strval); }
#line 6598 "core/cfg.tab.c"
    break;

  case 241: /* assign_stm: RUNDIR EQUAL ID  */
#line 1016 "core/cfg.y"
                                  { runtime_dir=(yyvsp[0].strval); }
#line 6604 "core/cfg.tab.c"
    break;

  case 242: /* assign_stm: RUNDIR EQUAL error  */
#line 1017 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 6610 "core/cfg.tab.c"
    break;

  case 243: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 1018 "core/cfg.y"
                              { mhomed=(yyvsp[0].intval); }
#line 6616 "core/cfg.tab.c"
    break;

  case 244: /* assign_stm: MHOMED EQUAL error  */
#line 1019 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6622 "core/cfg.tab.c"
    break;

  case 245: /* assign_stm: DISABLE_TCP EQUAL NUMBER  */
#line 1020 "core/cfg.y"
                                   {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6634 "core/cfg.tab.c"
    break;

  case 246: /* assign_stm: DISABLE_TCP EQUAL error  */
#line 1027 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6640 "core/cfg.tab.c"
    break;

  case 247: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 1028 "core/cfg.y"
                                          {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6652 "core/cfg.tab.c"
    break;

  case 248: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 1035 "core/cfg.y"
                                         { yyerror("boolean value expected"); }
#line 6658 "core/cfg.tab.c"
    break;

  case 249: /* assign_stm: TCP_ACCEPT_UNIQUE EQUAL NUMBER  */
#line 1036 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6670 "core/cfg.tab.c"
    break;

  case 250: /* assign_stm: TCP_ACCEPT_UNIQUE EQUAL error  */
#line 1043 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 6676 "core/cfg.tab.c"
    break;

  case 251: /* assign_stm: TCP_CONNECTION_MATCH EQUAL NUMBER  */
#line 1044 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6688 "core/cfg.tab.c"
    break;

  case 252: /* assign_stm: TCP_CONNECTION_MATCH EQUAL error  */
#line 1051 "core/cfg.y"
                                           { yyerror("number expected"); }
#line 6694 "core/cfg.tab.c"
    break;

  case 253: /* assign_stm: TCP_CHILDREN EQUAL NUMBER  */
#line 1052 "core/cfg.y"
                                    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6706 "core/cfg.tab.c"
    break;

  case 254: /* assign_stm: TCP_CHILDREN EQUAL error  */
#line 1059 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 6712 "core/cfg.tab.c"
    break;

  case 255: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL intno  */
#line 1060 "core/cfg.y"
                                          {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6724 "core/cfg.tab.c"
    break;

  case 256: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 1067 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 6730 "core/cfg.tab.c"
    break;

  case 257: /* assign_stm: TCP_SEND_TIMEOUT EQUAL intno  */
#line 1068 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6742 "core/cfg.tab.c"
    break;

  case 258: /* assign_stm: TCP_SEND_TIMEOUT EQUAL error  */
#line 1075 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 6748 "core/cfg.tab.c"
    break;

  case 259: /* assign_stm: TCP_CON_LIFETIME EQUAL intno  */
#line 1076 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6763 "core/cfg.tab.c"
    break;

  case 260: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 1086 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 6769 "core/cfg.tab.c"
    break;

  case 261: /* assign_stm: TCP_POLL_METHOD EQUAL ID  */
#line 1087 "core/cfg.y"
                                   {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6788 "core/cfg.tab.c"
    break;

  case 262: /* assign_stm: TCP_POLL_METHOD EQUAL STRING  */
#line 1101 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6807 "core/cfg.tab.c"
    break;

  case 263: /* assign_stm: TCP_POLL_METHOD EQUAL error  */
#line 1115 "core/cfg.y"
                                      { yyerror("poll method name expected"); }
#line 6813 "core/cfg.tab.c"
    break;

  case 264: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1116 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6825 "core/cfg.tab.c"
    break;

  case 265: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 1123 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 6831 "core/cfg.tab.c"
    break;

  case 266: /* assign_stm: TLS_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1124 "core/cfg.y"
                                           {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 6843 "core/cfg.tab.c"
    break;

  case 267: /* assign_stm: TLS_MAX_CONNECTIONS EQUAL error  */
#line 1131 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 6849 "core/cfg.tab.c"
    break;

  case 268: /* assign_stm: TCP_NO_CONNECT EQUAL NUMBER  */
#line 1132 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6861 "core/cfg.tab.c"
    break;

  case 269: /* assign_stm: TCP_NO_CONNECT EQUAL error  */
#line 1139 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6867 "core/cfg.tab.c"
    break;

  case 270: /* assign_stm: TCP_SOURCE_IPV4 EQUAL ipv4  */
#line 1140 "core/cfg.y"
                                     {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6881 "core/cfg.tab.c"
    break;

  case 271: /* assign_stm: TCP_SOURCE_IPV4 EQUAL error  */
#line 1149 "core/cfg.y"
                                      { yyerror("IPv4 address expected"); }
#line 6887 "core/cfg.tab.c"
    break;

  case 272: /* assign_stm: TCP_SOURCE_IPV6 EQUAL ipv6  */
#line 1150 "core/cfg.y"
                                     {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 6901 "core/cfg.tab.c"
    break;

  case 273: /* assign_stm: TCP_SOURCE_IPV6 EQUAL error  */
#line 1159 "core/cfg.y"
                                      { yyerror("IPv6 address expected"); }
#line 6907 "core/cfg.tab.c"
    break;

  case 274: /* assign_stm: TCP_OPT_FD_CACHE EQUAL NUMBER  */
#line 1160 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6919 "core/cfg.tab.c"
    break;

  case 275: /* assign_stm: TCP_OPT_FD_CACHE EQUAL error  */
#line 1167 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 6925 "core/cfg.tab.c"
    break;

  case 276: /* assign_stm: TCP_OPT_BUF_WRITE EQUAL NUMBER  */
#line 1168 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6937 "core/cfg.tab.c"
    break;

  case 277: /* assign_stm: TCP_OPT_BUF_WRITE EQUAL error  */
#line 1175 "core/cfg.y"
                                        { yyerror("boolean value expected"); }
#line 6943 "core/cfg.tab.c"
    break;

  case 278: /* assign_stm: TCP_OPT_CONN_WQ_MAX EQUAL NUMBER  */
#line 1176 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6955 "core/cfg.tab.c"
    break;

  case 279: /* assign_stm: TCP_OPT_CONN_WQ_MAX error  */
#line 1183 "core/cfg.y"
                                    { yyerror("boolean value expected"); }
#line 6961 "core/cfg.tab.c"
    break;

  case 280: /* assign_stm: TCP_OPT_WQ_MAX EQUAL NUMBER  */
#line 1184 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6973 "core/cfg.tab.c"
    break;

  case 281: /* assign_stm: TCP_OPT_WQ_MAX error  */
#line 1191 "core/cfg.y"
                               { yyerror("number expected"); }
#line 6979 "core/cfg.tab.c"
    break;

  case 282: /* assign_stm: TCP_OPT_RD_BUF EQUAL NUMBER  */
#line 1192 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 6991 "core/cfg.tab.c"
    break;

  case 283: /* assign_stm: TCP_OPT_RD_BUF error  */
#line 1199 "core/cfg.y"
                               { yyerror("number expected"); }
#line 6997 "core/cfg.tab.c"
    break;

  case 284: /* assign_stm: TCP_OPT_WQ_BLK EQUAL NUMBER  */
#line 1200 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7009 "core/cfg.tab.c"
    break;

  case 285: /* assign_stm: TCP_OPT_WQ_BLK error  */
#line 1207 "core/cfg.y"
                               { yyerror("number expected"); }
#line 7015 "core/cfg.tab.c"
    break;

  case 286: /* assign_stm: TCP_OPT_DEFER_ACCEPT EQUAL NUMBER  */
#line 1208 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7027 "core/cfg.tab.c"
    break;

  case 287: /* assign_stm: TCP_OPT_DEFER_ACCEPT EQUAL error  */
#line 1215 "core/cfg.y"
                                           { yyerror("boolean value expected"); }
#line 7033 "core/cfg.tab.c"
    break;

  case 288: /* assign_stm: TCP_OPT_DELAYED_ACK EQUAL NUMBER  */
#line 1216 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7045 "core/cfg.tab.c"
    break;

  case 289: /* assign_stm: TCP_OPT_DELAYED_ACK EQUAL error  */
#line 1223 "core/cfg.y"
                                          { yyerror("boolean value expected"); }
#line 7051 "core/cfg.tab.c"
    break;

  case 290: /* assign_stm: TCP_OPT_SYNCNT EQUAL NUMBER  */
#line 1224 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7063 "core/cfg.tab.c"
    break;

  case 291: /* assign_stm: TCP_OPT_SYNCNT EQUAL error  */
#line 1231 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 7069 "core/cfg.tab.c"
    break;

  case 292: /* assign_stm: TCP_OPT_LINGER2 EQUAL NUMBER  */
#line 1232 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7081 "core/cfg.tab.c"
    break;

  case 293: /* assign_stm: TCP_OPT_LINGER2 EQUAL error  */
#line 1239 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7087 "core/cfg.tab.c"
    break;

  case 294: /* assign_stm: TCP_OPT_KEEPALIVE EQUAL NUMBER  */
#line 1240 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7099 "core/cfg.tab.c"
    break;

  case 295: /* assign_stm: TCP_OPT_KEEPALIVE EQUAL error  */
#line 1247 "core/cfg.y"
                                        { yyerror("boolean value expected");}
#line 7105 "core/cfg.tab.c"
    break;

  case 296: /* assign_stm: TCP_OPT_KEEPIDLE EQUAL NUMBER  */
#line 1248 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7117 "core/cfg.tab.c"
    break;

  case 297: /* assign_stm: TCP_OPT_KEEPIDLE EQUAL error  */
#line 1255 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7123 "core/cfg.tab.c"
    break;

  case 298: /* assign_stm: TCP_OPT_KEEPINTVL EQUAL NUMBER  */
#line 1256 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7135 "core/cfg.tab.c"
    break;

  case 299: /* assign_stm: TCP_OPT_KEEPINTVL EQUAL error  */
#line 1263 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 7141 "core/cfg.tab.c"
    break;

  case 300: /* assign_stm: TCP_OPT_KEEPCNT EQUAL NUMBER  */
#line 1264 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7153 "core/cfg.tab.c"
    break;

  case 301: /* assign_stm: TCP_OPT_KEEPCNT EQUAL error  */
#line 1271 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7159 "core/cfg.tab.c"
    break;

  case 302: /* assign_stm: TCP_OPT_CRLF_PING EQUAL NUMBER  */
#line 1272 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7171 "core/cfg.tab.c"
    break;

  case 303: /* assign_stm: TCP_OPT_CRLF_PING EQUAL error  */
#line 1279 "core/cfg.y"
                                        { yyerror("boolean value expected"); }
#line 7177 "core/cfg.tab.c"
    break;

  case 304: /* assign_stm: TCP_OPT_ACCEPT_NO_CL EQUAL NUMBER  */
#line 1280 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7189 "core/cfg.tab.c"
    break;

  case 305: /* assign_stm: TCP_OPT_ACCEPT_NO_CL EQUAL error  */
#line 1287 "core/cfg.y"
                                           { yyerror("boolean value expected"); }
#line 7195 "core/cfg.tab.c"
    break;

  case 306: /* assign_stm: TCP_OPT_ACCEPT_HEP3 EQUAL NUMBER  */
#line 1288 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7207 "core/cfg.tab.c"
    break;

  case 307: /* assign_stm: TCP_OPT_ACCEPT_HEP3 EQUAL error  */
#line 1295 "core/cfg.y"
                                          { yyerror("boolean value expected"); }
#line 7213 "core/cfg.tab.c"
    break;

  case 308: /* assign_stm: TCP_OPT_ACCEPT_HAPROXY EQUAL NUMBER  */
#line 1296 "core/cfg.y"
                                              {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7225 "core/cfg.tab.c"
    break;

  case 309: /* assign_stm: TCP_OPT_ACCEPT_HAPROXY EQUAL error  */
#line 1303 "core/cfg.y"
                                             { yyerror("boolean value expected"); }
#line 7231 "core/cfg.tab.c"
    break;

  case 310: /* assign_stm: TCP_CLONE_RCVBUF EQUAL NUMBER  */
#line 1305 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7243 "core/cfg.tab.c"
    break;

  case 311: /* assign_stm: TCP_CLONE_RCVBUF EQUAL error  */
#line 1312 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7249 "core/cfg.tab.c"
    break;

  case 312: /* assign_stm: TCP_REUSE_PORT EQUAL NUMBER  */
#line 1313 "core/cfg.y"
                                      {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7265 "core/cfg.tab.c"
    break;

  case 313: /* assign_stm: TCP_REUSE_PORT EQUAL error  */
#line 1324 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 7271 "core/cfg.tab.c"
    break;

  case 314: /* assign_stm: TCP_WAIT_DATA EQUAL intno  */
#line 1325 "core/cfg.y"
                                    {
		#ifdef USE_TCP
			tcp_default_cfg.wait_data_ms=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7283 "core/cfg.tab.c"
    break;

  case 315: /* assign_stm: TCP_WAIT_DATA EQUAL error  */
#line 1332 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 7289 "core/cfg.tab.c"
    break;

  case 316: /* assign_stm: TCP_SCRIPT_MODE EQUAL intno  */
#line 1333 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			ksr_tcp_script_mode=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7301 "core/cfg.tab.c"
    break;

  case 317: /* assign_stm: TCP_SCRIPT_MODE EQUAL error  */
#line 1340 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7307 "core/cfg.tab.c"
    break;

  case 318: /* assign_stm: DISABLE_TLS EQUAL NUMBER  */
#line 1341 "core/cfg.y"
                                   {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7319 "core/cfg.tab.c"
    break;

  case 319: /* assign_stm: DISABLE_TLS EQUAL error  */
#line 1348 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 7325 "core/cfg.tab.c"
    break;

  case 320: /* assign_stm: ENABLE_TLS EQUAL NUMBER  */
#line 1349 "core/cfg.y"
                                  {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7337 "core/cfg.tab.c"
    break;

  case 321: /* assign_stm: ENABLE_TLS EQUAL error  */
#line 1356 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 7343 "core/cfg.tab.c"
    break;

  case 322: /* assign_stm: TLSLOG EQUAL NUMBER  */
#line 1357 "core/cfg.y"
                              {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7355 "core/cfg.tab.c"
    break;

  case 323: /* assign_stm: TLSLOG EQUAL error  */
#line 1364 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 7361 "core/cfg.tab.c"
    break;

  case 324: /* assign_stm: TLS_PORT_NO EQUAL NUMBER  */
#line 1365 "core/cfg.y"
                                   {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7373 "core/cfg.tab.c"
    break;

  case 325: /* assign_stm: TLS_PORT_NO EQUAL error  */
#line 1372 "core/cfg.y"
                                  { yyerror("number expected"); }
#line 7379 "core/cfg.tab.c"
    break;

  case 326: /* assign_stm: TLS_METHOD EQUAL SSLv23  */
#line 1373 "core/cfg.y"
                                  {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7391 "core/cfg.tab.c"
    break;

  case 327: /* assign_stm: TLS_METHOD EQUAL SSLv2  */
#line 1380 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7403 "core/cfg.tab.c"
    break;

  case 328: /* assign_stm: TLS_METHOD EQUAL SSLv3  */
#line 1387 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7415 "core/cfg.tab.c"
    break;

  case 329: /* assign_stm: TLS_METHOD EQUAL TLSv1  */
#line 1394 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7427 "core/cfg.tab.c"
    break;

  case 330: /* assign_stm: TLS_METHOD EQUAL error  */
#line 1401 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7439 "core/cfg.tab.c"
    break;

  case 331: /* assign_stm: TLS_VERIFY EQUAL NUMBER  */
#line 1408 "core/cfg.y"
                                  {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7451 "core/cfg.tab.c"
    break;

  case 332: /* assign_stm: TLS_VERIFY EQUAL error  */
#line 1415 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 7457 "core/cfg.tab.c"
    break;

  case 333: /* assign_stm: TLS_REQUIRE_CERTIFICATE EQUAL NUMBER  */
#line 1416 "core/cfg.y"
                                               {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7469 "core/cfg.tab.c"
    break;

  case 334: /* assign_stm: TLS_REQUIRE_CERTIFICATE EQUAL error  */
#line 1423 "core/cfg.y"
                                              { yyerror("boolean value expected"); }
#line 7475 "core/cfg.tab.c"
    break;

  case 335: /* assign_stm: TLS_CERTIFICATE EQUAL STRING  */
#line 1424 "core/cfg.y"
                                       {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7487 "core/cfg.tab.c"
    break;

  case 336: /* assign_stm: TLS_CERTIFICATE EQUAL error  */
#line 1431 "core/cfg.y"
                                      { yyerror("string value expected"); }
#line 7493 "core/cfg.tab.c"
    break;

  case 337: /* assign_stm: TLS_PRIVATE_KEY EQUAL STRING  */
#line 1432 "core/cfg.y"
                                       {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7505 "core/cfg.tab.c"
    break;

  case 338: /* assign_stm: TLS_PRIVATE_KEY EQUAL error  */
#line 1439 "core/cfg.y"
                                      { yyerror("string value expected"); }
#line 7511 "core/cfg.tab.c"
    break;

  case 339: /* assign_stm: TLS_CA_LIST EQUAL STRING  */
#line 1440 "core/cfg.y"
                                   {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7523 "core/cfg.tab.c"
    break;

  case 340: /* assign_stm: TLS_CA_LIST EQUAL error  */
#line 1447 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 7529 "core/cfg.tab.c"
    break;

  case 341: /* assign_stm: TLS_HANDSHAKE_TIMEOUT EQUAL NUMBER  */
#line 1448 "core/cfg.y"
                                             {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7541 "core/cfg.tab.c"
    break;

  case 342: /* assign_stm: TLS_HANDSHAKE_TIMEOUT EQUAL error  */
#line 1455 "core/cfg.y"
                                            { yyerror("number expected"); }
#line 7547 "core/cfg.tab.c"
    break;

  case 343: /* assign_stm: TLS_SEND_TIMEOUT EQUAL NUMBER  */
#line 1456 "core/cfg.y"
                                        {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7559 "core/cfg.tab.c"
    break;

  case 344: /* assign_stm: TLS_SEND_TIMEOUT EQUAL error  */
#line 1463 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7565 "core/cfg.tab.c"
    break;

  case 345: /* assign_stm: DISABLE_SCTP EQUAL NUMBER  */
#line 1464 "core/cfg.y"
                                    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7577 "core/cfg.tab.c"
    break;

  case 346: /* assign_stm: DISABLE_SCTP EQUAL error  */
#line 1471 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 7583 "core/cfg.tab.c"
    break;

  case 347: /* assign_stm: ENABLE_SCTP EQUAL NUMBER  */
#line 1472 "core/cfg.y"
                                   {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7595 "core/cfg.tab.c"
    break;

  case 348: /* assign_stm: ENABLE_SCTP EQUAL error  */
#line 1479 "core/cfg.y"
                                  { yyerror("boolean or number expected"); }
#line 7601 "core/cfg.tab.c"
    break;

  case 349: /* assign_stm: SCTP_CHILDREN EQUAL NUMBER  */
#line 1480 "core/cfg.y"
                                     {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7613 "core/cfg.tab.c"
    break;

  case 350: /* assign_stm: SCTP_CHILDREN EQUAL error  */
#line 1487 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 7619 "core/cfg.tab.c"
    break;

  case 351: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1488 "core/cfg.y"
                                        { server_signature=(yyvsp[0].intval); }
#line 7625 "core/cfg.tab.c"
    break;

  case 352: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1489 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 7631 "core/cfg.tab.c"
    break;

  case 353: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1490 "core/cfg.y"
                                     { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 7639 "core/cfg.tab.c"
    break;

  case 354: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1493 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 7645 "core/cfg.tab.c"
    break;

  case 355: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1494 "core/cfg.y"
                                         { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 7653 "core/cfg.tab.c"
    break;

  case 356: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1497 "core/cfg.y"
                                        { yyerror("string value expected"); }
#line 7659 "core/cfg.tab.c"
    break;

  case 357: /* assign_stm: URI_HOST_EXTRA_CHARS EQUAL STRING  */
#line 1498 "core/cfg.y"
                                            { _sr_uri_host_extra_chars=(yyvsp[0].strval); }
#line 7665 "core/cfg.tab.c"
    break;

  case 358: /* assign_stm: URI_HOST_EXTRA_CHARS EQUAL error  */
#line 1499 "core/cfg.y"
                                           { yyerror("string value expected"); }
#line 7671 "core/cfg.tab.c"
    break;

  case 359: /* assign_stm: HDR_NAME_EXTRA_CHARS EQUAL STRING  */
#line 1500 "core/cfg.y"
                                            { _ksr_hname_extra_chars=(unsigned char*)(yyvsp[0].strval); }
#line 7677 "core/cfg.tab.c"
    break;

  case 360: /* assign_stm: HDR_NAME_EXTRA_CHARS EQUAL error  */
#line 1501 "core/cfg.y"
                                           { yyerror("string value expected"); }
#line 7683 "core/cfg.tab.c"
    break;

  case 361: /* assign_stm: REPLY_TO_VIA EQUAL NUMBER  */
#line 1502 "core/cfg.y"
                                    { reply_to_via=(yyvsp[0].intval); }
#line 7689 "core/cfg.tab.c"
    break;

  case 362: /* assign_stm: REPLY_TO_VIA EQUAL error  */
#line 1503 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 7695 "core/cfg.tab.c"
    break;

  case 363: /* assign_stm: LISTEN EQUAL id_lst  */
#line 1504 "core/cfg.y"
                              {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7712 "core/cfg.tab.c"
    break;

  case 364: /* assign_stm: LISTEN EQUAL id_lst VIRTUAL  */
#line 1516 "core/cfg.y"
                                      {
                for(lst_tmp=(yyvsp[-1].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface(   lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-1].sockid));
        }
#line 7730 "core/cfg.tab.c"
    break;

  case 365: /* assign_stm: LISTEN EQUAL id_lst STRNAME STRING  */
#line 1529 "core/cfg.y"
                                             {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7747 "core/cfg.tab.c"
    break;

  case 366: /* assign_stm: LISTEN EQUAL id_lst STRNAME STRING VIRTUAL  */
#line 1541 "core/cfg.y"
                                                     {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
                        lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 7765 "core/cfg.tab.c"
    break;

  case 367: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER  */
#line 1554 "core/cfg.y"
                                                               {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7783 "core/cfg.tab.c"
    break;

  case 368: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER VIRTUAL  */
#line 1567 "core/cfg.y"
                                                                       {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-3].strval), (yyvsp[-1].intval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 7802 "core/cfg.tab.c"
    break;

  case 369: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER STRNAME STRING  */
#line 1581 "core/cfg.y"
                                                                              {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 7820 "core/cfg.tab.c"
    break;

  case 370: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER STRNAME STRING VIRTUAL  */
#line 1594 "core/cfg.y"
                                                                                      {
                for(lst_tmp=(yyvsp[-7].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-5].strval), (yyvsp[-3].intval), (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-7].sockid));
        }
#line 7839 "core/cfg.tab.c"
    break;

  case 371: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id  */
#line 1608 "core/cfg.y"
                                                  {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 7857 "core/cfg.tab.c"
    break;

  case 372: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id VIRTUAL  */
#line 1621 "core/cfg.y"
                                                          {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-1].strval), 0,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 7876 "core/cfg.tab.c"
    break;

  case 373: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id STRNAME STRING  */
#line 1635 "core/cfg.y"
                                                                 {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 7894 "core/cfg.tab.c"
    break;

  case 374: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id STRNAME STRING VIRTUAL  */
#line 1648 "core/cfg.y"
                                                                         {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-3].strval), 0, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 7913 "core/cfg.tab.c"
    break;

  case 375: /* assign_stm: LISTEN EQUAL error  */
#line 1662 "core/cfg.y"
                              { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 7920 "core/cfg.tab.c"
    break;

  case 376: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1664 "core/cfg.y"
                              {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 7936 "core/cfg.tab.c"
    break;

  case 377: /* assign_stm: ALIAS EQUAL error  */
#line 1675 "core/cfg.y"
                              { yyerror("hostname expected"); }
#line 7942 "core/cfg.tab.c"
    break;

  case 378: /* assign_stm: SR_AUTO_ALIASES EQUAL NUMBER  */
#line 1676 "core/cfg.y"
                                       { sr_auto_aliases=(yyvsp[0].intval); }
#line 7948 "core/cfg.tab.c"
    break;

  case 379: /* assign_stm: SR_AUTO_ALIASES EQUAL error  */
#line 1677 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 7954 "core/cfg.tab.c"
    break;

  case 380: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1678 "core/cfg.y"
                                             {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 7965 "core/cfg.tab.c"
    break;

  case 381: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1684 "core/cfg.y"
                                         {yyerror("ip address or hostname expected"); }
#line 7971 "core/cfg.tab.c"
    break;

  case 382: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1685 "core/cfg.y"
                                       {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 7986 "core/cfg.tab.c"
    break;

  case 383: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1695 "core/cfg.y"
                                     {yyerror("ip address or hostname expected"); }
#line 7992 "core/cfg.tab.c"
    break;

  case 384: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1696 "core/cfg.y"
                                    { disable_core_dump=(yyvsp[0].intval); }
#line 7998 "core/cfg.tab.c"
    break;

  case 385: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1697 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 8004 "core/cfg.tab.c"
    break;

  case 386: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1698 "core/cfg.y"
                                     { open_files_limit=(yyvsp[0].intval); }
#line 8010 "core/cfg.tab.c"
    break;

  case 387: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1699 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 8016 "core/cfg.tab.c"
    break;

  case 388: /* assign_stm: SHM_MEM_SZ EQUAL NUMBER  */
#line 1700 "core/cfg.y"
                                  {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 8028 "core/cfg.tab.c"
    break;

  case 389: /* assign_stm: SHM_MEM_SZ EQUAL error  */
#line 1707 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8034 "core/cfg.tab.c"
    break;

  case 390: /* assign_stm: SHM_FORCE_ALLOC EQUAL NUMBER  */
#line 1708 "core/cfg.y"
                                       {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 8046 "core/cfg.tab.c"
    break;

  case 391: /* assign_stm: SHM_FORCE_ALLOC EQUAL error  */
#line 1715 "core/cfg.y"
                                      { yyerror("boolean value expected"); }
#line 8052 "core/cfg.tab.c"
    break;

  case 392: /* assign_stm: MLOCK_PAGES EQUAL NUMBER  */
#line 1716 "core/cfg.y"
                                   { mlock_pages=(yyvsp[0].intval); }
#line 8058 "core/cfg.tab.c"
    break;

  case 393: /* assign_stm: MLOCK_PAGES EQUAL error  */
#line 1717 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 8064 "core/cfg.tab.c"
    break;

  case 394: /* assign_stm: REAL_TIME EQUAL NUMBER  */
#line 1718 "core/cfg.y"
                                 { real_time=(yyvsp[0].intval); }
#line 8070 "core/cfg.tab.c"
    break;

  case 395: /* assign_stm: REAL_TIME EQUAL error  */
#line 1719 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 8076 "core/cfg.tab.c"
    break;

  case 396: /* assign_stm: RT_PRIO EQUAL NUMBER  */
#line 1720 "core/cfg.y"
                               { rt_prio=(yyvsp[0].intval); }
#line 8082 "core/cfg.tab.c"
    break;

  case 397: /* assign_stm: RT_PRIO EQUAL error  */
#line 1721 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 8088 "core/cfg.tab.c"
    break;

  case 398: /* assign_stm: RT_POLICY EQUAL NUMBER  */
#line 1722 "core/cfg.y"
                                 { rt_policy=(yyvsp[0].intval); }
#line 8094 "core/cfg.tab.c"
    break;

  case 399: /* assign_stm: RT_POLICY EQUAL error  */
#line 1723 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 8100 "core/cfg.tab.c"
    break;

  case 400: /* assign_stm: RT_TIMER1_PRIO EQUAL NUMBER  */
#line 1724 "core/cfg.y"
                                      { rt_timer1_prio=(yyvsp[0].intval); }
#line 8106 "core/cfg.tab.c"
    break;

  case 401: /* assign_stm: RT_TIMER1_PRIO EQUAL error  */
#line 1725 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8112 "core/cfg.tab.c"
    break;

  case 402: /* assign_stm: RT_TIMER1_POLICY EQUAL NUMBER  */
#line 1726 "core/cfg.y"
                                        { rt_timer1_policy=(yyvsp[0].intval); }
#line 8118 "core/cfg.tab.c"
    break;

  case 403: /* assign_stm: RT_TIMER1_POLICY EQUAL error  */
#line 1727 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8124 "core/cfg.tab.c"
    break;

  case 404: /* assign_stm: RT_TIMER2_PRIO EQUAL NUMBER  */
#line 1728 "core/cfg.y"
                                      { rt_timer2_prio=(yyvsp[0].intval); }
#line 8130 "core/cfg.tab.c"
    break;

  case 405: /* assign_stm: RT_TIMER2_PRIO EQUAL error  */
#line 1729 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8136 "core/cfg.tab.c"
    break;

  case 406: /* assign_stm: RT_TIMER2_POLICY EQUAL NUMBER  */
#line 1730 "core/cfg.y"
                                        { rt_timer2_policy=(yyvsp[0].intval); }
#line 8142 "core/cfg.tab.c"
    break;

  case 407: /* assign_stm: RT_TIMER2_POLICY EQUAL error  */
#line 1731 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8148 "core/cfg.tab.c"
    break;

  case 408: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1732 "core/cfg.y"
                                      {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8160 "core/cfg.tab.c"
    break;

  case 409: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1739 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8166 "core/cfg.tab.c"
    break;

  case 410: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1740 "core/cfg.y"
                                 {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8178 "core/cfg.tab.c"
    break;

  case 411: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1747 "core/cfg.y"
                                { yyerror("number expected"); }
#line 8184 "core/cfg.tab.c"
    break;

  case 412: /* assign_stm: MCAST EQUAL ID  */
#line 1748 "core/cfg.y"
                         {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8196 "core/cfg.tab.c"
    break;

  case 413: /* assign_stm: MCAST EQUAL STRING  */
#line 1755 "core/cfg.y"
                             {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8208 "core/cfg.tab.c"
    break;

  case 414: /* assign_stm: MCAST EQUAL error  */
#line 1762 "core/cfg.y"
                            { yyerror("string expected"); }
#line 8214 "core/cfg.tab.c"
    break;

  case 415: /* assign_stm: TOS EQUAL NUMBER  */
#line 1763 "core/cfg.y"
                           { tos=(yyvsp[0].intval); }
#line 8220 "core/cfg.tab.c"
    break;

  case 416: /* assign_stm: TOS EQUAL ID  */
#line 1764 "core/cfg.y"
                       { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 8252 "core/cfg.tab.c"
    break;

  case 417: /* assign_stm: TOS EQUAL error  */
#line 1791 "core/cfg.y"
                          { yyerror("number expected"); }
#line 8258 "core/cfg.tab.c"
    break;

  case 418: /* assign_stm: PMTU_DISCOVERY EQUAL NUMBER  */
#line 1792 "core/cfg.y"
                                      { pmtu_discovery=(yyvsp[0].intval); }
#line 8264 "core/cfg.tab.c"
    break;

  case 419: /* assign_stm: PMTU_DISCOVERY error  */
#line 1793 "core/cfg.y"
                               { yyerror("number expected"); }
#line 8270 "core/cfg.tab.c"
    break;

  case 420: /* assign_stm: KILL_TIMEOUT EQUAL NUMBER  */
#line 1794 "core/cfg.y"
                                    { ser_kill_timeout=(yyvsp[0].intval); }
#line 8276 "core/cfg.tab.c"
    break;

  case 421: /* assign_stm: KILL_TIMEOUT EQUAL error  */
#line 1795 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8282 "core/cfg.tab.c"
    break;

  case 422: /* assign_stm: MAX_WLOOPS EQUAL NUMBER  */
#line 1796 "core/cfg.y"
                                  { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 8288 "core/cfg.tab.c"
    break;

  case 423: /* assign_stm: MAX_WLOOPS EQUAL error  */
#line 1797 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8294 "core/cfg.tab.c"
    break;

  case 424: /* assign_stm: PVBUFSIZE EQUAL NUMBER  */
#line 1798 "core/cfg.y"
                                 { pv_set_buffer_size((yyvsp[0].intval)); }
#line 8300 "core/cfg.tab.c"
    break;

  case 425: /* assign_stm: PVBUFSIZE EQUAL error  */
#line 1799 "core/cfg.y"
                                { yyerror("number expected"); }
#line 8306 "core/cfg.tab.c"
    break;

  case 426: /* assign_stm: PVBUFSLOTS EQUAL NUMBER  */
#line 1800 "core/cfg.y"
                                  { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 8312 "core/cfg.tab.c"
    break;

  case 427: /* assign_stm: PVBUFSLOTS EQUAL error  */
#line 1801 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8318 "core/cfg.tab.c"
    break;

  case 428: /* assign_stm: PVCACHELIMIT EQUAL NUMBER  */
#line 1802 "core/cfg.y"
                                    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 8324 "core/cfg.tab.c"
    break;

  case 429: /* assign_stm: PVCACHELIMIT EQUAL error  */
#line 1803 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8330 "core/cfg.tab.c"
    break;

  case 430: /* assign_stm: PVCACHEACTION EQUAL NUMBER  */
#line 1804 "core/cfg.y"
                                     { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 8336 "core/cfg.tab.c"
    break;

  case 431: /* assign_stm: PVCACHEACTION EQUAL error  */
#line 1805 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 8342 "core/cfg.tab.c"
    break;

  case 432: /* assign_stm: HTTP_REPLY_PARSE EQUAL NUMBER  */
#line 1806 "core/cfg.y"
                                        { http_reply_parse=(yyvsp[0].intval); }
#line 8348 "core/cfg.tab.c"
    break;

  case 433: /* assign_stm: HTTP_REPLY_PARSE EQUAL error  */
#line 1807 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8354 "core/cfg.tab.c"
    break;

  case 434: /* assign_stm: VERBOSE_STARTUP EQUAL NUMBER  */
#line 1808 "core/cfg.y"
                                       { ksr_verbose_startup=(yyvsp[0].intval); }
#line 8360 "core/cfg.tab.c"
    break;

  case 435: /* assign_stm: VERBOSE_STARTUP EQUAL error  */
#line 1809 "core/cfg.y"
                                      { yyerror("boolean value expected"); }
#line 8366 "core/cfg.tab.c"
    break;

  case 436: /* assign_stm: ROUTE_LOCKS_SIZE EQUAL NUMBER  */
#line 1810 "core/cfg.y"
                                        { ksr_route_locks_size=(yyvsp[0].intval); }
#line 8372 "core/cfg.tab.c"
    break;

  case 437: /* assign_stm: ROUTE_LOCKS_SIZE EQUAL error  */
#line 1811 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 8378 "core/cfg.tab.c"
    break;

  case 438: /* assign_stm: WAIT_WORKER1_MODE EQUAL NUMBER  */
#line 1812 "core/cfg.y"
                                         { ksr_wait_worker1_mode=(yyvsp[0].intval); }
#line 8384 "core/cfg.tab.c"
    break;

  case 439: /* assign_stm: WAIT_WORKER1_MODE EQUAL error  */
#line 1813 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 8390 "core/cfg.tab.c"
    break;

  case 440: /* assign_stm: WAIT_WORKER1_TIME EQUAL NUMBER  */
#line 1814 "core/cfg.y"
                                         { ksr_wait_worker1_time=(yyvsp[0].intval); }
#line 8396 "core/cfg.tab.c"
    break;

  case 441: /* assign_stm: WAIT_WORKER1_TIME EQUAL error  */
#line 1815 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 8402 "core/cfg.tab.c"
    break;

  case 442: /* assign_stm: WAIT_WORKER1_USLEEP EQUAL NUMBER  */
#line 1816 "core/cfg.y"
                                           { ksr_wait_worker1_usleep=(yyvsp[0].intval); }
#line 8408 "core/cfg.tab.c"
    break;

  case 443: /* assign_stm: WAIT_WORKER1_USLEEP EQUAL error  */
#line 1817 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 8414 "core/cfg.tab.c"
    break;

  case 444: /* assign_stm: SERVER_ID EQUAL NUMBER  */
#line 1818 "core/cfg.y"
                             { server_id=(yyvsp[0].intval); }
#line 8420 "core/cfg.tab.c"
    break;

  case 445: /* assign_stm: SERVER_ID EQUAL error  */
#line 1819 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8426 "core/cfg.tab.c"
    break;

  case 446: /* assign_stm: KEMI DOT ONSEND_ROUTE_CALLBACK EQUAL STRING  */
#line 1820 "core/cfg.y"
                                                      {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 8440 "core/cfg.tab.c"
    break;

  case 447: /* assign_stm: KEMI DOT ONSEND_ROUTE_CALLBACK EQUAL error  */
#line 1829 "core/cfg.y"
                                                     { yyerror("string expected"); }
#line 8446 "core/cfg.tab.c"
    break;

  case 448: /* assign_stm: KEMI DOT REPLY_ROUTE_CALLBACK EQUAL STRING  */
#line 1830 "core/cfg.y"
                                                     {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 8460 "core/cfg.tab.c"
    break;

  case 449: /* assign_stm: KEMI DOT REPLY_ROUTE_CALLBACK EQUAL error  */
#line 1839 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 8466 "core/cfg.tab.c"
    break;

  case 450: /* assign_stm: KEMI DOT EVENT_ROUTE_CALLBACK EQUAL STRING  */
#line 1840 "core/cfg.y"
                                                     {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 8480 "core/cfg.tab.c"
    break;

  case 451: /* assign_stm: KEMI DOT EVENT_ROUTE_CALLBACK EQUAL error  */
#line 1849 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 8486 "core/cfg.tab.c"
    break;

  case 452: /* assign_stm: KEMI DOT RECEIVED_ROUTE_CALLBACK EQUAL STRING  */
#line 1850 "core/cfg.y"
                                                        {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 8500 "core/cfg.tab.c"
    break;

  case 453: /* assign_stm: KEMI DOT RECEIVED_ROUTE_CALLBACK EQUAL error  */
#line 1859 "core/cfg.y"
                                                       { yyerror("string expected"); }
#line 8506 "core/cfg.tab.c"
    break;

  case 454: /* assign_stm: KEMI DOT PRE_ROUTING_CALLBACK EQUAL STRING  */
#line 1860 "core/cfg.y"
                                                     {
			kemi_pre_routing_callback.s = (yyvsp[0].strval);
			kemi_pre_routing_callback.len = strlen((yyvsp[0].strval));
			if(kemi_pre_routing_callback.len==4
					&& strcasecmp(kemi_pre_routing_callback.s, "none")==0) {
				kemi_pre_routing_callback.s = "";
				kemi_pre_routing_callback.len = 0;
			}
		}
#line 8520 "core/cfg.tab.c"
    break;

  case 455: /* assign_stm: KEMI DOT PRE_ROUTING_CALLBACK EQUAL error  */
#line 1869 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 8526 "core/cfg.tab.c"
    break;

  case 456: /* assign_stm: RECEIVED_ROUTE_MODE EQUAL intno  */
#line 1870 "core/cfg.y"
                                      { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 8532 "core/cfg.tab.c"
    break;

  case 457: /* assign_stm: RECEIVED_ROUTE_MODE EQUAL error  */
#line 1871 "core/cfg.y"
                                           { yyerror("number  expected"); }
#line 8538 "core/cfg.tab.c"
    break;

  case 458: /* assign_stm: MAX_RECURSIVE_LEVEL EQUAL NUMBER  */
#line 1872 "core/cfg.y"
                                       { set_max_recursive_level((yyvsp[0].intval)); }
#line 8544 "core/cfg.tab.c"
    break;

  case 459: /* assign_stm: MAX_BRANCHES_PARAM EQUAL NUMBER  */
#line 1873 "core/cfg.y"
                                      { sr_dst_max_branches = (yyvsp[0].intval); }
#line 8550 "core/cfg.tab.c"
    break;

  case 460: /* assign_stm: LATENCY_LOG EQUAL intno  */
#line 1874 "core/cfg.y"
                              { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 8556 "core/cfg.tab.c"
    break;

  case 461: /* assign_stm: LATENCY_LOG EQUAL error  */
#line 1875 "core/cfg.y"
                                   { yyerror("number  expected"); }
#line 8562 "core/cfg.tab.c"
    break;

  case 462: /* assign_stm: LATENCY_CFG_LOG EQUAL intno  */
#line 1876 "core/cfg.y"
                                  { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 8568 "core/cfg.tab.c"
    break;

  case 463: /* assign_stm: LATENCY_CFG_LOG EQUAL error  */
#line 1877 "core/cfg.y"
                                       { yyerror("number  expected"); }
#line 8574 "core/cfg.tab.c"
    break;

  case 464: /* assign_stm: LATENCY_LIMIT_DB EQUAL NUMBER  */
#line 1878 "core/cfg.y"
                                    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 8580 "core/cfg.tab.c"
    break;

  case 465: /* assign_stm: LATENCY_LIMIT_DB EQUAL error  */
#line 1879 "core/cfg.y"
                                        { yyerror("number  expected"); }
#line 8586 "core/cfg.tab.c"
    break;

  case 466: /* assign_stm: LATENCY_LIMIT_ACTION EQUAL NUMBER  */
#line 1880 "core/cfg.y"
                                        { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 8592 "core/cfg.tab.c"
    break;

  case 467: /* assign_stm: LATENCY_LIMIT_ACTION EQUAL error  */
#line 1881 "core/cfg.y"
                                            { yyerror("number  expected"); }
#line 8598 "core/cfg.tab.c"
    break;

  case 468: /* assign_stm: LATENCY_LIMIT_CFG EQUAL NUMBER  */
#line 1882 "core/cfg.y"
                                     { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 8604 "core/cfg.tab.c"
    break;

  case 469: /* assign_stm: LATENCY_LIMIT_CFG EQUAL error  */
#line 1883 "core/cfg.y"
                                         { yyerror("number  expected"); }
#line 8610 "core/cfg.tab.c"
    break;

  case 470: /* assign_stm: MSG_TIME EQUAL NUMBER  */
#line 1884 "core/cfg.y"
                            { sr_msg_time=(yyvsp[0].intval); }
#line 8616 "core/cfg.tab.c"
    break;

  case 471: /* assign_stm: MSG_TIME EQUAL error  */
#line 1885 "core/cfg.y"
                                { yyerror("number  expected"); }
#line 8622 "core/cfg.tab.c"
    break;

  case 472: /* assign_stm: ONSEND_RT_REPLY EQUAL NUMBER  */
#line 1886 "core/cfg.y"
                                       { onsend_route_reply=(yyvsp[0].intval); }
#line 8628 "core/cfg.tab.c"
    break;

  case 473: /* assign_stm: ONSEND_RT_REPLY EQUAL error  */
#line 1887 "core/cfg.y"
                                      { yyerror("int value expected"); }
#line 8634 "core/cfg.tab.c"
    break;

  case 474: /* assign_stm: UDP_MTU EQUAL NUMBER  */
#line 1888 "core/cfg.y"
                               { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 8640 "core/cfg.tab.c"
    break;

  case 475: /* assign_stm: UDP_MTU EQUAL error  */
#line 1889 "core/cfg.y"
                              { yyerror("number expected"); }
#line 8646 "core/cfg.tab.c"
    break;

  case 476: /* assign_stm: FORCE_RPORT EQUAL NUMBER  */
#line 1891 "core/cfg.y"
                { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8652 "core/cfg.tab.c"
    break;

  case 477: /* assign_stm: FORCE_RPORT EQUAL error  */
#line 1892 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 8658 "core/cfg.tab.c"
    break;

  case 478: /* assign_stm: LOCAL_RPORT EQUAL NUMBER  */
#line 1893 "core/cfg.y"
                                   { ksr_local_rport=(yyvsp[0].intval); }
#line 8664 "core/cfg.tab.c"
    break;

  case 479: /* assign_stm: LOCAL_RPORT EQUAL error  */
#line 1894 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 8670 "core/cfg.tab.c"
    break;

  case 480: /* assign_stm: UDP_MTU_TRY_PROTO EQUAL proto  */
#line 1896 "core/cfg.y"
                { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 8676 "core/cfg.tab.c"
    break;

  case 481: /* assign_stm: UDP_MTU_TRY_PROTO EQUAL error  */
#line 1898 "core/cfg.y"
                { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 8682 "core/cfg.tab.c"
    break;

  case 482: /* assign_stm: UDP4_RAW EQUAL intno  */
#line 1899 "core/cfg.y"
                               { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 8688 "core/cfg.tab.c"
    break;

  case 483: /* assign_stm: UDP4_RAW EQUAL error  */
#line 1900 "core/cfg.y"
                               { yyerror("number expected"); }
#line 8694 "core/cfg.tab.c"
    break;

  case 484: /* assign_stm: UDP4_RAW_MTU EQUAL NUMBER  */
#line 1901 "core/cfg.y"
                                    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 8702 "core/cfg.tab.c"
    break;

  case 485: /* assign_stm: UDP4_RAW_MTU EQUAL error  */
#line 1904 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8708 "core/cfg.tab.c"
    break;

  case 486: /* assign_stm: UDP4_RAW_TTL EQUAL NUMBER  */
#line 1905 "core/cfg.y"
                                    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 8716 "core/cfg.tab.c"
    break;

  case 487: /* assign_stm: UDP4_RAW_TTL EQUAL error  */
#line 1908 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8722 "core/cfg.tab.c"
    break;

  case 489: /* assign_stm: error EQUAL  */
#line 1910 "core/cfg.y"
                      { yyerror("unknown config variable"); }
#line 8728 "core/cfg.tab.c"
    break;

  case 491: /* cfg_var_id: DEFAULT  */
#line 1914 "core/cfg.y"
                  { (yyval.strval)="default" ; }
#line 8734 "core/cfg.tab.c"
    break;

  case 493: /* cfg_var_idn: DEFAULT  */
#line 1918 "core/cfg.y"
                  { (yyval.strval)="default" ; }
#line 8740 "core/cfg.tab.c"
    break;

  case 494: /* cfg_var_idn: NUMBER  */
#line 1919 "core/cfg.y"
                 {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 8750 "core/cfg.tab.c"
    break;

  case 495: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL NUMBER  */
#line 1927 "core/cfg.y"
                                                {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8760 "core/cfg.tab.c"
    break;

  case 496: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL STRING  */
#line 1932 "core/cfg.y"
                                                  {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 8770 "core/cfg.tab.c"
    break;

  case 497: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL NUMBER CFG_DESCRIPTION STRING  */
#line 1937 "core/cfg.y"
                                                                         {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8780 "core/cfg.tab.c"
    break;

  case 498: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL STRING CFG_DESCRIPTION STRING  */
#line 1942 "core/cfg.y"
                                                                         {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 8790 "core/cfg.tab.c"
    break;

  case 499: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL error  */
#line 1947 "core/cfg.y"
                                                 {
		yyerror("number or string expected");
	}
#line 8798 "core/cfg.tab.c"
    break;

  case 500: /* cfg_var: cfg_var_id LBRACK NUMBER RBRACK DOT cfg_var_idn EQUAL NUMBER  */
#line 1950 "core/cfg.y"
                                                                       {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8808 "core/cfg.tab.c"
    break;

  case 501: /* cfg_var: cfg_var_id LBRACK NUMBER RBRACK DOT cfg_var_idn EQUAL STRING  */
#line 1955 "core/cfg.y"
                                                                       {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 8818 "core/cfg.tab.c"
    break;

  case 502: /* module_stm: LOADMODULE STRING  */
#line 1963 "core/cfg.y"
                          {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_module((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8829 "core/cfg.tab.c"
    break;

  case 503: /* module_stm: LOADMODULE error  */
#line 1969 "core/cfg.y"
                                { yyerror("string expected"); }
#line 8835 "core/cfg.tab.c"
    break;

  case 504: /* module_stm: LOADMODULEX STRING  */
#line 1970 "core/cfg.y"
                             {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (load_modulex((yyvsp[0].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 8846 "core/cfg.tab.c"
    break;

  case 505: /* module_stm: LOADMODULEX error  */
#line 1976 "core/cfg.y"
                                { yyerror("string expected"); }
#line 8852 "core/cfg.tab.c"
    break;

  case 506: /* module_stm: LOADPATH STRING  */
#line 1977 "core/cfg.y"
                          {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8867 "core/cfg.tab.c"
    break;

  case 507: /* module_stm: LOADPATH error  */
#line 1987 "core/cfg.y"
                                { yyerror("string expected"); }
#line 8873 "core/cfg.tab.c"
    break;

  case 508: /* module_stm: LOADPATH EQUAL STRING  */
#line 1988 "core/cfg.y"
                                {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 8888 "core/cfg.tab.c"
    break;

  case 509: /* module_stm: LOADPATH EQUAL error  */
#line 1998 "core/cfg.y"
                                { yyerror("string expected"); }
#line 8894 "core/cfg.tab.c"
    break;

  case 510: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 1999 "core/cfg.y"
                                                                  {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8908 "core/cfg.tab.c"
    break;

  case 511: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA intno RPAREN  */
#line 2008 "core/cfg.y"
                                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8922 "core/cfg.tab.c"
    break;

  case 512: /* module_stm: MODPARAM error  */
#line 2017 "core/cfg.y"
                         { yyerror("Invalid arguments"); }
#line 8928 "core/cfg.tab.c"
    break;

  case 513: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 2018 "core/cfg.y"
                                                                   {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8942 "core/cfg.tab.c"
    break;

  case 514: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA intno RPAREN  */
#line 2027 "core/cfg.y"
                                                                  {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8956 "core/cfg.tab.c"
    break;

  case 515: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA PVAR RPAREN  */
#line 2036 "core/cfg.y"
                                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_VAR, (void*)(yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 8970 "core/cfg.tab.c"
    break;

  case 516: /* module_stm: MODPARAMX error  */
#line 2045 "core/cfg.y"
                          { yyerror("Invalid arguments"); }
#line 8976 "core/cfg.tab.c"
    break;

  case 517: /* module_stm: CFGENGINE STRING  */
#line 2046 "core/cfg.y"
                           {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 8987 "core/cfg.tab.c"
    break;

  case 518: /* module_stm: CFGENGINE error  */
#line 2052 "core/cfg.y"
                                { yyerror("string expected"); }
#line 8993 "core/cfg.tab.c"
    break;

  case 519: /* module_stm: CFGENGINE EQUAL STRING  */
#line 2053 "core/cfg.y"
                                 {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9004 "core/cfg.tab.c"
    break;

  case 520: /* module_stm: CFGENGINE EQUAL error  */
#line 2059 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9010 "core/cfg.tab.c"
    break;

  case 521: /* ip: ipv4  */
#line 2063 "core/cfg.y"
              { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9016 "core/cfg.tab.c"
    break;

  case 522: /* ip: ipv6  */
#line 2064 "core/cfg.y"
                { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9022 "core/cfg.tab.c"
    break;

  case 523: /* ipv4: NUMBER DOT NUMBER DOT NUMBER DOT NUMBER  */
#line 2067 "core/cfg.y"
                                                {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 9054 "core/cfg.tab.c"
    break;

  case 524: /* ipv6addr: IPV6ADDR  */
#line 2096 "core/cfg.y"
                 {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 9072 "core/cfg.tab.c"
    break;

  case 525: /* ipv6: ipv6addr  */
#line 2111 "core/cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9078 "core/cfg.tab.c"
    break;

  case 526: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 2112 "core/cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 9084 "core/cfg.tab.c"
    break;

  case 527: /* route_name: NUMBER  */
#line 2116 "core/cfg.y"
                                {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 9100 "core/cfg.tab.c"
    break;

  case 528: /* route_name: ID  */
#line 2127 "core/cfg.y"
                                                { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9106 "core/cfg.tab.c"
    break;

  case 529: /* route_name: STRING  */
#line 2128 "core/cfg.y"
                                        { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9112 "core/cfg.tab.c"
    break;

  case 530: /* route_main: ROUTE  */
#line 2132 "core/cfg.y"
                      { routename=NULL; }
#line 9118 "core/cfg.tab.c"
    break;

  case 531: /* route_main: ROUTE_REQUEST  */
#line 2133 "core/cfg.y"
                                  { routename=NULL; }
#line 9124 "core/cfg.tab.c"
    break;

  case 532: /* route_stm: route_main LBRACE actions RBRACE  */
#line 2137 "core/cfg.y"
                                         {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 9136 "core/cfg.tab.c"
    break;

  case 533: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2144 "core/cfg.y"
                                                               {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 9157 "core/cfg.tab.c"
    break;

  case 534: /* route_stm: ROUTE error  */
#line 2160 "core/cfg.y"
                      { yyerror("invalid  route  statement"); }
#line 9163 "core/cfg.tab.c"
    break;

  case 535: /* route_stm: ROUTE_REQUEST error  */
#line 2161 "core/cfg.y"
                              { yyerror("invalid  request_route  statement"); }
#line 9169 "core/cfg.tab.c"
    break;

  case 536: /* failure_route_main: ROUTE_FAILURE  */
#line 2164 "core/cfg.y"
                                  { routename=NULL; }
#line 9175 "core/cfg.tab.c"
    break;

  case 537: /* failure_route_stm: failure_route_main LBRACE actions RBRACE  */
#line 2167 "core/cfg.y"
                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 9187 "core/cfg.tab.c"
    break;

  case 538: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2174 "core/cfg.y"
                                                                       {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 9208 "core/cfg.tab.c"
    break;

  case 539: /* failure_route_stm: ROUTE_FAILURE error  */
#line 2190 "core/cfg.y"
                              { yyerror("invalid failure_route statement"); }
#line 9214 "core/cfg.tab.c"
    break;

  case 540: /* route_reply_main: ROUTE_ONREPLY  */
#line 2194 "core/cfg.y"
                                      { routename=NULL; }
#line 9220 "core/cfg.tab.c"
    break;

  case 541: /* route_reply_main: ROUTE_REPLY  */
#line 2195 "core/cfg.y"
                                { routename=NULL; }
#line 9226 "core/cfg.tab.c"
    break;

  case 542: /* $@6: %empty  */
#line 2200 "core/cfg.y"
                                {rt=CORE_ONREPLY_ROUTE;}
#line 9232 "core/cfg.tab.c"
    break;

  case 543: /* onreply_route_stm: route_reply_main LBRACE $@6 actions RBRACE  */
#line 2200 "core/cfg.y"
                                                                        {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 9244 "core/cfg.tab.c"
    break;

  case 544: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 2207 "core/cfg.y"
                              { yyerror("invalid onreply_route statement"); }
#line 9250 "core/cfg.tab.c"
    break;

  case 545: /* onreply_route_stm: ROUTE_REPLY error  */
#line 2208 "core/cfg.y"
                            { yyerror("invalid onreply_route statement"); }
#line 9256 "core/cfg.tab.c"
    break;

  case 546: /* $@7: %empty  */
#line 2210 "core/cfg.y"
                {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 9262 "core/cfg.tab.c"
    break;

  case 547: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK $@7 LBRACE actions RBRACE  */
#line 2211 "core/cfg.y"
                                      {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 9288 "core/cfg.tab.c"
    break;

  case 548: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK error  */
#line 2232 "core/cfg.y"
                                                       {
		yyerror("invalid onreply_route statement");
	}
#line 9296 "core/cfg.tab.c"
    break;

  case 549: /* branch_route_main: ROUTE_BRANCH  */
#line 2237 "core/cfg.y"
                                { routename=NULL; }
#line 9302 "core/cfg.tab.c"
    break;

  case 550: /* branch_route_stm: branch_route_main LBRACE actions RBRACE  */
#line 2240 "core/cfg.y"
                                                {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 9314 "core/cfg.tab.c"
    break;

  case 551: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2247 "core/cfg.y"
                                                                      {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 9335 "core/cfg.tab.c"
    break;

  case 552: /* branch_route_stm: ROUTE_BRANCH error  */
#line 2263 "core/cfg.y"
                             { yyerror("invalid branch_route statement"); }
#line 9341 "core/cfg.tab.c"
    break;

  case 553: /* send_route_main: ROUTE_SEND  */
#line 2266 "core/cfg.y"
                            { routename=NULL; }
#line 9347 "core/cfg.tab.c"
    break;

  case 554: /* send_route_stm: send_route_main LBRACE actions RBRACE  */
#line 2269 "core/cfg.y"
                                              {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 9359 "core/cfg.tab.c"
    break;

  case 555: /* send_route_stm: ROUTE_SEND LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2276 "core/cfg.y"
                                                                    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 9380 "core/cfg.tab.c"
    break;

  case 556: /* send_route_stm: ROUTE_SEND error  */
#line 2292 "core/cfg.y"
                           { yyerror("invalid onsend_route statement"); }
#line 9386 "core/cfg.tab.c"
    break;

  case 557: /* event_route_main: ROUTE_EVENT  */
#line 2295 "core/cfg.y"
                              { routename=NULL; }
#line 9392 "core/cfg.tab.c"
    break;

  case 558: /* event_route_stm: event_route_main LBRACK EVENT_RT_NAME RBRACK LBRACE actions RBRACE  */
#line 2298 "core/cfg.y"
                                                                           {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 9413 "core/cfg.tab.c"
    break;

  case 559: /* event_route_stm: ROUTE_EVENT error  */
#line 2315 "core/cfg.y"
                            { yyerror("invalid event_route statement"); }
#line 9419 "core/cfg.tab.c"
    break;

  case 560: /* preprocess_stm: SUBST STRING  */
#line 2318 "core/cfg.y"
                     { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 9425 "core/cfg.tab.c"
    break;

  case 561: /* preprocess_stm: SUBST error  */
#line 2319 "core/cfg.y"
                      { yyerror("invalid subst preprocess statement"); }
#line 9431 "core/cfg.tab.c"
    break;

  case 562: /* preprocess_stm: SUBSTDEF STRING  */
#line 2320 "core/cfg.y"
                          { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_NORMAL)<0) YYERROR; }
#line 9437 "core/cfg.tab.c"
    break;

  case 563: /* preprocess_stm: SUBSTDEF error  */
#line 2321 "core/cfg.y"
                         { yyerror("invalid substdef preprocess statement"); }
#line 9443 "core/cfg.tab.c"
    break;

  case 564: /* preprocess_stm: SUBSTDEFS STRING  */
#line 2322 "core/cfg.y"
                           { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_QUOTED)<0) YYERROR; }
#line 9449 "core/cfg.tab.c"
    break;

  case 565: /* preprocess_stm: SUBSTDEFS error  */
#line 2323 "core/cfg.y"
                          { yyerror("invalid substdefs preprocess statement"); }
#line 9455 "core/cfg.tab.c"
    break;

  case 566: /* equalop: EQUAL_T  */
#line 2345 "core/cfg.y"
                {(yyval.intval)=EQUAL_OP; }
#line 9461 "core/cfg.tab.c"
    break;

  case 567: /* equalop: DIFF  */
#line 2346 "core/cfg.y"
                {(yyval.intval)=DIFF_OP; }
#line 9467 "core/cfg.tab.c"
    break;

  case 568: /* equalop: STREQ  */
#line 2347 "core/cfg.y"
                {(yyval.intval)=EQUAL_OP; }
#line 9473 "core/cfg.tab.c"
    break;

  case 569: /* equalop: STRDIFF  */
#line 2348 "core/cfg.y"
                  {(yyval.intval)=DIFF_OP; }
#line 9479 "core/cfg.tab.c"
    break;

  case 570: /* cmpop: GT  */
#line 2351 "core/cfg.y"
                {(yyval.intval)=GT_OP; }
#line 9485 "core/cfg.tab.c"
    break;

  case 571: /* cmpop: LT  */
#line 2352 "core/cfg.y"
                {(yyval.intval)=LT_OP; }
#line 9491 "core/cfg.tab.c"
    break;

  case 572: /* cmpop: GTE  */
#line 2353 "core/cfg.y"
                {(yyval.intval)=GTE_OP; }
#line 9497 "core/cfg.tab.c"
    break;

  case 573: /* cmpop: LTE  */
#line 2354 "core/cfg.y"
                {(yyval.intval)=LTE_OP; }
#line 9503 "core/cfg.tab.c"
    break;

  case 574: /* strop: equalop  */
#line 2357 "core/cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 9509 "core/cfg.tab.c"
    break;

  case 575: /* strop: MATCH  */
#line 2358 "core/cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 9515 "core/cfg.tab.c"
    break;

  case 576: /* rve_equalop: EQUAL_T  */
#line 2364 "core/cfg.y"
                {(yyval.intval)=RVE_EQ_OP; }
#line 9521 "core/cfg.tab.c"
    break;

  case 577: /* rve_equalop: DIFF  */
#line 2365 "core/cfg.y"
                {(yyval.intval)=RVE_DIFF_OP; }
#line 9527 "core/cfg.tab.c"
    break;

  case 578: /* rve_equalop: INTEQ  */
#line 2366 "core/cfg.y"
                {(yyval.intval)=RVE_IEQ_OP; }
#line 9533 "core/cfg.tab.c"
    break;

  case 579: /* rve_equalop: INTDIFF  */
#line 2367 "core/cfg.y"
                  {(yyval.intval)=RVE_IDIFF_OP; }
#line 9539 "core/cfg.tab.c"
    break;

  case 580: /* rve_equalop: STREQ  */
#line 2368 "core/cfg.y"
                {(yyval.intval)=RVE_STREQ_OP; }
#line 9545 "core/cfg.tab.c"
    break;

  case 581: /* rve_equalop: STRDIFF  */
#line 2369 "core/cfg.y"
                  {(yyval.intval)=RVE_STRDIFF_OP; }
#line 9551 "core/cfg.tab.c"
    break;

  case 582: /* rve_equalop: MATCH  */
#line 2370 "core/cfg.y"
                {(yyval.intval)=RVE_MATCH_OP; }
#line 9557 "core/cfg.tab.c"
    break;

  case 583: /* rve_cmpop: GT  */
#line 2373 "core/cfg.y"
                {(yyval.intval)=RVE_GT_OP; }
#line 9563 "core/cfg.tab.c"
    break;

  case 584: /* rve_cmpop: LT  */
#line 2374 "core/cfg.y"
                {(yyval.intval)=RVE_LT_OP; }
#line 9569 "core/cfg.tab.c"
    break;

  case 585: /* rve_cmpop: GTE  */
#line 2375 "core/cfg.y"
                {(yyval.intval)=RVE_GTE_OP; }
#line 9575 "core/cfg.tab.c"
    break;

  case 586: /* rve_cmpop: LTE  */
#line 2376 "core/cfg.y"
                {(yyval.intval)=RVE_LTE_OP; }
#line 9581 "core/cfg.tab.c"
    break;

  case 587: /* uri_type: URI  */
#line 2383 "core/cfg.y"
                        {(yyval.intval)=URI_O;}
#line 9587 "core/cfg.tab.c"
    break;

  case 588: /* uri_type: FROM_URI  */
#line 2384 "core/cfg.y"
                        {(yyval.intval)=FROM_URI_O;}
#line 9593 "core/cfg.tab.c"
    break;

  case 589: /* uri_type: TO_URI  */
#line 2385 "core/cfg.y"
                        {(yyval.intval)=TO_URI_O;}
#line 9599 "core/cfg.tab.c"
    break;

  case 590: /* eint_op_onsend: SNDPORT  */
#line 2392 "core/cfg.y"
                                        { (yyval.intval)=SNDPORT_O; }
#line 9605 "core/cfg.tab.c"
    break;

  case 591: /* eint_op_onsend: TOPORT  */
#line 2393 "core/cfg.y"
                                        { (yyval.intval)=TOPORT_O; }
#line 9611 "core/cfg.tab.c"
    break;

  case 592: /* eint_op_onsend: SNDAF  */
#line 2394 "core/cfg.y"
                                        { (yyval.intval)=SNDAF_O; }
#line 9617 "core/cfg.tab.c"
    break;

  case 593: /* eint_op: SRCPORT  */
#line 2398 "core/cfg.y"
                                { (yyval.intval)=SRCPORT_O; }
#line 9623 "core/cfg.tab.c"
    break;

  case 594: /* eint_op: DSTPORT  */
#line 2399 "core/cfg.y"
                                        { (yyval.intval)=DSTPORT_O; }
#line 9629 "core/cfg.tab.c"
    break;

  case 595: /* eint_op: AF  */
#line 2400 "core/cfg.y"
                                                { (yyval.intval)=AF_O; }
#line 9635 "core/cfg.tab.c"
    break;

  case 596: /* eint_op: MSGLEN  */
#line 2401 "core/cfg.y"
                                        { (yyval.intval)=MSGLEN_O; }
#line 9641 "core/cfg.tab.c"
    break;

  case 598: /* eip_op_onsend: SNDIP  */
#line 2407 "core/cfg.y"
                                        { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 9647 "core/cfg.tab.c"
    break;

  case 599: /* eip_op_onsend: TOIP  */
#line 2408 "core/cfg.y"
                                        { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 9653 "core/cfg.tab.c"
    break;

  case 600: /* eip_op: SRCIP  */
#line 2411 "core/cfg.y"
                                { (yyval.intval)=SRCIP_O; }
#line 9659 "core/cfg.tab.c"
    break;

  case 601: /* eip_op: DSTIP  */
#line 2412 "core/cfg.y"
                                        { (yyval.intval)=DSTIP_O; }
#line 9665 "core/cfg.tab.c"
    break;

  case 603: /* exp_elem: METHOD strop rval_expr  */
#line 2420 "core/cfg.y"
                {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 9671 "core/cfg.tab.c"
    break;

  case 604: /* exp_elem: METHOD strop ID  */
#line 2422 "core/cfg.y"
                {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 9677 "core/cfg.tab.c"
    break;

  case 605: /* exp_elem: METHOD strop error  */
#line 2423 "core/cfg.y"
                             { (yyval.expr)=0; yyerror("string expected"); }
#line 9683 "core/cfg.tab.c"
    break;

  case 606: /* exp_elem: METHOD error  */
#line 2425 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 9689 "core/cfg.tab.c"
    break;

  case 607: /* exp_elem: uri_type strop rval_expr  */
#line 2427 "core/cfg.y"
                {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 9695 "core/cfg.tab.c"
    break;

  case 608: /* exp_elem: uri_type strop MYSELF  */
#line 2429 "core/cfg.y"
                {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9701 "core/cfg.tab.c"
    break;

  case 609: /* exp_elem: uri_type strop error  */
#line 2431 "core/cfg.y"
                { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 9707 "core/cfg.tab.c"
    break;

  case 610: /* exp_elem: uri_type error  */
#line 2433 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 9713 "core/cfg.tab.c"
    break;

  case 611: /* exp_elem: eint_op cmpop rval_expr  */
#line 2434 "core/cfg.y"
                                           { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9719 "core/cfg.tab.c"
    break;

  case 612: /* exp_elem: eint_op equalop rval_expr  */
#line 2436 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9725 "core/cfg.tab.c"
    break;

  case 613: /* exp_elem: eint_op cmpop error  */
#line 2437 "core/cfg.y"
                                { (yyval.expr)=0; yyerror("number expected"); }
#line 9731 "core/cfg.tab.c"
    break;

  case 614: /* exp_elem: eint_op equalop error  */
#line 2438 "core/cfg.y"
                                { (yyval.expr)=0; yyerror("number expected"); }
#line 9737 "core/cfg.tab.c"
    break;

  case 615: /* exp_elem: eint_op error  */
#line 2439 "core/cfg.y"
                        { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 9743 "core/cfg.tab.c"
    break;

  case 616: /* exp_elem: PROTO equalop eqproto  */
#line 2441 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9749 "core/cfg.tab.c"
    break;

  case 617: /* exp_elem: PROTO equalop rval_expr  */
#line 2443 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9755 "core/cfg.tab.c"
    break;

  case 618: /* exp_elem: PROTO equalop error  */
#line 2445 "core/cfg.y"
                { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9761 "core/cfg.tab.c"
    break;

  case 619: /* exp_elem: SNDPROTO equalop eqproto  */
#line 2447 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 9767 "core/cfg.tab.c"
    break;

  case 620: /* exp_elem: SNDPROTO equalop rval_expr  */
#line 2449 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 9773 "core/cfg.tab.c"
    break;

  case 621: /* exp_elem: SNDPROTO equalop error  */
#line 2451 "core/cfg.y"
                { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 9779 "core/cfg.tab.c"
    break;

  case 622: /* exp_elem: eip_op strop ipnet  */
#line 2452 "core/cfg.y"
                                           { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 9785 "core/cfg.tab.c"
    break;

  case 623: /* exp_elem: eip_op strop rval_expr  */
#line 2453 "core/cfg.y"
                                               {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_INT)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 9826 "core/cfg.tab.c"
    break;

  case 624: /* exp_elem: eip_op strop host  */
#line 2490 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 9832 "core/cfg.tab.c"
    break;

  case 625: /* exp_elem: eip_op strop MYSELF  */
#line 2492 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 9838 "core/cfg.tab.c"
    break;

  case 626: /* exp_elem: eip_op strop error  */
#line 2494 "core/cfg.y"
                { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 9844 "core/cfg.tab.c"
    break;

  case 627: /* exp_elem: eip_op error  */
#line 2496 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 9850 "core/cfg.tab.c"
    break;

  case 628: /* exp_elem: MYSELF equalop uri_type  */
#line 2499 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9856 "core/cfg.tab.c"
    break;

  case 629: /* exp_elem: MYSELF equalop eip_op  */
#line 2501 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 9862 "core/cfg.tab.c"
    break;

  case 630: /* exp_elem: MYSELF equalop error  */
#line 2503 "core/cfg.y"
                { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 9868 "core/cfg.tab.c"
    break;

  case 631: /* exp_elem: MYSELF error  */
#line 2504 "core/cfg.y"
                        { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 9874 "core/cfg.tab.c"
    break;

  case 632: /* ipnet: ip SLASH ip  */
#line 2508 "core/cfg.y"
                        { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 9880 "core/cfg.tab.c"
    break;

  case 633: /* ipnet: ip SLASH NUMBER  */
#line 2509 "core/cfg.y"
                          {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 9896 "core/cfg.tab.c"
    break;

  case 634: /* ipnet: ip  */
#line 2520 "core/cfg.y"
                { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 9902 "core/cfg.tab.c"
    break;

  case 635: /* ipnet: ip SLASH error  */
#line 2521 "core/cfg.y"
                         { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 9908 "core/cfg.tab.c"
    break;

  case 636: /* host: ID  */
#line 2525 "core/cfg.y"
           { (yyval.strval)=(yyvsp[0].strval); }
#line 9914 "core/cfg.tab.c"
    break;

  case 637: /* host: host DOT ID  */
#line 2526 "core/cfg.y"
                      {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9934 "core/cfg.tab.c"
    break;

  case 638: /* host: host MINUS ID  */
#line 2541 "core/cfg.y"
                        {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 9954 "core/cfg.tab.c"
    break;

  case 639: /* host: host DOT error  */
#line 2556 "core/cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9960 "core/cfg.tab.c"
    break;

  case 640: /* host: host MINUS error  */
#line 2557 "core/cfg.y"
                           { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 9966 "core/cfg.tab.c"
    break;

  case 643: /* host_if_id: NUMBER  */
#line 2562 "core/cfg.y"
                         {
			/* get string version */
			(yyval.strval)=pkg_malloc(strlen(yy_number_str)+1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				strcpy((yyval.strval), yy_number_str);
			}
		}
#line 9980 "core/cfg.tab.c"
    break;

  case 644: /* host_or_if: host_if_id  */
#line 2574 "core/cfg.y"
                   { (yyval.strval)=(yyvsp[0].strval); }
#line 9986 "core/cfg.tab.c"
    break;

  case 645: /* host_or_if: host_or_if DOT host_if_id  */
#line 2575 "core/cfg.y"
                                    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10006 "core/cfg.tab.c"
    break;

  case 646: /* host_or_if: host_or_if MINUS host_if_id  */
#line 2590 "core/cfg.y"
                                      {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10026 "core/cfg.tab.c"
    break;

  case 647: /* host_or_if: host_or_if DOT error  */
#line 2605 "core/cfg.y"
                               { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10033 "core/cfg.tab.c"
    break;

  case 648: /* host_or_if: host_or_if MINUS error  */
#line 2607 "core/cfg.y"
                                 { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10040 "core/cfg.tab.c"
    break;

  case 649: /* fcmd: cmd  */
#line 2614 "core/cfg.y"
            {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 10077 "core/cfg.tab.c"
    break;

  case 650: /* stm: action  */
#line 2656 "core/cfg.y"
                { (yyval.action)=(yyvsp[0].action); }
#line 10083 "core/cfg.tab.c"
    break;

  case 651: /* stm: LBRACE actions RBRACE  */
#line 2657 "core/cfg.y"
                                { (yyval.action)=(yyvsp[-1].action); }
#line 10089 "core/cfg.tab.c"
    break;

  case 652: /* actions: actions action  */
#line 2660 "core/cfg.y"
                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 10095 "core/cfg.tab.c"
    break;

  case 653: /* actions: action  */
#line 2661 "core/cfg.y"
                        {(yyval.action)=(yyvsp[0].action);}
#line 10101 "core/cfg.tab.c"
    break;

  case 654: /* actions: actions error  */
#line 2662 "core/cfg.y"
                        { (yyval.action)=0; yyerror("bad command"); }
#line 10107 "core/cfg.tab.c"
    break;

  case 655: /* action: fcmd SEMICOLON  */
#line 2665 "core/cfg.y"
                       {(yyval.action)=(yyvsp[-1].action);}
#line 10113 "core/cfg.tab.c"
    break;

  case 656: /* action: if_cmd  */
#line 2666 "core/cfg.y"
                 {(yyval.action)=(yyvsp[0].action);}
#line 10119 "core/cfg.tab.c"
    break;

  case 657: /* action: switch_cmd  */
#line 2667 "core/cfg.y"
                     {(yyval.action)=(yyvsp[0].action);}
#line 10125 "core/cfg.tab.c"
    break;

  case 658: /* action: while_cmd  */
#line 2668 "core/cfg.y"
                    { (yyval.action)=(yyvsp[0].action); }
#line 10131 "core/cfg.tab.c"
    break;

  case 659: /* action: ret_cmd SEMICOLON  */
#line 2669 "core/cfg.y"
                            { (yyval.action)=(yyvsp[-1].action); }
#line 10137 "core/cfg.tab.c"
    break;

  case 660: /* action: assign_action SEMICOLON  */
#line 2670 "core/cfg.y"
                                  {(yyval.action)=(yyvsp[-1].action);}
#line 10143 "core/cfg.tab.c"
    break;

  case 661: /* action: SEMICOLON  */
#line 2671 "core/cfg.y"
                                      {(yyval.action)=0;}
#line 10149 "core/cfg.tab.c"
    break;

  case 662: /* action: fcmd error  */
#line 2672 "core/cfg.y"
                     { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 10155 "core/cfg.tab.c"
    break;

  case 663: /* if_cmd: IF rval_expr stm  */
#line 2675 "core/cfg.y"
                                {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10168 "core/cfg.tab.c"
    break;

  case 664: /* if_cmd: IF rval_expr stm ELSE stm  */
#line 2683 "core/cfg.y"
                                        {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10181 "core/cfg.tab.c"
    break;

  case 665: /* ct_rval: rval_expr  */
#line 2693 "core/cfg.y"
                   {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_INT){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 10201 "core/cfg.tab.c"
    break;

  case 666: /* single_case: CASE ct_rval COLON actions  */
#line 2710 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10213 "core/cfg.tab.c"
    break;

  case 667: /* single_case: CASE SLASH ct_rval COLON actions  */
#line 2717 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10225 "core/cfg.tab.c"
    break;

  case 668: /* single_case: CASE ct_rval COLON  */
#line 2724 "core/cfg.y"
                             {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10237 "core/cfg.tab.c"
    break;

  case 669: /* single_case: CASE SLASH ct_rval COLON  */
#line 2731 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10249 "core/cfg.tab.c"
    break;

  case 670: /* single_case: DEFAULT COLON actions  */
#line 2738 "core/cfg.y"
                                {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10259 "core/cfg.tab.c"
    break;

  case 671: /* single_case: DEFAULT COLON  */
#line 2743 "core/cfg.y"
                        {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10269 "core/cfg.tab.c"
    break;

  case 672: /* single_case: CASE error COLON actions  */
#line 2748 "core/cfg.y"
                                   { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10275 "core/cfg.tab.c"
    break;

  case 673: /* single_case: CASE SLASH error COLON actions  */
#line 2749 "core/cfg.y"
                                         { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10281 "core/cfg.tab.c"
    break;

  case 674: /* single_case: CASE error COLON  */
#line 2750 "core/cfg.y"
                           { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10287 "core/cfg.tab.c"
    break;

  case 675: /* single_case: CASE SLASH error COLON  */
#line 2751 "core/cfg.y"
                                 { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10293 "core/cfg.tab.c"
    break;

  case 676: /* single_case: CASE ct_rval COLON error  */
#line 2752 "core/cfg.y"
                                   { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 10299 "core/cfg.tab.c"
    break;

  case 677: /* case_stms: case_stms single_case  */
#line 2755 "core/cfg.y"
                              {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 10313 "core/cfg.tab.c"
    break;

  case 678: /* case_stms: single_case  */
#line 2764 "core/cfg.y"
                      {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 10323 "core/cfg.tab.c"
    break;

  case 679: /* switch_cmd: SWITCH rval_expr LBRACE case_stms RBRACE  */
#line 2771 "core/cfg.y"
                                                   {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10353 "core/cfg.tab.c"
    break;

  case 680: /* switch_cmd: SWITCH rval_expr LBRACE RBRACE  */
#line 2796 "core/cfg.y"
                                         {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10374 "core/cfg.tab.c"
    break;

  case 681: /* switch_cmd: SWITCH error  */
#line 2812 "core/cfg.y"
                       { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 10380 "core/cfg.tab.c"
    break;

  case 682: /* switch_cmd: SWITCH rval_expr LBRACE error RBRACE  */
#line 2814 "core/cfg.y"
                {(yyval.action)=0; yyerror ("bad switch body"); }
#line 10386 "core/cfg.tab.c"
    break;

  case 683: /* while_cmd: WHILE rval_expr stm  */
#line 2818 "core/cfg.y"
                            {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 10401 "core/cfg.tab.c"
    break;

  case 684: /* select_param: ID  */
#line 2837 "core/cfg.y"
           {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 10415 "core/cfg.tab.c"
    break;

  case 685: /* select_param: ID LBRACK intno RBRACK  */
#line 2846 "core/cfg.y"
                                 {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 10432 "core/cfg.tab.c"
    break;

  case 686: /* select_param: ID LBRACK STRING RBRACK  */
#line 2858 "core/cfg.y"
                                  {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 10450 "core/cfg.tab.c"
    break;

  case 689: /* $@8: %empty  */
#line 2877 "core/cfg.y"
                    { sel.n = 0; sel.f[0] = 0; }
#line 10456 "core/cfg.tab.c"
    break;

  case 690: /* select_id: SELECT_MARK $@8 select_params  */
#line 2877 "core/cfg.y"
                                                               {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 10469 "core/cfg.tab.c"
    break;

  case 691: /* attr_class_spec: ATTR_FROM  */
#line 2887 "core/cfg.y"
                  { s_attr->type |= AVP_TRACK_FROM; }
#line 10475 "core/cfg.tab.c"
    break;

  case 692: /* attr_class_spec: ATTR_TO  */
#line 2888 "core/cfg.y"
                  { s_attr->type |= AVP_TRACK_TO; }
#line 10481 "core/cfg.tab.c"
    break;

  case 693: /* attr_class_spec: ATTR_FROMURI  */
#line 2889 "core/cfg.y"
                       { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 10487 "core/cfg.tab.c"
    break;

  case 694: /* attr_class_spec: ATTR_TOURI  */
#line 2890 "core/cfg.y"
                     { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 10493 "core/cfg.tab.c"
    break;

  case 695: /* attr_class_spec: ATTR_FROMUSER  */
#line 2891 "core/cfg.y"
                        { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 10499 "core/cfg.tab.c"
    break;

  case 696: /* attr_class_spec: ATTR_TOUSER  */
#line 2892 "core/cfg.y"
                      { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 10505 "core/cfg.tab.c"
    break;

  case 697: /* attr_class_spec: ATTR_FROMDOMAIN  */
#line 2893 "core/cfg.y"
                          { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 10511 "core/cfg.tab.c"
    break;

  case 698: /* attr_class_spec: ATTR_TODOMAIN  */
#line 2894 "core/cfg.y"
                        { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 10517 "core/cfg.tab.c"
    break;

  case 699: /* attr_class_spec: ATTR_GLOBAL  */
#line 2895 "core/cfg.y"
                      { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 10523 "core/cfg.tab.c"
    break;

  case 700: /* attr_name_spec: ID  */
#line 2898 "core/cfg.y"
           { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 10529 "core/cfg.tab.c"
    break;

  case 703: /* attr_mark: ATTR_MARK  */
#line 2905 "core/cfg.y"
                  {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else { memset(s_attr, 0, (sizeof(struct avp_spec))); }
	}
#line 10539 "core/cfg.tab.c"
    break;

  case 704: /* attr_id: attr_mark attr_spec  */
#line 2912 "core/cfg.y"
                            { (yyval.attr) = s_attr; }
#line 10545 "core/cfg.tab.c"
    break;

  case 705: /* attr_id_num_idx: attr_mark attr_spec LBRACK intno RBRACK  */
#line 2915 "core/cfg.y"
                                                {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 10555 "core/cfg.tab.c"
    break;

  case 706: /* attr_id_no_idx: attr_mark attr_spec LBRACK RBRACK  */
#line 2922 "core/cfg.y"
                                          {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 10564 "core/cfg.tab.c"
    break;

  case 713: /* attr_id_any_str: avp_pvar  */
#line 2944 "core/cfg.y"
                   {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 10581 "core/cfg.tab.c"
    break;

  case 714: /* attr_id_any_str: STRING  */
#line 2956 "core/cfg.y"
                 {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 10608 "core/cfg.tab.c"
    break;

  case 715: /* pvar: PVAR  */
#line 2980 "core/cfg.y"
             {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 10622 "core/cfg.tab.c"
    break;

  case 716: /* avp_pvar: AVP_OR_PVAR  */
#line 2991 "core/cfg.y"
                            {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 10648 "core/cfg.tab.c"
    break;

  case 717: /* assign_op: EQUAL  */
#line 3022 "core/cfg.y"
              { (yyval.intval) = ASSIGN_T; }
#line 10654 "core/cfg.tab.c"
    break;

  case 718: /* lval: attr_id_ass  */
#line 3026 "core/cfg.y"
                  {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 10669 "core/cfg.tab.c"
    break;

  case 719: /* lval: pvar  */
#line 3036 "core/cfg.y"
                      {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 10688 "core/cfg.tab.c"
    break;

  case 720: /* lval: avp_pvar  */
#line 3050 "core/cfg.y"
                      {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 10703 "core/cfg.tab.c"
    break;

  case 721: /* rval: intno  */
#line 3062 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_INT, (void*)(yyvsp[0].intval)); }
#line 10709 "core/cfg.tab.c"
    break;

  case 722: /* rval: STRING  */
#line 3063 "core/cfg.y"
                                        {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 10716 "core/cfg.tab.c"
    break;

  case 723: /* rval: attr_id_any  */
#line 3065 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 10722 "core/cfg.tab.c"
    break;

  case 724: /* rval: pvar  */
#line 3066 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 10728 "core/cfg.tab.c"
    break;

  case 725: /* rval: avp_pvar  */
#line 3067 "core/cfg.y"
                                        {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 10747 "core/cfg.tab.c"
    break;

  case 726: /* rval: select_id  */
#line 3081 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 10753 "core/cfg.tab.c"
    break;

  case 727: /* rval: fcmd  */
#line 3082 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 10759 "core/cfg.tab.c"
    break;

  case 728: /* rval: exp_elem  */
#line 3083 "core/cfg.y"
                   { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 10765 "core/cfg.tab.c"
    break;

  case 729: /* rval: LBRACE actions RBRACE  */
#line 3084 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10771 "core/cfg.tab.c"
    break;

  case 730: /* rval: LBRACE error RBRACE  */
#line 3085 "core/cfg.y"
                                { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 10777 "core/cfg.tab.c"
    break;

  case 731: /* rval: LPAREN assign_action RPAREN  */
#line 3086 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 10783 "core/cfg.tab.c"
    break;

  case 732: /* rval: LPAREN error RPAREN  */
#line 3087 "core/cfg.y"
                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10789 "core/cfg.tab.c"
    break;

  case 733: /* rve_un_op: NOT  */
#line 3091 "core/cfg.y"
                { (yyval.intval)=RVE_LNOT_OP; }
#line 10795 "core/cfg.tab.c"
    break;

  case 734: /* rve_un_op: BIN_NOT  */
#line 3092 "core/cfg.y"
                                { (yyval.intval)=RVE_BNOT_OP; }
#line 10801 "core/cfg.tab.c"
    break;

  case 735: /* rve_un_op: MINUS  */
#line 3093 "core/cfg.y"
                                        { (yyval.intval)=RVE_UMINUS_OP; }
#line 10807 "core/cfg.tab.c"
    break;

  case 736: /* rval_expr: rval  */
#line 3106 "core/cfg.y"
                                                        { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 10818 "core/cfg.tab.c"
    break;

  case 737: /* rval_expr: rve_un_op rval_expr  */
#line 3112 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 10824 "core/cfg.tab.c"
    break;

  case 738: /* rval_expr: INTCAST rval_expr  */
#line 3113 "core/cfg.y"
                                                                {(yyval.rv_expr)=mk_rve1(RVE_INT_OP, (yyvsp[0].rv_expr)); }
#line 10830 "core/cfg.tab.c"
    break;

  case 739: /* rval_expr: STRCAST rval_expr  */
#line 3114 "core/cfg.y"
                                                                {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 10836 "core/cfg.tab.c"
    break;

  case 740: /* rval_expr: rval_expr PLUS rval_expr  */
#line 3115 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10842 "core/cfg.tab.c"
    break;

  case 741: /* rval_expr: rval_expr MINUS rval_expr  */
#line 3116 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10848 "core/cfg.tab.c"
    break;

  case 742: /* rval_expr: rval_expr STAR rval_expr  */
#line 3117 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10854 "core/cfg.tab.c"
    break;

  case 743: /* rval_expr: rval_expr SLASH rval_expr  */
#line 3118 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10860 "core/cfg.tab.c"
    break;

  case 744: /* rval_expr: rval_expr MODULO rval_expr  */
#line 3119 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 10866 "core/cfg.tab.c"
    break;

  case 745: /* rval_expr: rval_expr BIN_OR rval_expr  */
#line 3120 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 10872 "core/cfg.tab.c"
    break;

  case 746: /* rval_expr: rval_expr BIN_AND rval_expr  */
#line 3121 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10878 "core/cfg.tab.c"
    break;

  case 747: /* rval_expr: rval_expr BIN_XOR rval_expr  */
#line 3122 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10884 "core/cfg.tab.c"
    break;

  case 748: /* rval_expr: rval_expr BIN_LSHIFT rval_expr  */
#line 3123 "core/cfg.y"
                                                 {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10890 "core/cfg.tab.c"
    break;

  case 749: /* rval_expr: rval_expr BIN_RSHIFT rval_expr  */
#line 3124 "core/cfg.y"
                                                 {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 10896 "core/cfg.tab.c"
    break;

  case 750: /* rval_expr: rval_expr rve_cmpop rval_expr  */
#line 3125 "core/cfg.y"
                                                         { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10902 "core/cfg.tab.c"
    break;

  case 751: /* rval_expr: rval_expr rve_equalop rval_expr  */
#line 3126 "core/cfg.y"
                                                                {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 10925 "core/cfg.tab.c"
    break;

  case 752: /* rval_expr: rval_expr LOG_AND rval_expr  */
#line 3144 "core/cfg.y"
                                                { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10931 "core/cfg.tab.c"
    break;

  case 753: /* rval_expr: rval_expr LOG_OR rval_expr  */
#line 3145 "core/cfg.y"
                                                { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 10937 "core/cfg.tab.c"
    break;

  case 754: /* rval_expr: LPAREN rval_expr RPAREN  */
#line 3146 "core/cfg.y"
                                                        { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 10943 "core/cfg.tab.c"
    break;

  case 755: /* rval_expr: STRLEN LPAREN rval_expr RPAREN  */
#line 3147 "core/cfg.y"
                                                 { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 10949 "core/cfg.tab.c"
    break;

  case 756: /* rval_expr: STREMPTY LPAREN rval_expr RPAREN  */
#line 3148 "core/cfg.y"
                                                   {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 10955 "core/cfg.tab.c"
    break;

  case 757: /* rval_expr: DEFINED rval_expr  */
#line 3149 "core/cfg.y"
                                                                { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 10961 "core/cfg.tab.c"
    break;

  case 758: /* rval_expr: SELVAL LPAREN rval_expr COMMA rval_expr COMMA rval_expr RPAREN  */
#line 3150 "core/cfg.y"
                                                                                 {
				rve_tmp=mk_rve2(RVE_SELVALOPT_OP, (yyvsp[-3].rv_expr), (yyvsp[-1].rv_expr));
				if(rve_tmp == NULL) {
					(yyval.rv_expr)=0;
					yyerror("faild to create tenary target expression");
				}
				(yyval.rv_expr)=mk_rve2(RVE_SELVALEXP_OP, (yyvsp[-5].rv_expr), rve_tmp);
		}
#line 10974 "core/cfg.tab.c"
    break;

  case 759: /* rval_expr: rve_un_op error  */
#line 3158 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10980 "core/cfg.tab.c"
    break;

  case 760: /* rval_expr: INTCAST error  */
#line 3159 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10986 "core/cfg.tab.c"
    break;

  case 761: /* rval_expr: STRCAST error  */
#line 3160 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10992 "core/cfg.tab.c"
    break;

  case 762: /* rval_expr: rval_expr PLUS error  */
#line 3161 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 10998 "core/cfg.tab.c"
    break;

  case 763: /* rval_expr: rval_expr MINUS error  */
#line 3162 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11004 "core/cfg.tab.c"
    break;

  case 764: /* rval_expr: rval_expr STAR error  */
#line 3163 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11010 "core/cfg.tab.c"
    break;

  case 765: /* rval_expr: rval_expr SLASH error  */
#line 3164 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11016 "core/cfg.tab.c"
    break;

  case 766: /* rval_expr: rval_expr MODULO error  */
#line 3165 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11022 "core/cfg.tab.c"
    break;

  case 767: /* rval_expr: rval_expr BIN_OR error  */
#line 3166 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11028 "core/cfg.tab.c"
    break;

  case 768: /* rval_expr: rval_expr BIN_AND error  */
#line 3167 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11034 "core/cfg.tab.c"
    break;

  case 769: /* rval_expr: rval_expr rve_cmpop error  */
#line 3169 "core/cfg.y"
                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11040 "core/cfg.tab.c"
    break;

  case 770: /* rval_expr: rval_expr rve_equalop error  */
#line 3171 "core/cfg.y"
                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11046 "core/cfg.tab.c"
    break;

  case 771: /* rval_expr: rval_expr LOG_AND error  */
#line 3172 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11052 "core/cfg.tab.c"
    break;

  case 772: /* rval_expr: rval_expr LOG_OR error  */
#line 3173 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11058 "core/cfg.tab.c"
    break;

  case 773: /* rval_expr: STRLEN LPAREN error RPAREN  */
#line 3174 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11064 "core/cfg.tab.c"
    break;

  case 774: /* rval_expr: STREMPTY LPAREN error RPAREN  */
#line 3175 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11070 "core/cfg.tab.c"
    break;

  case 775: /* rval_expr: SELVAL LPAREN error RPAREN  */
#line 3176 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11076 "core/cfg.tab.c"
    break;

  case 776: /* rval_expr: DEFINED error  */
#line 3177 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11082 "core/cfg.tab.c"
    break;

  case 777: /* assign_action: lval assign_op rval_expr  */
#line 3180 "core/cfg.y"
                                                { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 11091 "core/cfg.tab.c"
    break;

  case 778: /* avpflag_oper: SETAVPFLAG  */
#line 3198 "core/cfg.y"
                   { (yyval.intval) = 1; }
#line 11097 "core/cfg.tab.c"
    break;

  case 779: /* avpflag_oper: RESETAVPFLAG  */
#line 3199 "core/cfg.y"
                       { (yyval.intval) = 0; }
#line 11103 "core/cfg.tab.c"
    break;

  case 780: /* avpflag_oper: ISAVPFLAGSET  */
#line 3200 "core/cfg.y"
                       { (yyval.intval) = -1; }
#line 11109 "core/cfg.tab.c"
    break;

  case 781: /* cmd: FORWARD LPAREN RPAREN  */
#line 3203 "core/cfg.y"
                              { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11115 "core/cfg.tab.c"
    break;

  case 782: /* cmd: FORWARD LPAREN host RPAREN  */
#line 3204 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11121 "core/cfg.tab.c"
    break;

  case 783: /* cmd: FORWARD LPAREN STRING RPAREN  */
#line 3205 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11127 "core/cfg.tab.c"
    break;

  case 784: /* cmd: FORWARD LPAREN ip RPAREN  */
#line 3206 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11133 "core/cfg.tab.c"
    break;

  case 785: /* cmd: FORWARD LPAREN host COMMA NUMBER RPAREN  */
#line 3207 "core/cfg.y"
                                                  { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11139 "core/cfg.tab.c"
    break;

  case 786: /* cmd: FORWARD LPAREN STRING COMMA NUMBER RPAREN  */
#line 3208 "core/cfg.y"
                                                    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11145 "core/cfg.tab.c"
    break;

  case 787: /* cmd: FORWARD LPAREN ip COMMA NUMBER RPAREN  */
#line 3209 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11151 "core/cfg.tab.c"
    break;

  case 788: /* cmd: FORWARD LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3210 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11157 "core/cfg.tab.c"
    break;

  case 789: /* cmd: FORWARD LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3211 "core/cfg.y"
                                                     {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11163 "core/cfg.tab.c"
    break;

  case 790: /* cmd: FORWARD LPAREN URIHOST RPAREN  */
#line 3212 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11169 "core/cfg.tab.c"
    break;

  case 791: /* cmd: FORWARD error  */
#line 3213 "core/cfg.y"
                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11175 "core/cfg.tab.c"
    break;

  case 792: /* cmd: FORWARD LPAREN error RPAREN  */
#line 3214 "core/cfg.y"
                                      { (yyval.action)=0; yyerror("bad forward argument"); }
#line 11181 "core/cfg.tab.c"
    break;

  case 793: /* cmd: FORWARD_UDP LPAREN host RPAREN  */
#line 3215 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11187 "core/cfg.tab.c"
    break;

  case 794: /* cmd: FORWARD_UDP LPAREN STRING RPAREN  */
#line 3216 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11193 "core/cfg.tab.c"
    break;

  case 795: /* cmd: FORWARD_UDP LPAREN ip RPAREN  */
#line 3217 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11199 "core/cfg.tab.c"
    break;

  case 796: /* cmd: FORWARD_UDP LPAREN host COMMA NUMBER RPAREN  */
#line 3218 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11205 "core/cfg.tab.c"
    break;

  case 797: /* cmd: FORWARD_UDP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3219 "core/cfg.y"
                                                        {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11211 "core/cfg.tab.c"
    break;

  case 798: /* cmd: FORWARD_UDP LPAREN ip COMMA NUMBER RPAREN  */
#line 3220 "core/cfg.y"
                                                    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11217 "core/cfg.tab.c"
    break;

  case 799: /* cmd: FORWARD_UDP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3221 "core/cfg.y"
                                                          {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11223 "core/cfg.tab.c"
    break;

  case 800: /* cmd: FORWARD_UDP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3222 "core/cfg.y"
                                                         { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11229 "core/cfg.tab.c"
    break;

  case 801: /* cmd: FORWARD_UDP LPAREN URIHOST RPAREN  */
#line 3223 "core/cfg.y"
                                            { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11235 "core/cfg.tab.c"
    break;

  case 802: /* cmd: FORWARD_UDP error  */
#line 3224 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11241 "core/cfg.tab.c"
    break;

  case 803: /* cmd: FORWARD_UDP LPAREN error RPAREN  */
#line 3225 "core/cfg.y"
                                          { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 11247 "core/cfg.tab.c"
    break;

  case 804: /* cmd: FORWARD_TCP LPAREN host RPAREN  */
#line 3226 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11253 "core/cfg.tab.c"
    break;

  case 805: /* cmd: FORWARD_TCP LPAREN STRING RPAREN  */
#line 3227 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11259 "core/cfg.tab.c"
    break;

  case 806: /* cmd: FORWARD_TCP LPAREN ip RPAREN  */
#line 3228 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11265 "core/cfg.tab.c"
    break;

  case 807: /* cmd: FORWARD_TCP LPAREN host COMMA NUMBER RPAREN  */
#line 3229 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11271 "core/cfg.tab.c"
    break;

  case 808: /* cmd: FORWARD_TCP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3230 "core/cfg.y"
                                                        {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11277 "core/cfg.tab.c"
    break;

  case 809: /* cmd: FORWARD_TCP LPAREN ip COMMA NUMBER RPAREN  */
#line 3231 "core/cfg.y"
                                                    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11283 "core/cfg.tab.c"
    break;

  case 810: /* cmd: FORWARD_TCP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3232 "core/cfg.y"
                                                          {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11289 "core/cfg.tab.c"
    break;

  case 811: /* cmd: FORWARD_TCP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3233 "core/cfg.y"
                                                         { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11295 "core/cfg.tab.c"
    break;

  case 812: /* cmd: FORWARD_TCP LPAREN URIHOST RPAREN  */
#line 3234 "core/cfg.y"
                                            { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11301 "core/cfg.tab.c"
    break;

  case 813: /* cmd: FORWARD_TCP error  */
#line 3235 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11307 "core/cfg.tab.c"
    break;

  case 814: /* cmd: FORWARD_TCP LPAREN error RPAREN  */
#line 3236 "core/cfg.y"
                                          { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 11313 "core/cfg.tab.c"
    break;

  case 815: /* cmd: FORWARD_TLS LPAREN host RPAREN  */
#line 3237 "core/cfg.y"
                                         {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11326 "core/cfg.tab.c"
    break;

  case 816: /* cmd: FORWARD_TLS LPAREN STRING RPAREN  */
#line 3245 "core/cfg.y"
                                           {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11339 "core/cfg.tab.c"
    break;

  case 817: /* cmd: FORWARD_TLS LPAREN ip RPAREN  */
#line 3253 "core/cfg.y"
                                        {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11352 "core/cfg.tab.c"
    break;

  case 818: /* cmd: FORWARD_TLS LPAREN host COMMA NUMBER RPAREN  */
#line 3261 "core/cfg.y"
                                                      {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11365 "core/cfg.tab.c"
    break;

  case 819: /* cmd: FORWARD_TLS LPAREN STRING COMMA NUMBER RPAREN  */
#line 3269 "core/cfg.y"
                                                        {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11378 "core/cfg.tab.c"
    break;

  case 820: /* cmd: FORWARD_TLS LPAREN ip COMMA NUMBER RPAREN  */
#line 3277 "core/cfg.y"
                                                    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 11391 "core/cfg.tab.c"
    break;

  case 821: /* cmd: FORWARD_TLS LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3285 "core/cfg.y"
                                                          {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11404 "core/cfg.tab.c"
    break;

  case 822: /* cmd: FORWARD_TLS LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3293 "core/cfg.y"
                                                         {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11417 "core/cfg.tab.c"
    break;

  case 823: /* cmd: FORWARD_TLS LPAREN URIHOST RPAREN  */
#line 3301 "core/cfg.y"
                                            {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11430 "core/cfg.tab.c"
    break;

  case 824: /* cmd: FORWARD_TLS error  */
#line 3309 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11436 "core/cfg.tab.c"
    break;

  case 825: /* cmd: FORWARD_TLS LPAREN error RPAREN  */
#line 3310 "core/cfg.y"
                                          { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 11443 "core/cfg.tab.c"
    break;

  case 826: /* cmd: FORWARD_SCTP LPAREN host RPAREN  */
#line 3312 "core/cfg.y"
                                          {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11456 "core/cfg.tab.c"
    break;

  case 827: /* cmd: FORWARD_SCTP LPAREN STRING RPAREN  */
#line 3320 "core/cfg.y"
                                            {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11469 "core/cfg.tab.c"
    break;

  case 828: /* cmd: FORWARD_SCTP LPAREN ip RPAREN  */
#line 3328 "core/cfg.y"
                                        {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11482 "core/cfg.tab.c"
    break;

  case 829: /* cmd: FORWARD_SCTP LPAREN host COMMA NUMBER RPAREN  */
#line 3336 "core/cfg.y"
                                                       {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11496 "core/cfg.tab.c"
    break;

  case 830: /* cmd: FORWARD_SCTP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3345 "core/cfg.y"
                                                         {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11510 "core/cfg.tab.c"
    break;

  case 831: /* cmd: FORWARD_SCTP LPAREN ip COMMA NUMBER RPAREN  */
#line 3354 "core/cfg.y"
                                                     {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 11524 "core/cfg.tab.c"
    break;

  case 832: /* cmd: FORWARD_SCTP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3363 "core/cfg.y"
                                                           {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11537 "core/cfg.tab.c"
    break;

  case 833: /* cmd: FORWARD_SCTP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3371 "core/cfg.y"
                                                          {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 11551 "core/cfg.tab.c"
    break;

  case 834: /* cmd: FORWARD_SCTP LPAREN URIHOST RPAREN  */
#line 3380 "core/cfg.y"
                                             {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11564 "core/cfg.tab.c"
    break;

  case 835: /* cmd: FORWARD_SCTP error  */
#line 3388 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11570 "core/cfg.tab.c"
    break;

  case 836: /* cmd: FORWARD_SCTP LPAREN error RPAREN  */
#line 3389 "core/cfg.y"
                                           { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 11577 "core/cfg.tab.c"
    break;

  case 837: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 3391 "core/cfg.y"
                                        {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 11585 "core/cfg.tab.c"
    break;

  case 838: /* cmd: LOG_TOK LPAREN NUMBER COMMA STRING RPAREN  */
#line 3394 "core/cfg.y"
                                                        {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11591 "core/cfg.tab.c"
    break;

  case 839: /* cmd: LOG_TOK error  */
#line 3395 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11597 "core/cfg.tab.c"
    break;

  case 840: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 3396 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("bad log argument"); }
#line 11603 "core/cfg.tab.c"
    break;

  case 841: /* cmd: SETFLAG LPAREN NUMBER RPAREN  */
#line 3397 "core/cfg.y"
                                        {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11615 "core/cfg.tab.c"
    break;

  case 842: /* cmd: SETFLAG LPAREN flag_name RPAREN  */
#line 3404 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11627 "core/cfg.tab.c"
    break;

  case 843: /* cmd: SETFLAG error  */
#line 3411 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11633 "core/cfg.tab.c"
    break;

  case 844: /* cmd: RESETFLAG LPAREN NUMBER RPAREN  */
#line 3412 "core/cfg.y"
                                         {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11644 "core/cfg.tab.c"
    break;

  case 845: /* cmd: RESETFLAG LPAREN flag_name RPAREN  */
#line 3418 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11656 "core/cfg.tab.c"
    break;

  case 846: /* cmd: RESETFLAG error  */
#line 3425 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11662 "core/cfg.tab.c"
    break;

  case 847: /* cmd: ISFLAGSET LPAREN NUMBER RPAREN  */
#line 3426 "core/cfg.y"
                                         {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 11673 "core/cfg.tab.c"
    break;

  case 848: /* cmd: ISFLAGSET LPAREN flag_name RPAREN  */
#line 3432 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 11685 "core/cfg.tab.c"
    break;

  case 849: /* cmd: ISFLAGSET error  */
#line 3439 "core/cfg.y"
                          { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11691 "core/cfg.tab.c"
    break;

  case 850: /* cmd: avpflag_oper LPAREN attr_id_any_str COMMA flag_name RPAREN  */
#line 3440 "core/cfg.y"
                                                                     {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 11702 "core/cfg.tab.c"
    break;

  case 851: /* cmd: avpflag_oper LPAREN attr_id_any_str COMMA error RPAREN  */
#line 3446 "core/cfg.y"
                                                                 {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 11710 "core/cfg.tab.c"
    break;

  case 852: /* cmd: avpflag_oper LPAREN error COMMA flag_name RPAREN  */
#line 3449 "core/cfg.y"
                                                           {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 11718 "core/cfg.tab.c"
    break;

  case 853: /* cmd: avpflag_oper LPAREN error RPAREN  */
#line 3452 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad parameters"); }
#line 11724 "core/cfg.tab.c"
    break;

  case 854: /* cmd: avpflag_oper error  */
#line 3453 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 11730 "core/cfg.tab.c"
    break;

  case 855: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 3454 "core/cfg.y"
                                                  {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 11738 "core/cfg.tab.c"
    break;

  case 856: /* cmd: ERROR error  */
#line 3457 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11744 "core/cfg.tab.c"
    break;

  case 857: /* cmd: ERROR LPAREN error RPAREN  */
#line 3458 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad error argument"); }
#line 11750 "core/cfg.tab.c"
    break;

  case 858: /* cmd: ROUTE LPAREN rval_expr RPAREN  */
#line 3459 "core/cfg.y"
                                        {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11764 "core/cfg.tab.c"
    break;

  case 859: /* cmd: ROUTE LPAREN ID RPAREN  */
#line 3468 "core/cfg.y"
                                        {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 11778 "core/cfg.tab.c"
    break;

  case 860: /* cmd: ROUTE error  */
#line 3477 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11784 "core/cfg.tab.c"
    break;

  case 861: /* cmd: ROUTE LPAREN error RPAREN  */
#line 3478 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad route argument"); }
#line 11790 "core/cfg.tab.c"
    break;

  case 862: /* cmd: EXEC LPAREN STRING RPAREN  */
#line 3479 "core/cfg.y"
                                        { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11796 "core/cfg.tab.c"
    break;

  case 863: /* cmd: SET_HOST LPAREN STRING RPAREN  */
#line 3480 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11802 "core/cfg.tab.c"
    break;

  case 864: /* cmd: SET_HOST error  */
#line 3481 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11808 "core/cfg.tab.c"
    break;

  case 865: /* cmd: SET_HOST LPAREN error RPAREN  */
#line 3482 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11814 "core/cfg.tab.c"
    break;

  case 866: /* cmd: PREFIX LPAREN STRING RPAREN  */
#line 3483 "core/cfg.y"
                                      { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11820 "core/cfg.tab.c"
    break;

  case 867: /* cmd: PREFIX error  */
#line 3484 "core/cfg.y"
                       { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11826 "core/cfg.tab.c"
    break;

  case 868: /* cmd: PREFIX LPAREN error RPAREN  */
#line 3485 "core/cfg.y"
                                     { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11832 "core/cfg.tab.c"
    break;

  case 869: /* cmd: STRIP_TAIL LPAREN NUMBER RPAREN  */
#line 3486 "core/cfg.y"
                                          { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11838 "core/cfg.tab.c"
    break;

  case 870: /* cmd: STRIP_TAIL error  */
#line 3487 "core/cfg.y"
                           { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11844 "core/cfg.tab.c"
    break;

  case 871: /* cmd: STRIP_TAIL LPAREN error RPAREN  */
#line 3488 "core/cfg.y"
                                         { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11850 "core/cfg.tab.c"
    break;

  case 872: /* cmd: STRIP LPAREN NUMBER RPAREN  */
#line 3489 "core/cfg.y"
                                     { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11856 "core/cfg.tab.c"
    break;

  case 873: /* cmd: STRIP error  */
#line 3490 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11862 "core/cfg.tab.c"
    break;

  case 874: /* cmd: STRIP LPAREN error RPAREN  */
#line 3491 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11868 "core/cfg.tab.c"
    break;

  case 875: /* cmd: SET_USERPHONE LPAREN RPAREN  */
#line 3492 "core/cfg.y"
                                      { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 11874 "core/cfg.tab.c"
    break;

  case 876: /* cmd: SET_USERPHONE error  */
#line 3493 "core/cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11880 "core/cfg.tab.c"
    break;

  case 877: /* cmd: REMOVE_BRANCH LPAREN intno RPAREN  */
#line 3494 "core/cfg.y"
                                            {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 11889 "core/cfg.tab.c"
    break;

  case 878: /* cmd: REMOVE_BRANCH LPAREN RPAREN  */
#line 3498 "core/cfg.y"
                                      {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 11898 "core/cfg.tab.c"
    break;

  case 879: /* cmd: REMOVE_BRANCH error  */
#line 3502 "core/cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11904 "core/cfg.tab.c"
    break;

  case 880: /* cmd: REMOVE_BRANCH LPAREN error RPAREN  */
#line 3503 "core/cfg.y"
                                            { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 11910 "core/cfg.tab.c"
    break;

  case 881: /* cmd: CLEAR_BRANCHES LPAREN RPAREN  */
#line 3504 "core/cfg.y"
                                       { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 11916 "core/cfg.tab.c"
    break;

  case 882: /* cmd: SET_HOSTPORT LPAREN STRING RPAREN  */
#line 3505 "core/cfg.y"
                                            { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11922 "core/cfg.tab.c"
    break;

  case 883: /* cmd: SET_HOSTPORT error  */
#line 3506 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11928 "core/cfg.tab.c"
    break;

  case 884: /* cmd: SET_HOSTPORT LPAREN error RPAREN  */
#line 3507 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11934 "core/cfg.tab.c"
    break;

  case 885: /* cmd: SET_HOSTPORTTRANS LPAREN STRING RPAREN  */
#line 3508 "core/cfg.y"
                                                 { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11940 "core/cfg.tab.c"
    break;

  case 886: /* cmd: SET_HOSTPORTTRANS error  */
#line 3509 "core/cfg.y"
                                  { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11946 "core/cfg.tab.c"
    break;

  case 887: /* cmd: SET_HOSTPORTTRANS LPAREN error RPAREN  */
#line 3510 "core/cfg.y"
                                                { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11952 "core/cfg.tab.c"
    break;

  case 888: /* cmd: SET_PORT LPAREN STRING RPAREN  */
#line 3511 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11958 "core/cfg.tab.c"
    break;

  case 889: /* cmd: SET_PORT error  */
#line 3512 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11964 "core/cfg.tab.c"
    break;

  case 890: /* cmd: SET_PORT LPAREN error RPAREN  */
#line 3513 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11970 "core/cfg.tab.c"
    break;

  case 891: /* cmd: SET_USER LPAREN STRING RPAREN  */
#line 3514 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11976 "core/cfg.tab.c"
    break;

  case 892: /* cmd: SET_USER error  */
#line 3515 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11982 "core/cfg.tab.c"
    break;

  case 893: /* cmd: SET_USER LPAREN error RPAREN  */
#line 3516 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 11988 "core/cfg.tab.c"
    break;

  case 894: /* cmd: SET_USERPASS LPAREN STRING RPAREN  */
#line 3517 "core/cfg.y"
                                            { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 11994 "core/cfg.tab.c"
    break;

  case 895: /* cmd: SET_USERPASS error  */
#line 3518 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12000 "core/cfg.tab.c"
    break;

  case 896: /* cmd: SET_USERPASS LPAREN error RPAREN  */
#line 3519 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12006 "core/cfg.tab.c"
    break;

  case 897: /* cmd: SET_URI LPAREN STRING RPAREN  */
#line 3520 "core/cfg.y"
                                       { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12012 "core/cfg.tab.c"
    break;

  case 898: /* cmd: SET_URI error  */
#line 3521 "core/cfg.y"
                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12018 "core/cfg.tab.c"
    break;

  case 899: /* cmd: SET_URI LPAREN error RPAREN  */
#line 3522 "core/cfg.y"
                                      { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12024 "core/cfg.tab.c"
    break;

  case 900: /* cmd: REVERT_URI LPAREN RPAREN  */
#line 3523 "core/cfg.y"
                                   { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12030 "core/cfg.tab.c"
    break;

  case 901: /* cmd: REVERT_URI  */
#line 3524 "core/cfg.y"
                     { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12036 "core/cfg.tab.c"
    break;

  case 902: /* cmd: FORCE_RPORT LPAREN RPAREN  */
#line 3525 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12042 "core/cfg.tab.c"
    break;

  case 903: /* cmd: FORCE_RPORT  */
#line 3526 "core/cfg.y"
                        {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12048 "core/cfg.tab.c"
    break;

  case 904: /* cmd: ADD_LOCAL_RPORT LPAREN RPAREN  */
#line 3527 "core/cfg.y"
                                        { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12054 "core/cfg.tab.c"
    break;

  case 905: /* cmd: ADD_LOCAL_RPORT  */
#line 3528 "core/cfg.y"
                                {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12060 "core/cfg.tab.c"
    break;

  case 906: /* cmd: FORCE_TCP_ALIAS LPAREN NUMBER RPAREN  */
#line 3529 "core/cfg.y"
                                                {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12073 "core/cfg.tab.c"
    break;

  case 907: /* cmd: FORCE_TCP_ALIAS LPAREN RPAREN  */
#line 3537 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12086 "core/cfg.tab.c"
    break;

  case 908: /* cmd: FORCE_TCP_ALIAS  */
#line 3545 "core/cfg.y"
                                                        {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12099 "core/cfg.tab.c"
    break;

  case 909: /* cmd: FORCE_TCP_ALIAS LPAREN error RPAREN  */
#line 3553 "core/cfg.y"
                                                {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12105 "core/cfg.tab.c"
    break;

  case 910: /* cmd: UDP_MTU_TRY_PROTO LPAREN proto RPAREN  */
#line 3555 "core/cfg.y"
                { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12111 "core/cfg.tab.c"
    break;

  case 911: /* cmd: UDP_MTU_TRY_PROTO LPAREN error RPAREN  */
#line 3557 "core/cfg.y"
                { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 12117 "core/cfg.tab.c"
    break;

  case 912: /* cmd: SET_ADV_ADDRESS LPAREN listen_id RPAREN  */
#line 3558 "core/cfg.y"
                                                  {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 12133 "core/cfg.tab.c"
    break;

  case 913: /* cmd: SET_ADV_ADDRESS LPAREN error RPAREN  */
#line 3569 "core/cfg.y"
                                              { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12139 "core/cfg.tab.c"
    break;

  case 914: /* cmd: SET_ADV_ADDRESS error  */
#line 3570 "core/cfg.y"
                                {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12145 "core/cfg.tab.c"
    break;

  case 915: /* cmd: SET_ADV_PORT LPAREN NUMBER RPAREN  */
#line 3571 "core/cfg.y"
                                            {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 12166 "core/cfg.tab.c"
    break;

  case 916: /* cmd: SET_ADV_PORT LPAREN error RPAREN  */
#line 3587 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12172 "core/cfg.tab.c"
    break;

  case 917: /* cmd: SET_ADV_PORT error  */
#line 3588 "core/cfg.y"
                              {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12178 "core/cfg.tab.c"
    break;

  case 918: /* cmd: FORCE_SEND_SOCKET LPAREN phostport RPAREN  */
#line 3589 "core/cfg.y"
                                                    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 12187 "core/cfg.tab.c"
    break;

  case 919: /* cmd: FORCE_SEND_SOCKET LPAREN error RPAREN  */
#line 3593 "core/cfg.y"
                                                {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 12195 "core/cfg.tab.c"
    break;

  case 920: /* cmd: FORCE_SEND_SOCKET error  */
#line 3596 "core/cfg.y"
                                  {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12201 "core/cfg.tab.c"
    break;

  case 921: /* cmd: SET_FWD_NO_CONNECT LPAREN RPAREN  */
#line 3597 "core/cfg.y"
                                                {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12209 "core/cfg.tab.c"
    break;

  case 922: /* cmd: SET_FWD_NO_CONNECT  */
#line 3600 "core/cfg.y"
                                {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12217 "core/cfg.tab.c"
    break;

  case 923: /* cmd: SET_RPL_NO_CONNECT LPAREN RPAREN  */
#line 3603 "core/cfg.y"
                                                {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12225 "core/cfg.tab.c"
    break;

  case 924: /* cmd: SET_RPL_NO_CONNECT  */
#line 3606 "core/cfg.y"
                                {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12233 "core/cfg.tab.c"
    break;

  case 925: /* cmd: SET_FWD_CLOSE LPAREN RPAREN  */
#line 3609 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12241 "core/cfg.tab.c"
    break;

  case 926: /* cmd: SET_FWD_CLOSE  */
#line 3612 "core/cfg.y"
                        {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12249 "core/cfg.tab.c"
    break;

  case 927: /* cmd: SET_RPL_CLOSE LPAREN RPAREN  */
#line 3615 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12257 "core/cfg.tab.c"
    break;

  case 928: /* cmd: SET_RPL_CLOSE  */
#line 3618 "core/cfg.y"
                        {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12265 "core/cfg.tab.c"
    break;

  case 929: /* cmd: CFG_SELECT LPAREN STRING COMMA NUMBER RPAREN  */
#line 3621 "core/cfg.y"
                                                       {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 12273 "core/cfg.tab.c"
    break;

  case 930: /* cmd: CFG_SELECT LPAREN STRING COMMA rval_expr RPAREN  */
#line 3624 "core/cfg.y"
                                                          {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 12281 "core/cfg.tab.c"
    break;

  case 931: /* cmd: CFG_SELECT error  */
#line 3627 "core/cfg.y"
                           { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12287 "core/cfg.tab.c"
    break;

  case 932: /* cmd: CFG_SELECT LPAREN error RPAREN  */
#line 3628 "core/cfg.y"
                                         { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 12293 "core/cfg.tab.c"
    break;

  case 933: /* cmd: CFG_RESET LPAREN STRING RPAREN  */
#line 3629 "core/cfg.y"
                                         {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 12301 "core/cfg.tab.c"
    break;

  case 934: /* cmd: CFG_RESET error  */
#line 3632 "core/cfg.y"
                          { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12307 "core/cfg.tab.c"
    break;

  case 935: /* cmd: CFG_RESET LPAREN error RPAREN  */
#line 3633 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 12313 "core/cfg.tab.c"
    break;

  case 936: /* $@9: %empty  */
#line 3634 "core/cfg.y"
             {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			ksr_exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 12326 "core/cfg.tab.c"
    break;

  case 937: /* cmd: ID $@9 LPAREN func_params RPAREN  */
#line 3641 "core/cfg.y"
                                                {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				/* free_mod_func_action(mod_func_action); */
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 12357 "core/cfg.tab.c"
    break;

  case 938: /* cmd: ID error  */
#line 3667 "core/cfg.y"
                                                        { yyerror("'('')' expected (function call)");}
#line 12363 "core/cfg.tab.c"
    break;

  case 940: /* func_params: func_params COMMA func_param  */
#line 3671 "core/cfg.y"
                                       { }
#line 12369 "core/cfg.tab.c"
    break;

  case 941: /* func_params: func_param  */
#line 3672 "core/cfg.y"
                     {}
#line 12375 "core/cfg.tab.c"
    break;

  case 942: /* func_param: rval_expr  */
#line 3675 "core/cfg.y"
                  {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 12394 "core/cfg.tab.c"
    break;

  case 943: /* ret_cmd: DROP LPAREN RPAREN  */
#line 3692 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12403 "core/cfg.tab.c"
    break;

  case 944: /* ret_cmd: DROP rval_expr  */
#line 3696 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12412 "core/cfg.tab.c"
    break;

  case 945: /* ret_cmd: DROP  */
#line 3700 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12421 "core/cfg.tab.c"
    break;

  case 946: /* ret_cmd: EXIT LPAREN RPAREN  */
#line 3704 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12431 "core/cfg.tab.c"
    break;

  case 947: /* ret_cmd: EXIT rval_expr  */
#line 3709 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12440 "core/cfg.tab.c"
    break;

  case 948: /* ret_cmd: EXIT  */
#line 3713 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12450 "core/cfg.tab.c"
    break;

  case 949: /* ret_cmd: RETURN  */
#line 3718 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 12459 "core/cfg.tab.c"
    break;

  case 950: /* ret_cmd: RETURN LPAREN RPAREN  */
#line 3722 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 12468 "core/cfg.tab.c"
    break;

  case 951: /* ret_cmd: RETURN rval_expr  */
#line 3726 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12477 "core/cfg.tab.c"
    break;

  case 952: /* ret_cmd: BREAK  */
#line 3730 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 12486 "core/cfg.tab.c"
    break;


#line 12490 "core/cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 3736 "core/cfg.y"


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_INT && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct name_lst));
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no coresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
